# =================================================================================================
#<profile4xi profile = "12" />
#<program4xi program = "kernel4xi.py">
#<abstract4xi abstract = "kernel management"/>
#<refer4xi reference = "Kernels"/>
#<verify4xi verification = "10" target = "kernel4xi5test.py">
#<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; ACK4moduletesting; [Rel 7.21]"/>
# =================================================================================================

# -------------------------------------------------------------------------------------------------
# Public API                
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'Kernel4Xi',                          # NACK 5.7.1  p157    

            'add2kernel4xi',                      # NACK               

            'execute2kernel4xi',                  # NACK 5.8    p169                                             
            'execute2task4xi',                    # NACK 5.8    p172   
            'execute2nativekernel4xi',            # NACK 5.8    p174     
            
            'create2kernel4xi',                   # ACK 5.7.1  p157   
            'create2kernelsinprogram4xi',         # NACK 5.7.1  p158  
                       
            'delete2kernel4xi',                   # NACK

            'get2kernelinfo4xi',                  # ACK 5.7.3  p162  
            'get2kernelworkgroupinfo4xi',         # NACK 5.7.3  p164  
            'get2kernelarginfo4xi',               # NACK 5.7.3  p166                                  
            
            'release2kernel4xi',                  # NACK 5.7.1  p159                                         
            'retain2kernel4xi',                   # NACK 5.7.1  p159   
 
            'set2kernel4xi',                      # NACK 
            'set2kernelcallback4xi',              # NACK 
            'set2kernelarg4xi',                   # NACK 5.7.2  p160 
                                          
            'trace2kernel4xi'                     # NACK 

          ] 
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
from platform import processor
import sys
import threading                
import _thread   
from decimal import *
#"
#/>


# -------------------------------------------------------------------------------------------------
# Scope4Xi imports                               
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
import version4xi


# -------------------------------------------------------------------------------------------------
# Image modules of devices                           
# -------------------------------------------------------------------------------------------------
from apu2kernel4xi import APU2Kernel4Xi                                                             
from bpu2kernel4xi import BPU2Kernel4Xi
from cpu2kernel4xi import CPU2Kernel4Xi
from dpu2kernel4xi import DPU2Kernel4Xi
from epu2kernel4xi import EPU2Kernel4Xi
from fpu2kernel4xi import FPU2Kernel4Xi
from gpu2kernel4xi import GPU2Kernel4Xi
from hpu2kernel4xi import HPU2Kernel4Xi
from ipu2kernel4xi import IPU2Kernel4Xi
from jpu2kernel4xi import JPU2Kernel4Xi
from kpu2kernel4xi import KPU2Kernel4Xi
from lpu2kernel4xi import LPU2Kernel4Xi
from mpu2kernel4xi import MPU2Kernel4Xi
from npu2kernel4xi import NPU2Kernel4Xi
from opu2kernel4xi import OPU2Kernel4Xi
from ppu2kernel4xi import PPU2Kernel4Xi
from qpu2kernel4xi import QPU2Kernel4Xi
from rpu2kernel4xi import RPU2Kernel4Xi
from spu2kernel4xi import SPU2Kernel4Xi
from tpu2kernel4xi import TPU2Kernel4Xi
from upu2kernel4xi import UPU2Kernel4Xi
from vpu2kernel4xi import VPU2Kernel4Xi
from xpu2kernel4xi import XPU2Kernel4Xi
from wpu2kernel4xi import WPU2Kernel4Xi
from ypu2kernel4xi import YPU2Kernel4Xi
from zpu2kernel4xi import ZPU2Kernel4Xi

from apu2kernel4xi import add2kernel4apu                                                            
from bpu2kernel4xi import add2kernel4bpu
from cpu2kernel4xi import add2kernel4cpu
from dpu2kernel4xi import add2kernel4dpu
from epu2kernel4xi import add2kernel4epu
from fpu2kernel4xi import add2kernel4fpu
from gpu2kernel4xi import add2kernel4gpu
from hpu2kernel4xi import add2kernel4hpu
from ipu2kernel4xi import add2kernel4ipu
from jpu2kernel4xi import add2kernel4jpu
from kpu2kernel4xi import add2kernel4kpu
from lpu2kernel4xi import add2kernel4lpu
from mpu2kernel4xi import add2kernel4mpu
from npu2kernel4xi import add2kernel4npu
from opu2kernel4xi import add2kernel4opu
from ppu2kernel4xi import add2kernel4ppu
from qpu2kernel4xi import add2kernel4qpu
from rpu2kernel4xi import add2kernel4rpu
from spu2kernel4xi import add2kernel4spu
from tpu2kernel4xi import add2kernel4tpu
from upu2kernel4xi import add2kernel4upu
from vpu2kernel4xi import add2kernel4vpu
from xpu2kernel4xi import add2kernel4xpu
from wpu2kernel4xi import add2kernel4wpu
from ypu2kernel4xi import add2kernel4ypu
from zpu2kernel4xi import add2kernel4zpu


from apu2kernel4xi import create2kernel4apu                                                            
from bpu2kernel4xi import create2kernel4bpu
from cpu2kernel4xi import create2kernel4cpu
from dpu2kernel4xi import create2kernel4dpu
from epu2kernel4xi import create2kernel4epu
from fpu2kernel4xi import create2kernel4fpu
from gpu2kernel4xi import create2kernel4gpu
from hpu2kernel4xi import create2kernel4hpu
from ipu2kernel4xi import create2kernel4ipu
from jpu2kernel4xi import create2kernel4jpu
from kpu2kernel4xi import create2kernel4kpu
from lpu2kernel4xi import create2kernel4lpu
from mpu2kernel4xi import create2kernel4mpu
from npu2kernel4xi import create2kernel4npu
from opu2kernel4xi import create2kernel4opu
from ppu2kernel4xi import create2kernel4ppu
from qpu2kernel4xi import create2kernel4qpu
from rpu2kernel4xi import create2kernel4rpu
from spu2kernel4xi import create2kernel4spu
from tpu2kernel4xi import create2kernel4tpu
from upu2kernel4xi import create2kernel4upu
from vpu2kernel4xi import create2kernel4vpu
from xpu2kernel4xi import create2kernel4xpu
from wpu2kernel4xi import create2kernel4wpu
from ypu2kernel4xi import create2kernel4ypu
from zpu2kernel4xi import create2kernel4zpu

from apu2kernel4xi import delete2kernel4apu                                                            
from bpu2kernel4xi import delete2kernel4bpu
from cpu2kernel4xi import delete2kernel4cpu
from dpu2kernel4xi import delete2kernel4dpu
from epu2kernel4xi import delete2kernel4epu
from fpu2kernel4xi import delete2kernel4fpu
from gpu2kernel4xi import delete2kernel4gpu
from hpu2kernel4xi import delete2kernel4hpu
from ipu2kernel4xi import delete2kernel4ipu
from jpu2kernel4xi import delete2kernel4jpu
from kpu2kernel4xi import delete2kernel4kpu
from lpu2kernel4xi import delete2kernel4lpu
from mpu2kernel4xi import delete2kernel4mpu
from npu2kernel4xi import delete2kernel4npu
from opu2kernel4xi import delete2kernel4opu
from ppu2kernel4xi import delete2kernel4ppu
from qpu2kernel4xi import delete2kernel4qpu
from rpu2kernel4xi import delete2kernel4rpu
from spu2kernel4xi import delete2kernel4spu
from tpu2kernel4xi import delete2kernel4tpu
from upu2kernel4xi import delete2kernel4upu
from vpu2kernel4xi import delete2kernel4vpu
from xpu2kernel4xi import delete2kernel4xpu
from wpu2kernel4xi import delete2kernel4wpu
from ypu2kernel4xi import delete2kernel4ypu
from zpu2kernel4xi import delete2kernel4zpu

from apu2kernel4xi import get2kernelinfo4apu                                                            
from bpu2kernel4xi import get2kernelinfo4bpu
from cpu2kernel4xi import get2kernelinfo4cpu
from dpu2kernel4xi import get2kernelinfo4dpu
from epu2kernel4xi import get2kernelinfo4epu
from fpu2kernel4xi import get2kernelinfo4fpu
from gpu2kernel4xi import get2kernelinfo4gpu
from hpu2kernel4xi import get2kernelinfo4hpu
from ipu2kernel4xi import get2kernelinfo4ipu
from jpu2kernel4xi import get2kernelinfo4jpu
from kpu2kernel4xi import get2kernelinfo4kpu
from lpu2kernel4xi import get2kernelinfo4lpu
from mpu2kernel4xi import get2kernelinfo4mpu
from npu2kernel4xi import get2kernelinfo4npu
from opu2kernel4xi import get2kernelinfo4opu
from ppu2kernel4xi import get2kernelinfo4ppu
from qpu2kernel4xi import get2kernelinfo4qpu
from rpu2kernel4xi import get2kernelinfo4rpu
from spu2kernel4xi import get2kernelinfo4spu
from tpu2kernel4xi import get2kernelinfo4tpu
from upu2kernel4xi import get2kernelinfo4upu
from vpu2kernel4xi import get2kernelinfo4vpu
from xpu2kernel4xi import get2kernelinfo4xpu
from wpu2kernel4xi import get2kernelinfo4wpu
from ypu2kernel4xi import get2kernelinfo4ypu
from zpu2kernel4xi import get2kernelinfo4zpu

from apu2kernel4xi import add2kernel4apu                                                            
from bpu2kernel4xi import add2kernel4bpu
from cpu2kernel4xi import add2kernel4cpu
from dpu2kernel4xi import add2kernel4dpu
from epu2kernel4xi import add2kernel4epu
from fpu2kernel4xi import add2kernel4fpu
from gpu2kernel4xi import add2kernel4gpu
from hpu2kernel4xi import add2kernel4hpu
from ipu2kernel4xi import add2kernel4ipu
from jpu2kernel4xi import add2kernel4jpu
from kpu2kernel4xi import add2kernel4kpu
from lpu2kernel4xi import add2kernel4lpu
from mpu2kernel4xi import add2kernel4mpu
from npu2kernel4xi import add2kernel4npu
from opu2kernel4xi import add2kernel4opu
from ppu2kernel4xi import add2kernel4ppu
from qpu2kernel4xi import add2kernel4qpu
from rpu2kernel4xi import add2kernel4rpu
from spu2kernel4xi import add2kernel4spu
from tpu2kernel4xi import add2kernel4tpu
from upu2kernel4xi import add2kernel4upu
from vpu2kernel4xi import add2kernel4vpu
from xpu2kernel4xi import add2kernel4xpu
from wpu2kernel4xi import add2kernel4wpu
from ypu2kernel4xi import add2kernel4ypu
from zpu2kernel4xi import add2kernel4zpu

from apu2kernel4xi import release2kernel4apu                                                            
from bpu2kernel4xi import release2kernel4bpu
from cpu2kernel4xi import release2kernel4cpu
from dpu2kernel4xi import release2kernel4dpu
from epu2kernel4xi import release2kernel4epu
from fpu2kernel4xi import release2kernel4fpu
from gpu2kernel4xi import release2kernel4gpu
from hpu2kernel4xi import release2kernel4hpu
from ipu2kernel4xi import release2kernel4ipu
from jpu2kernel4xi import release2kernel4jpu
from kpu2kernel4xi import release2kernel4kpu
from lpu2kernel4xi import release2kernel4lpu
from mpu2kernel4xi import release2kernel4mpu
from npu2kernel4xi import release2kernel4npu
from opu2kernel4xi import release2kernel4opu
from ppu2kernel4xi import release2kernel4ppu
from qpu2kernel4xi import release2kernel4qpu
from rpu2kernel4xi import release2kernel4rpu
from spu2kernel4xi import release2kernel4spu
from tpu2kernel4xi import release2kernel4tpu
from upu2kernel4xi import release2kernel4upu
from vpu2kernel4xi import release2kernel4vpu
from xpu2kernel4xi import release2kernel4xpu
from wpu2kernel4xi import release2kernel4wpu
from ypu2kernel4xi import release2kernel4ypu
from zpu2kernel4xi import release2kernel4zpu

from apu2kernel4xi import retain2kernel4apu                                                            
from bpu2kernel4xi import retain2kernel4bpu
from cpu2kernel4xi import retain2kernel4cpu
from dpu2kernel4xi import retain2kernel4dpu
from epu2kernel4xi import retain2kernel4epu
from fpu2kernel4xi import retain2kernel4fpu
from gpu2kernel4xi import retain2kernel4gpu
from hpu2kernel4xi import retain2kernel4hpu
from ipu2kernel4xi import retain2kernel4ipu
from jpu2kernel4xi import retain2kernel4jpu
from kpu2kernel4xi import retain2kernel4kpu
from lpu2kernel4xi import retain2kernel4lpu
from mpu2kernel4xi import retain2kernel4mpu
from npu2kernel4xi import retain2kernel4npu
from opu2kernel4xi import retain2kernel4opu
from ppu2kernel4xi import retain2kernel4ppu
from qpu2kernel4xi import retain2kernel4qpu
from rpu2kernel4xi import retain2kernel4rpu
from spu2kernel4xi import retain2kernel4spu
from tpu2kernel4xi import retain2kernel4tpu
from upu2kernel4xi import retain2kernel4upu
from vpu2kernel4xi import retain2kernel4vpu
from xpu2kernel4xi import retain2kernel4xpu
from wpu2kernel4xi import retain2kernel4wpu
from ypu2kernel4xi import retain2kernel4ypu
from zpu2kernel4xi import retain2kernel4zpu

from apu2kernel4xi import set2kernel4apu                                                            
from bpu2kernel4xi import set2kernel4bpu
from cpu2kernel4xi import set2kernel4cpu
from dpu2kernel4xi import set2kernel4dpu
from epu2kernel4xi import set2kernel4epu
from fpu2kernel4xi import set2kernel4fpu
from gpu2kernel4xi import set2kernel4gpu
from hpu2kernel4xi import set2kernel4hpu
from ipu2kernel4xi import set2kernel4ipu
from jpu2kernel4xi import set2kernel4jpu
from kpu2kernel4xi import set2kernel4kpu
from lpu2kernel4xi import set2kernel4lpu
from mpu2kernel4xi import set2kernel4mpu
from npu2kernel4xi import set2kernel4npu
from opu2kernel4xi import set2kernel4opu
from ppu2kernel4xi import set2kernel4ppu
from qpu2kernel4xi import set2kernel4qpu
from rpu2kernel4xi import set2kernel4rpu
from spu2kernel4xi import set2kernel4spu
from tpu2kernel4xi import set2kernel4tpu
from upu2kernel4xi import set2kernel4upu
from vpu2kernel4xi import set2kernel4vpu
from xpu2kernel4xi import set2kernel4xpu
from wpu2kernel4xi import set2kernel4wpu
from ypu2kernel4xi import set2kernel4ypu
from zpu2kernel4xi import set2kernel4zpu

from apu2kernel4xi import set2kernelarg4apu                                                            
from bpu2kernel4xi import set2kernelarg4bpu
from cpu2kernel4xi import set2kernelarg4cpu
from dpu2kernel4xi import set2kernelarg4dpu
from epu2kernel4xi import set2kernelarg4epu
from fpu2kernel4xi import set2kernelarg4fpu
from gpu2kernel4xi import set2kernelarg4gpu
from hpu2kernel4xi import set2kernelarg4hpu
from ipu2kernel4xi import set2kernelarg4ipu
from jpu2kernel4xi import set2kernelarg4jpu
from kpu2kernel4xi import set2kernelarg4kpu
from lpu2kernel4xi import set2kernelarg4lpu
from mpu2kernel4xi import set2kernelarg4mpu
from npu2kernel4xi import set2kernelarg4npu
from opu2kernel4xi import set2kernelarg4opu
from ppu2kernel4xi import set2kernelarg4ppu
from qpu2kernel4xi import set2kernelarg4qpu
from rpu2kernel4xi import set2kernelarg4rpu
from spu2kernel4xi import set2kernelarg4spu
from tpu2kernel4xi import set2kernelarg4tpu
from upu2kernel4xi import set2kernelarg4upu
from vpu2kernel4xi import set2kernelarg4vpu
from xpu2kernel4xi import set2kernelarg4xpu
from wpu2kernel4xi import set2kernelarg4wpu
from ypu2kernel4xi import set2kernelarg4ypu
from zpu2kernel4xi import set2kernelarg4zpu

from apu2kernel4xi import set2kernelcallback4apu                                                            
from bpu2kernel4xi import set2kernelcallback4bpu
from cpu2kernel4xi import set2kernelcallback4cpu
from dpu2kernel4xi import set2kernelcallback4dpu
from epu2kernel4xi import set2kernelcallback4epu
from fpu2kernel4xi import set2kernelcallback4fpu
from gpu2kernel4xi import set2kernelcallback4gpu
from hpu2kernel4xi import set2kernelcallback4hpu
from ipu2kernel4xi import set2kernelcallback4ipu
from jpu2kernel4xi import set2kernelcallback4jpu
from kpu2kernel4xi import set2kernelcallback4kpu
from lpu2kernel4xi import set2kernelcallback4lpu
from mpu2kernel4xi import set2kernelcallback4mpu
from npu2kernel4xi import set2kernelcallback4npu
from opu2kernel4xi import set2kernelcallback4opu
from ppu2kernel4xi import set2kernelcallback4ppu
from qpu2kernel4xi import set2kernelcallback4qpu
from rpu2kernel4xi import set2kernelcallback4rpu
from spu2kernel4xi import set2kernelcallback4spu
from tpu2kernel4xi import set2kernelcallback4tpu
from upu2kernel4xi import set2kernelcallback4upu
from vpu2kernel4xi import set2kernelcallback4vpu
from xpu2kernel4xi import set2kernelcallback4xpu
from wpu2kernel4xi import set2kernelcallback4wpu
from ypu2kernel4xi import set2kernelcallback4ypu
from zpu2kernel4xi import set2kernelcallback4zpu

from apu2kernel4xi import trace2kernel4apu                                                            
from bpu2kernel4xi import trace2kernel4bpu
from cpu2kernel4xi import trace2kernel4cpu
from dpu2kernel4xi import trace2kernel4dpu
from epu2kernel4xi import trace2kernel4epu
from fpu2kernel4xi import trace2kernel4fpu
from gpu2kernel4xi import trace2kernel4gpu
from hpu2kernel4xi import trace2kernel4hpu
from ipu2kernel4xi import trace2kernel4ipu
from jpu2kernel4xi import trace2kernel4jpu
from kpu2kernel4xi import trace2kernel4kpu
from lpu2kernel4xi import trace2kernel4lpu
from mpu2kernel4xi import trace2kernel4mpu
from npu2kernel4xi import trace2kernel4npu
from opu2kernel4xi import trace2kernel4opu
from ppu2kernel4xi import trace2kernel4ppu
from qpu2kernel4xi import trace2kernel4qpu
from rpu2kernel4xi import trace2kernel4rpu
from spu2kernel4xi import trace2kernel4spu
from tpu2kernel4xi import trace2kernel4tpu
from upu2kernel4xi import trace2kernel4upu
from vpu2kernel4xi import trace2kernel4vpu
from xpu2kernel4xi import trace2kernel4xpu
from wpu2kernel4xi import trace2kernel4wpu
from ypu2kernel4xi import trace2kernel4ypu
from zpu2kernel4xi import trace2kernel4zpu

# -------------------------------------------------------------------------------------------------
# Buffer module                           
# -------------------------------------------------------------------------------------------------
from buffer4xi import Buffer4Xi
from buffer4xi import create2buffer4xi
from buffer4xi import create2subbuffer4xi
from buffer4xi import get2bufferinfo4xi
from buffer4xi import release2buffer4xi
from buffer4xi import retain2buffer4xi
from buffer4xi import set2buffer4xi


# -------------------------------------------------------------------------------------------------
# Command queue module                           
# -------------------------------------------------------------------------------------------------
from commandqueue4xi import CommandQueue4Xi
from commandqueue4xi import create2commandqueue4xi 
from commandqueue4xi import flush2commandqueue4xi
from commandqueue4xi import finish2commandqueue4xi
from commandqueue4xi import get2commandqueueinfo4xi
from commandqueue4xi import release2commandqueue4xi
from commandqueue4xi import retain2commandqueue4xi
from commandqueue4xi import set2commandqueue4xi


# -------------------------------------------------------------------------------------------------
# Context module                           
# -------------------------------------------------------------------------------------------------
from context4xi import Context4Xi 
from context4xi import create2context4xi
from context4xi import get2context4xi
from context4xi import release2context4xi
from context4xi import retain2context4xi
from context4xi import set2context4xi


# -------------------------------------------------------------------------------------------------
# Device module                        
# -------------------------------------------------------------------------------------------------
from device4xi import Device4Xi
from device4xi import init2device4xi 
from device4xi import set2device4xi
from device4xi import get2device4xi

# -------------------------------------------------------------------------------------------------
# Event module                           
# -------------------------------------------------------------------------------------------------
from event4xi import Event4Xi


# -------------------------------------------------------------------------------------------------
# Platform module                           
# -------------------------------------------------------------------------------------------------
from platformids4xi  import get2platformids4xi
from platforminfo4xi import PlatformInfo4Xi                                                                        
from platforminfo4xi import init2platforminfo4xi
from platforminfo4xi import set2platforminfo4xi
from platforminfo4xi import get2platforminfo4xi
#"
#/>

# -------------------------------------------------------------------------------------------------
# Multiprocessing Imports                          
# -------------------------------------------------------------------------------------------------
#<process4xi process = "
import _multiprocessing
#"
#/>


# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
from ace_object4xi import ace_object4xi
from arena4xi import Arena4Xi
from cpu_corecount4xi import cpu_corecount4xi
from dummyprocess4xi import DummyProcess4Xi
from print4xi import print4xi
from pipe4xi import Pipe4Xi
from queue4xi import Queue4Xi  
from time4xi import time4xi
from reason_object4xi import reason_object4xi
from sense_object4xi import sense_object4xi


#"
#/>

# -------------------------------------------------------------------------------------------------
# Global constants                            
# ------------------------------------------------------------------------------------------------
#<globalize4xi globalization = "
global kernel4xi                                                      # KERNELS

global kerneltrace4xi                                                 # TRACE

global info2kernel4xi                                                 # KERNEL INFORMATION

global platform2xi                                                     # PLATFORM
global device2xi                                                       # DEVICE
global context2xi                                                      # CONTEXT

        
#"
#/>

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
kernel4xi = {}                                                        # KERNELS
kerneltrace4xi = {}                                                   # TRACE
info2kernel4xi = {}                                                   # KERNEL INFORMATION

platform2xi = {}                                                       # PLATFORM
device2xi   = {}                                                       # DEVICE
context2xi  = {}                                                       # CONTEXT

#"
#"/>

# -------------------------------------------------------------------------------------------------
#<function4xi function = "trace2kernel4xi" usage = "  
#
#   print('(Step 15A/25) OF KERNEL4XI5TEST - TRYING TO TRACE XI: ', time4xi()) 
#   try:                               
#       task4trace2kernel  = {}
#       for key2pu in keys2pu:
#           task4trace2kernel[key2pu]  = {}
#       response4trace2kernel = trace2kernel4xi(task4trace2kernel)  
#       key2response = response4trace2kernel.keys()
#       for key2response in sorted(keys2response):
#           print(key2response, ' : ', response4trace2kernel[key2response] )
#           # APU  :  {'MESSAGE': '{(Step 2Z0/33) failed; trace2kernel4apu-failed {}; time: 04:43:16 10/31/11 Pacific Daylight Time}', 'CLASS': 'trace2kernel4apu', 'METHOD': 'trace2kernel4apu'}
#           # GPU  :  {'MESSAGE': '{(Step 2Z0/33) failed; trace2kernel4gpu-failed {}; time: 04:43:16 10/31/11 Pacific Daylight Time}', 'CLASS': 'trace2kernel4gpu', 'METHOD': 'trace2kernel4gpu'}
#           # XPU  :  {'MESSAGE': '{(Step 2Z0/33) failed; trace2kernel4xpu-failed {}; time: 04:43:16 10/31/11 Pacific Daylight Time}', 'CLASS': 'trace2kernel4xpu', 'METHOD': 'trace2kernel4xpu'}
#           # ZPU  :  {'MESSAGE': '{(Step 2Z0/33) failed; trace2kernel4zpu-failed {}; time: 04:43:16 10/31/11 Pacific Daylight Time}', 'CLASS': 'trace2kernel4zpu', 'METHOD': 'trace2kernel4zpu'}                                                                                                  
#   except:
#       print('(Step 15Z1/25) OF KERNEL4XI5TEST *** FAILED TO TRACE XI: ', time4xi()) 
#
#">

# -------------------------------------------------------------------------------------------------   
def trace2kernel4xi(task4trace2xi=None):  

    '''
    creates callback to kernel4xi
    '''

    global kerneltrace4xi
    
    
    # -----------------------------------------------------------------------------------------
    # (Step 1/33)         
    # -----------------------------------------------------------------------------------------          
    debug = False
    
    class2print = "trace2kernel4xi" 
    method2print = "trace2kernel4xi"

    message2print = "{(Step 1A/33) started" + "; trace2kernel4xi-started: " + str(trace2kernel4xi)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)                                                              
    # 
  
             
    message2print = "{(Step 1B/33) passed" + "; task4trace2xi-to-trace2kernel4xi: " + str(task4trace2xi) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                                                              # 
    # 

    code2ack  = ' '
    code2nack = ' '    
    
    kerneltrace4xi = {}                                                                                             # INITIALIZES TO EMPTY DICTIONARY
      
      
    if task4trace2xi is None:
        keys2task = None    
    else:
        try:
            keys2task = task4trace2xi.keys()
        except:
            keys2task = None   
    if debug is True:
       print("{(Step 1C/33) of trace2kernel4xi - keys2task: ", sorted(keys2task))
               

    # -----------------------------------------------------------------------------------------
    # (Step A/33) - APU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step A/33) 
        # ----------------------------------------------------------------------------- 
        if 'APU' in keys2task:
            message2print = "{(Step A/33) passing" + "; task-passing-to-trace2kernel4apu: " + str(task4trace2xi['APU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
            
            kerneltrace4xi ['APU']  = trace2kernel4apu()                                                      
             
            message2print = "{(Step A1/33) set" + "; apu-kernel-trace-set-by-trace2kernel4apu to: " + str(kerneltrace4xi ['APU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
            if debug is True:
                print("{(Step A2/33) of trace2kernel4xi - set trace4xi of APU kernel to: ", kerneltrace4xi ['APU'])
            
            code2ack  = code2ack + 'A1-'
        else:
            pass    
    except:
        message2print = "{(Step AZ1/33) yielded" + "; apu-yielded-by-trace2kernel4xi: " + 'APU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'AZ1-'

    # -----------------------------------------------------------------------------------------
    # (Step B/33) - BPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step B/33) 
        # ----------------------------------------------------------------------------- 
        if 'BPU' in keys2task:
            message2print = "{(Step B/33) passing" + "; task-passing-to-trace2kernel4bpu: " + str(task4trace2xi['BPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            kerneltrace4xi ['BPU']  = trace2kernel4bpu()                                                      # 
         
            message2print = "{(Step B1/33) set" + "; bpu-kernel-trace-set-by-trace2kernel4bpu to: " + str(kerneltrace4xi ['BPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
            code2ack  = code2ack + 'B1-'
        else:
            pass    
    except:
        message2print = "{(Step BZ1/33) yielded" + "; bpu-yielded-by-trace2kernel4xi: " + 'BPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'BZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step C/33) - CPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step C/33) 
        # ----------------------------------------------------------------------------- 
        if 'CPU' in keys2task:
            message2print = "{(Step C/33) passing" + "; task-passing-to-trace2kernel4cpu: " + str(task4trace2xi['CPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            kerneltrace4xi ['CPU']  = trace2kernel4cpu()                                                      # 
         
            message2print = "{(Step C1/33) set" + "; cpu-kernel-trace-set-by-trace2kernel4cpu to: " + str(kerneltrace4xi ['CPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
            code2ack  = code2ack + 'C1-'
        else:
            pass    
    except:
        message2print = "{(Step CZ1/33) yielded" + "; cpu-yielded-by-trace2kernel4xi: " + 'CPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'CZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step D/33) - DPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step D/33) 
        # ----------------------------------------------------------------------------- 
        if 'DPU' in keys2task:
            message2print = "{(Step D/33) passing" + "; task-passing-to-trace2kernel4dpu: " + str(task4trace2xi['DPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            kerneltrace4xi ['DPU']  = trace2kernel4dpu()                                                      # 
         
            message2print = "{(Step D1/33) set" + "; dpu-kernel-trace-set-by-trace2kernel4dpu to: " + str(kerneltrace4xi ['DPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
            code2ack  = code2ack + 'D1-'
        else:
            pass    
    except:
        message2print = "{(Step DZ1/33) yielded" + "; dpu-yielded-by-trace2kernel4xi: " + 'DPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'DZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step E/33) - EPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step E/33) 
        # ----------------------------------------------------------------------------- 
        if 'EPU' in keys2task:
            message2print = "{(Step E/33) passing" + "; task-passing-to-trace2kernel4epu: " + str(task4trace2xi['EPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            kerneltrace4xi ['EPU']  = trace2kernel4epu()                                                      # 
         
            message2print = "{(Step E1/33) set" + "; epu-kernel-trace-set-by-trace2kernel4epu to: " + str(kerneltrace4xi ['EPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
            code2ack  = code2ack + 'E1-'
        else:
            pass    
    except:
        message2print = "{(Step EZ1/33) yielded" + "; epu-yielded-by-trace2kernel4xi: " + 'EPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'EZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step F/33) - FPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step F/33) 
        # ----------------------------------------------------------------------------- 
        if 'FPU' in keys2task:
            message2print = "{(Step F/33) passing" + "; task-passing-to-trace2kernel4fpu: " + str(task4trace2xi['FPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            kerneltrace4xi ['FPU']  = trace2kernel4fpu()                                                      # 
         
            message2print = "{(Step F1/33) set" + "; fpu-kernel-trace-set-by-trace2kernel4fpu to: " + str(kerneltrace4xi ['PU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
            code2ack  = code2ack + 'F1-'
        else:
            pass    
    except:
        message2print = "{(Step FZ1/33) yielded" + "; fpu-yielded-by-trace2kernel4xi: " + 'FPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'FZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step G/33) - GPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step G/33) 
        # ----------------------------------------------------------------------------- 
        if 'GPU' in keys2task:
            message2print = "{(Step G/33) passing" + "; task-passing-to-trace2kernel4gpu: " + str(task4trace2xi['GPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            kerneltrace4xi ['GPU']  = trace2kernel4gpu()                                                      # 
         
            message2print = "{(Step G1/33) set" + "; gpu-kernel-trace-set-by-trace2kernel4gpu to: " + str(kerneltrace4xi ['GPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
            code2ack  = code2ack + 'G1-'
        else:
            pass    
    except:
        message2print = "{(Step GZ1/33) yielded" + "; gpu-yielded-by-trace2kernel4xi: " + 'GPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'GZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step H/33) - HPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step H/33) 
        # ----------------------------------------------------------------------------- 
        if 'HPU' in keys2task:
            message2print = "{(Step H/33) passing" + "; task-passing-to-trace2kernel4hpu: " + str(task4trace2xi['HPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            kerneltrace4xi ['HPU']  = trace2kernel4hpu()                                                      # 
         
            message2print = "{(Step H1/33) set" + "; hpu-kernel-trace-set-by-trace2kernel4hpu to: " + str(kerneltrace4xi ['HPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
            code2ack  = code2ack + 'H1-'
        else:
            pass    
    except:
        message2print = "{(Step HZ1/33) yielded" + "; hpu-yielded-by-trace2kernel4xi: " + 'HPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'HZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step I/33) - IPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step I/33) 
        # ----------------------------------------------------------------------------- 
        if 'IPU' in keys2task:
            message2print = "{(Step I/33) passing" + "; task-passing-to-trace2kernel4ipu: " + str(task4trace2xi['IPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            kerneltrace4xi ['IPU']  = trace2kernel4ipu()                                                      # 
         
            message2print = "{(Step I1/33) set" + "; ipu-kernel-trace-set-by-trace2kernel4ipu to: " + str(kerneltrace4xi ['IPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
            code2ack  = code2ack + 'I1-'
        else:
            pass    
    except:
        message2print = "{(Step IZ1/33) yielded" + "; ipu-yielded-by-trace2kernel4xi: " + 'IPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'IZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step J/33) - JPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step J/33) 
        # ----------------------------------------------------------------------------- 
        if 'JPU' in keys2task:
            message2print = "{(Step J/33) passing" + "; task-passing-to-trace2kernel4jpu: " + str(task4trace2xi['JPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            kerneltrace4xi ['JPU']  = trace2kernel4jpu()                                                      # 
         
            message2print = "{(Step J1/33) set" + "; jpu-kernel-trace-set-by-trace2kernel4jpu to: " + str(kerneltrace4xi ['JPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
            code2ack  = code2ack + 'J1-'
        else:
            pass    
    except:
        message2print = "{(Step JZ1/33) yielded" + "; jpu-yielded-by-trace2kernel4xi: " + 'JPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'JZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step K/33) - KPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step K/33) 
        # ----------------------------------------------------------------------------- 
        if 'KPU' in keys2task:
            message2print = "{(Step K/33) passing" + "; task-passing-to-trace2kernel4kpu: " + str(task4trace2xi['KPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            kerneltrace4xi ['KPU']  = trace2kernel4kpu()                                                      # 
         
            message2print = "{(Step K1/33) set" + "; kpu-kernel-trace-set-by-trace2kernel4kpu to: " + str(kerneltrace4xi ['KPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
            code2ack  = code2ack + 'K1-'
        else:
            pass    
    except:
        message2print = "{(Step KZ1/33) yielded" + "; kpu-yielded-by-trace2kernel4xi: " + 'KPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'KZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step L/33) - LPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step L/33) 
        # ----------------------------------------------------------------------------- 
        if 'LPU' in keys2task:
            message2print = "{(Step L/33) passing" + "; task-passing-to-trace2kernel4lpu: " + str(task4trace2xi['LPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            kerneltrace4xi ['LPU']  = trace2kernel4lpu()                                                      # 
         
            message2print = "{(Step L1/33) set" + "; lpu-kernel-trace-set-by-trace2kernel4lpu to: " + str(kerneltrace4xi ['LPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
            code2ack  = code2ack + '1-'
        else:
            pass    
    except:
        message2print = "{(Step LZ1/33) yielded" + "; lpu-yielded-by-trace2kernel4xi: " + 'LPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'LZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step M/33) - MPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step M/33) 
        # ----------------------------------------------------------------------------- 
        if 'MPU' in keys2task:
            message2print = "{(Step M/33) passing" + "; task-passing-to-trace2kernel4mpu: " + str(task4trace2xi['MPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            kerneltrace4xi ['MPU']  = trace2kernel4mpu()                                                      # 
         
            message2print = "{(Step M1/33) set" + "; mpu-kernel-trace-set-by-trace2kernel4mpu to: " + str(kerneltrace4xi ['MPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
            code2ack  = code2ack + 'M1-'
        else:
            pass    
    except:
        message2print = "{(Step MZ1/33) yielded" + "; mpu-yielded-by-trace2kernel4xi: " + 'MPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'MZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step N/33) - NPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step N/33) 
        # ----------------------------------------------------------------------------- 
        if 'NPU' in keys2task:
            message2print = "{(Step N/33) passing" + "; task-passing-to-trace2kernel4npu: " + str(task4trace2xi['NPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            kerneltrace4xi ['NPU']  = trace2kernel4npu()                                                      # 
         
            message2print = "{(Step N1/33) set" + "; npu-kernel-trace-set-by-trace2kernel4npu to: " + str(kerneltrace4xi ['NPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
            code2ack  = code2ack + 'N1-'
        else:
            pass    
    except:
        message2print = "{(Step NZ1/33) yielded" + "; npu-yielded-by-trace2kernel4xi: " + 'NPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'NZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step O/33) - OPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step O/33) 
        # ----------------------------------------------------------------------------- 
        if 'OPU' in keys2task:
            message2print = "{(Step O/33) passing" + "; task-passing-to-trace2kernel4opu: " + str(task4trace2xi['OPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            kerneltrace4xi ['OPU']  = trace2kernel4opu()                                                      # 
         
            message2print = "{(Step O1/33) set" + "; opu-kernel-trace-set-by-trace2kernel4opu to: " + str(kerneltrace4xi ['OPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
            code2ack  = code2ack + 'O1-'
        else:
            pass    
    except:
        message2print = "{(Step OZ1/33) yielded" + "; opu-yielded-by-trace2kernel4xi: " + 'OPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'OZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step P/33) - PPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step P/33) 
        # ----------------------------------------------------------------------------- 
        if 'PPU' in keys2task:
            message2print = "{(Step P/33) passing" + "; task-passing-to-trace2kernel4ppu: " + str(task4trace2xi['PPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            kerneltrace4xi ['PPU']  = trace2kernel4ppu()                                                      # 
         
            message2print = "{(Step P1/33) set" + "; ppu-kernel-trace-set-by-trace2kernel4ppu to: " + str(kerneltrace4xi ['PPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
            code2ack  = code2ack + 'P1-'
        else:
            pass    
    except:
        message2print = "{(Step PZ1/33) yielded" + "; ppu-yielded-by-trace2kernel4xi: " + 'PPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'PZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step Q/33) - QPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step Q/33) 
        # ----------------------------------------------------------------------------- 
        if 'QPU' in keys2task:
            message2print = "{(Step Q/33) passing" + "; task-passing-to-trace2kernel4qpu: " + str(task4trace2xi['QPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            kerneltrace4xi ['QPU']  = trace2kernel4qpu()                                                      # 
         
            message2print = "{(Step Q1/33) set" + "; qpu-kernel-trace-set-by-trace2kernel4qpu to: " + str(kerneltrace4xi ['QPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
            code2ack  = code2ack + 'Q1-'
        else:
            pass    
    except:
        message2print = "{(Step QZ1/33) yielded" + "; qpu-yielded-by-trace2kernel4xi: " + 'QPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'QZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step R/33) - RPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step R/33) 
        # ----------------------------------------------------------------------------- 
        if 'RPU' in keys2task:
            message2print = "{(Step R/33) passing" + "; task-passing-to-trace2kernel4rpu: " + str(task4trace2xi['RPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            kerneltrace4xi ['RPU']  = trace2kernel4rpu()                                                      # 
         
            message2print = "{(Step R1/33) set" + "; rpu-kernel-trace-set-by-trace2kernel4rpu to: " + str(kerneltrace4xi ['RPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
            code2ack  = code2ack + 'R1-'
        else:
            pass    
    except:
        message2print = "{(Step RZ1/33) yielded" + "; rpu-yielded-by-trace2kernel4xi: " + 'RPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'RZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step S/33) - SPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step S/33) 
        # ----------------------------------------------------------------------------- 
        if 'SPU' in keys2task:
            message2print = "{(Step S/33) passing" + "; task-passing-to-trace2kernel4spu: " + str(task4trace2xi['SPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            kerneltrace4xi ['SPU']  = trace2kernel4spu()                                                      # 
         
            message2print = "{(Step S1/33) set" + "; spu-kernel-trace-set-by-trace2kernel4spu to: " + str(kerneltrace4xi ['SPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
            code2ack  = code2ack + 'S1-'
        else:
            pass    
    except:
        message2print = "{(Step SZ1/33) yielded" + "; spu-yielded-by-trace2kernel4xi: " + 'SPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'SZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step T/33) - TPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step T/33) 
        # ----------------------------------------------------------------------------- 
        if 'TPU' in keys2task:
            message2print = "{(Step T/33) passing" + "; task-passing-to-trace2kernel4tpu: " + str(task4trace2xi['TPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            kerneltrace4xi ['TPU']  = trace2kernel4tpu()                                                      # 
         
            message2print = "{(Step T1/33) set" + "; tpu-kernel-trace-set-by-trace2kernel4tpu to: " + str(kerneltrace4xi ['TPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
            code2ack  = code2ack + 'T1-'
        else:
            pass    
    except:
        message2print = "{(Step TZ1/33) yielded" + "; tpu-yielded-by-trace2kernel4xi: " + 'TPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'TZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step U/33) - UPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step U/33) 
        # ----------------------------------------------------------------------------- 
        if 'UPU' in keys2task:
            message2print = "{(Step U/33) passing" + "; task-passing-to-trace2kernel4upu: " + str(task4trace2xi['UPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            kerneltrace4xi ['UPU']  = trace2kernel4upu()                                                      # 
         
            message2print = "{(Step U1/33) set" + "; upu-kernel-trace-set-by-trace2kernel4upu to: " + str(kerneltrace4xi ['UPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
            code2ack  = code2ack + 'U1-'
        else:
            pass    
    except:
        message2print = "{(Step UZ1/33) yielded" + "; upu-yielded-by-trace2kernel4xi: " + 'UPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'UZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step V/33) - VPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step V/33) 
        # ----------------------------------------------------------------------------- 
        if 'VPU' in keys2task:
            message2print = "{(Step V/33) passing" + "; task-passing-to-trace2kernel4vpu: " + str(task4trace2xi['VPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            kerneltrace4xi ['VPU']  = trace2kernel4vpu()                                                      # 
         
            message2print = "{(Step V1/33) set" + "; vpu-kernel-trace-set-by-trace2kernel4vpu to: " + str(kerneltrace4xi ['VPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
            code2ack  = code2ack + 'V1-'
        else:
            pass    
    except:
        message2print = "{(Step VZ1/33) yielded" + "; vpu-yielded-by-trace2kernel4xi: " + 'VPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'VZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step W/33) - WPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step W/33) 
        # ----------------------------------------------------------------------------- 
        if 'WPU' in keys2task:
            message2print = "{(Step W/33) passing" + "; task-passing-to-trace2kernel4wpu: " + str(task4trace2xi['WPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            kerneltrace4xi ['WPU']  = trace2kernel4wpu()                                                      # 
         
            message2print = "{(Step W1/33) set" + "; wpu-kernel-trace-set-by-trace2kernel4wpu to: " + str(kerneltrace4xi ['WPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
            code2ack  = code2ack + 'W1-'
        else:
            pass    
    except:
        message2print = "{(Step WZ1/33) yielded" + "; wpu-yielded-by-trace2kernel4xi: " + 'WPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'WZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step X/33) - XPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step X/33) 
        # ----------------------------------------------------------------------------- 
        if 'XPU' in keys2task:
            message2print = "{(Step X/33) passing" + "; task-passing-to-trace2kernel4xpu: " + str(task4trace2xi['XPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            kerneltrace4xi ['XPU']  = trace2kernel4xpu()                                                      # 
         
            message2print = "{(Step X1/33) set" + "; xpu-kernel-trace-set-by-trace2kernel4xpu to: " + str(kerneltrace4xi ['XPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
            if debug is True:
                print("{(Step X2/33) of trace2kernel4xi - set trace4xi of XPU kernel to: ", kerneltrace4xi ['XPU'])
            code2ack  = code2ack + 'X1-'
        else:
            pass    
    except:
        message2print = "{(Step XZ1/33) yielded" + "; xpu-yielded-by-trace2kernel4xi: " + 'XPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'XZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step Y/33) - YPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step Y/33) 
        # ----------------------------------------------------------------------------- 
        if 'YPU' in keys2task:
            message2print = "{(Step Y/33) passing" + "; task-passing-to-trace2kernel4ypu: " + str(task4trace2xi['YPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            kerneltrace4xi ['YPU']  = trace2kernel4ypu()                                                      # 
         
            message2print = "{(Step Y1/33) set" + "; ypu-kernel-trace-set-by-trace2kernel4ypu to: " + str(kerneltrace4xi ['YPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
            code2ack  = code2ack + 'Y1-'
        else:
            pass    
    except:
        message2print = "{(Step YZ1/33) yielded" + "; ypu-yielded-by-trace2kernel4xi: " + 'YPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'YZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step Z/33) - ZPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step Z/33) 
        # ----------------------------------------------------------------------------- 
        if 'ZPU' in keys2task:
            message2print = "{(Step Z/33) passing" + "; task-passing-to-trace2kernel4zpu: " + str(task4trace2xi['ZPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            kerneltrace4xi ['ZPU']  = trace2kernel4zpu()                                                      # 
         
            message2print = "{(Step Z1/33) set" + "; zpu-kernel-trace-set-by-trace2kernel4zpu to: " + str(kerneltrace4xi ['ZPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
            if debug is True:
                print("{(Step Z2/33) of trace2kernel4xi - set trace4xi of ZPU kernel to: ", kerneltrace4xi ['ZPU'])
            code2ack  = code2ack + 'Z1-'
        else:
            pass    
    except:
        message2print = "{(Step ZZ1/33) yielded" + "; zpu-yielded-by-trace2kernel4xi: " + 'ZPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'ZZ1-'

                                                
    # -----------------------------------------------------------------------------------------
    # (Step 33/3)           
    # -----------------------------------------------------------------------------------------
    print("{(Step 33/33) of trace2kernel4xi kerneltrace4xi - RETURNING : ") 
    if debug is True:
        for key2task in keys2task:
            print(key2task, kerneltrace4xi[key2task])
            # 
                
    message2print = "{(Step 33/33) returning" + "; kerneltrace4xi-returning-by-trace2kernel4xi: " + str(kerneltrace4xi) + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)
    #  
    
    return kerneltrace4xi


#</function4xi> 

# -------------------------------------------------------------------------------------------------
#<function4xi function = "set2kernelcallback4xi" usage = " 
#
#   print('(Step 14B/700) OF KERNEL4XI5TEST - TRYING TO SET KERNEL CALLBACK OF XI DEVICE ', time4xi())     
#   try:                               
#       task4callback2kernel  = {}
#       for key2pu in keys2pu:
#           task4callback2kernel[key2pu]  = {}
#       response4setcallback2kernel = set2kernelcallback4xi(task4callback2kernel) 
#       key2response = response4setcallback2kernel.keys()
#       for key2response in sorted(keys2response):
#           print(key2response, ' : ', response4setcallback2kernel[key2response])
#           # APU  :  <function trace2kernel4apu at 0x00000000043F1C48>
#           # ...
#           # ZPU  :  <function trace2kernel4zpu at 0x00000000058610C8>
#                                                                                                     
#   except:
#       print('(Step 14Z2/700) OF KERNEL4XI5TEST *** FAILED TO SET KERNEL CALLBACK OF XI DEVICE ', time4xi())
#
#">

# ------------------------------------------------------------------------------------------------- 
 
def set2kernelcallback4xi(task4set2kernelcallback=None):

    '''
    registers callback function to kernel4xi
    '''
    global kernel4xi
    
    
    # -----------------------------------------------------------------------------------------
    # (Step 1/33) PARAMETERS           
    # -----------------------------------------------------------------------------------------          
    debug = False
    
    class2print = "set2kernelcallback4xi"
    method2print = "set2kernelcallback4xi"

    message2print = "{(Step 1A/33) started" + "; set2kernelcallback4xi-started: " + str(set2kernelcallback4xi)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)                                                                     #  
    # 
    
    message2print = "{(Step 1B/33) passed" + "; task4kernelset2xi-to-set2kernelcallback4xi: " + str(task4set2kernelcallback) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                                                              
    # 
            
    code2ack  = ' '
    code2nack = ' '
    if kernel4xi is None:
        kernel4xi = create2kernel4xi()                                                                            
                                
        message2print = "{(Step 1C/33) set" + "; kernel4xi-set-by-set2kernelcallback4xi to: " + str(kernel4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        code2ack  = code2ack + '1C-'
    else:
        pass    
    
        
    if task4set2kernelcallback is None:
        keys2task = None    
    else:
        try:
            keys2task = task4set2kernelcallback.keys()
        except:
            keys2task = None   
    if debug is True:
       print("{(Step 1C/33) of set2kernelcallback4xi - keys2task: ", sorted(keys2task))
               

    # -----------------------------------------------------------------------------------------
    # (Step A/33) - APU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step A/33) 
        # ----------------------------------------------------------------------------- 
        if 'APU' in keys2task:
            message2print = "{(Step A/33) passing" + "; task-passing-to-set2kernelcallback4apu: " + str(task4set2kernelcallback['APU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
            
            kernel4xi ['APU'] ['CALLBACK'] = set2kernelcallback4apu()                                                      # 
             
            message2print = "{(Step A1/33) set" + "; apu-kernel-set-by-set2kernelcallback4apu to: " + str(kernel4xi ['APU'] ['CALLBACK'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
            if debug is True:
                print("{(Step A2/33) of set2kernelcallback4xi - set callback4xi of APU kernel to: ", kernel4xi ['APU'] ['CALLBACK'])
            
            code2ack  = code2ack + 'A1-'
        else:
            pass    
    except:
        message2print = "{(Step AZ1/33) yielded" + "; apu-yielded-by-set2kernelcallback4xi: " + 'APU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'AZ1-'

    # -----------------------------------------------------------------------------------------
    # (Step B/33) - BPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step B/33) 
        # ----------------------------------------------------------------------------- 
        if 'BPU' in keys2task:
            message2print = "{(Step B/33) passing" + "; task-passing-to-set2kernelcallback4bpu: " + str(task4set2kernelcallback['BPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            kernel4xi ['BPU'] ['CALLBACK'] = set2kernelcallback4bpu()                                                      # 
         
            message2print = "{(Step B1/33) set" + "; bpu-kernel-set-by-set2kernelcallback4bpu to: " + str(kernel4xi ['BPU'] ['CALLBACK'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
            code2ack  = code2ack + 'B1-'
        else:
            pass    
    except:
        message2print = "{(Step BZ1/33) yielded" + "; bpu-yielded-by-set2kernelcallback4xi: " + 'BPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'BZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step C/33) - CPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step C/33) 
        # ----------------------------------------------------------------------------- 
        if 'CPU' in keys2task:
            message2print = "{(Step C/33) passing" + "; task-passing-to-set2kernelcallback4cpu: " + str(task4set2kernelcallback['CPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            kernel4xi ['CPU'] ['CALLBACK'] = set2kernelcallback4cpu()                                                      # 
         
            message2print = "{(Step C1/33) set" + "; cpu-kernel-set-by-set2kernelcallback4cpu to: " + str(kernel4xi ['CPU'] ['CALLBACK'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
            code2ack  = code2ack + 'C1-'
        else:
            pass    
    except:
        message2print = "{(Step CZ1/33) yielded" + "; cpu-yielded-by-set2kernelcallback4xi: " + 'CPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'CZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step D/33) - DPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step D/33) 
        # ----------------------------------------------------------------------------- 
        if 'DPU' in keys2task:
            message2print = "{(Step D/33) passing" + "; task-passing-to-set2kernelcallback4dpu: " + str(task4set2kernelcallback['DPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            kernel4xi ['DPU'] ['CALLBACK'] = set2kernelcallback4dpu()                                                      # 
         
            message2print = "{(Step D1/33) set" + "; dpu-kernel-set-by-set2kernelcallback4dpu to: " + str(kernel4xi ['DPU'] ['CALLBACK'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
            code2ack  = code2ack + 'D1-'
        else:
            pass    
    except:
        message2print = "{(Step DZ1/33) yielded" + "; dpu-yielded-by-set2kernelcallback4xi: " + 'DPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'DZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step E/33) - EPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step E/33) 
        # ----------------------------------------------------------------------------- 
        if 'EPU' in keys2task:
            message2print = "{(Step E/33) passing" + "; task-passing-to-set2kernelcallback4epu: " + str(task4set2kernelcallback['EPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            kernel4xi ['EPU'] ['CALLBACK'] = set2kernelcallback4epu()                                                      # 
         
            message2print = "{(Step E1/33) set" + "; epu-kernel-set-by-set2kernelcallback4epu to: " + str(kernel4xi ['EPU'] ['CALLBACK'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
            code2ack  = code2ack + 'E1-'
        else:
            pass    
    except:
        message2print = "{(Step EZ1/33) yielded" + "; epu-yielded-by-set2kernelcallback4xi: " + 'EPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'EZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step F/33) - FPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step F/33) 
        # ----------------------------------------------------------------------------- 
        if 'FPU' in keys2task:
            message2print = "{(Step F/33) passing" + "; task-passing-to-set2kernelcallback4fpu: " + str(task4set2kernelcallback['FPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            kernel4xi ['FPU'] ['CALLBACK'] = set2kernelcallback4fpu()                                                      # 
         
            message2print = "{(Step F1/33) set" + "; fpu-kernel-set-by-set2kernelcallback4fpu to: " + str(kernel4xi ['FPU'] ['CALLBACK'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
            code2ack  = code2ack + 'F1-'
        else:
            pass    
    except:
        message2print = "{(Step FZ1/33) yielded" + "; fpu-yielded-by-set2kernelcallback4xi: " + 'FPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'FZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step G/33) - GPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step G/33) 
        # ----------------------------------------------------------------------------- 
        if 'GPU' in keys2task:
            message2print = "{(Step G/33) passing" + "; task-passing-to-set2kernelcallback4gpu: " + str(task4set2kernelcallback['GPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            kernel4xi ['GPU'] ['CALLBACK'] = set2kernelcallback4gpu()                                                      # 
         
            message2print = "{(Step G1/33) set" + "; gpu-kernel-set-by-set2kernelcallback4gpu to: " + str(kernel4xi ['GPU'] ['CALLBACK'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
            code2ack  = code2ack + 'G1-'
        else:
            pass    
    except:
        message2print = "{(Step GZ1/33) yielded" + "; gpu-yielded-by-set2kernelcallback4xi: " + 'GPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'GZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step H/33) - HPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step H/33) 
        # ----------------------------------------------------------------------------- 
        if 'HPU' in keys2task:
            message2print = "{(Step H/33) passing" + "; task-passing-to-set2kernelcallback4hpu: " + str(task4set2kernelcallback['HPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            kernel4xi ['HPU'] ['CALLBACK'] = set2kernelcallback4hpu()                                                      # 
         
            message2print = "{(Step H1/33) set" + "; hpu-kernel-set-by-set2kernelcallback4hpu to: " + str(kernel4xi ['HPU'] ['CALLBACK'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
            code2ack  = code2ack + 'H1-'
        else:
            pass    
    except:
        message2print = "{(Step HZ1/33) yielded" + "; hpu-yielded-by-set2kernelcallback4xi: " + 'HPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'HZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step I/33) - IPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step I/33) 
        # ----------------------------------------------------------------------------- 
        if 'IPU' in keys2task:
            message2print = "{(Step I/33) passing" + "; task-passing-to-set2kernelcallback4ipu: " + str(task4set2kernelcallback['IPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            kernel4xi ['IPU'] ['CALLBACK'] = set2kernelcallback4ipu()                                                      # 
         
            message2print = "{(Step I1/33) set" + "; ipu-kernel-set-by-set2kernelcallback4ipu to: " + str(kernel4xi ['IPU'] ['CALLBACK'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
            code2ack  = code2ack + 'I1-'
        else:
            pass    
    except:
        message2print = "{(Step IZ1/33) yielded" + "; ipu-yielded-by-set2kernelcallback4xi: " + 'IPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'IZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step J/33) - JPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step J/33) 
        # ----------------------------------------------------------------------------- 
        if 'JPU' in keys2task:
            message2print = "{(Step J/33) passing" + "; task-passing-to-set2kernelcallback4jpu: " + str(task4set2kernelcallback['JPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            kernel4xi ['JPU'] ['CALLBACK'] = set2kernelcallback4jpu()                                                      # 
         
            message2print = "{(Step J1/33) set" + "; jpu-kernel-set-by-set2kernelcallback4jpu to: " + str(kernel4xi ['JPU'] ['CALLBACK'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
            code2ack  = code2ack + 'J1-'
        else:
            pass    
    except:
        message2print = "{(Step JZ1/33) yielded" + "; jpu-yielded-by-set2kernelcallback4xi: " + 'JPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'JZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step K/33) - KPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step K/33) 
        # ----------------------------------------------------------------------------- 
        if 'KPU' in keys2task:
            message2print = "{(Step K/33) passing" + "; task-passing-to-set2kernelcallback4kpu: " + str(task4set2kernelcallback['KPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            kernel4xi ['KPU'] ['CALLBACK'] = set2kernelcallback4kpu()                                                      # 
         
            message2print = "{(Step K1/33) set" + "; kpu-kernel-set-by-set2kernelcallback4kpu to: " + str(kernel4xi ['KPU'] ['CALLBACK'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
            code2ack  = code2ack + 'K1-'
        else:
            pass    
    except:
        message2print = "{(Step KZ1/33) yielded" + "; kpu-yielded-by-set2kernelcallback4xi: " + 'KPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'KZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step L/33) - LPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step L/33) 
        # ----------------------------------------------------------------------------- 
        if 'LPU' in keys2task:
            message2print = "{(Step L/33) passing" + "; task-passing-to-set2kernelcallback4lpu: " + str(task4set2kernelcallback['LPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            kernel4xi ['LPU'] ['CALLBACK'] = set2kernelcallback4lpu()                                                      # 
         
            message2print = "{(Step L1/33) set" + "; lpu-kernel-set-by-set2kernelcallback4lpu to: " + str(kernel4xi ['LPU'] ['CALLBACK'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
            code2ack  = code2ack + '1-'
        else:
            pass    
    except:
        message2print = "{(Step LZ1/33) yielded" + "; lpu-yielded-by-set2kernelcallback4xi: " + 'LPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'LZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step M/33) - MPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step M/33) 
        # ----------------------------------------------------------------------------- 
        if 'MPU' in keys2task:
            message2print = "{(Step M/33) passing" + "; task-passing-to-set2kernelcallback4mpu: " + str(task4set2kernelcallback['MPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            kernel4xi ['MPU'] ['CALLBACK'] = set2kernelcallback4mpu()                                                      # 
         
            message2print = "{(Step M1/33) set" + "; mpu-kernel-set-by-set2kernelcallback4mpu to: " + str(kernel4xi ['MPU'] ['CALLBACK'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
            code2ack  = code2ack + 'M1-'
        else:
            pass    
    except:
        message2print = "{(Step MZ1/33) yielded" + "; mpu-yielded-by-set2kernelcallback4xi: " + 'MPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'MZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step N/33) - NPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step N/33) 
        # ----------------------------------------------------------------------------- 
        if 'NPU' in keys2task:
            message2print = "{(Step N/33) passing" + "; task-passing-to-set2kernelcallback4npu: " + str(task4set2kernelcallback['NPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            kernel4xi ['NPU'] ['CALLBACK'] = set2kernelcallback4npu()                                                      # 
         
            message2print = "{(Step N1/33) set" + "; npu-kernel-set-by-set2kernelcallback4npu to: " + str(kernel4xi ['NPU'] ['CALLBACK'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
            code2ack  = code2ack + 'N1-'
        else:
            pass    
    except:
        message2print = "{(Step NZ1/33) yielded" + "; npu-yielded-by-set2kernelcallback4xi: " + 'NPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'NZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step O/33) - OPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step O/33) 
        # ----------------------------------------------------------------------------- 
        if 'OPU' in keys2task:
            message2print = "{(Step O/33) passing" + "; task-passing-to-set2kernelcallback4opu: " + str(task4set2kernelcallback['OPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            kernel4xi ['OPU'] ['CALLBACK'] = set2kernelcallback4opu()                                                      # 
         
            message2print = "{(Step O1/33) set" + "; opu-kernel-set-by-set2kernelcallback4opu to: " + str(kernel4xi ['OPU'] ['CALLBACK'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
            code2ack  = code2ack + 'O1-'
        else:
            pass    
    except:
        message2print = "{(Step OZ1/33) yielded" + "; opu-yielded-by-set2kernelcallback4xi: " + 'OPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'OZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step P/33) - PPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step P/33) 
        # ----------------------------------------------------------------------------- 
        if 'PPU' in keys2task:
            message2print = "{(Step P/33) passing" + "; task-passing-to-set2kernelcallback4ppu: " + str(task4set2kernelcallback['PPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            kernel4xi ['PPU'] ['CALLBACK'] = set2kernelcallback4ppu()                                                      # 
         
            message2print = "{(Step P1/33) set" + "; ppu-kernel-set-by-set2kernelcallback4ppu to: " + str(kernel4xi ['PPU'] ['CALLBACK'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
            code2ack  = code2ack + 'P1-'
        else:
            pass    
    except:
        message2print = "{(Step PZ1/33) yielded" + "; ppu-yielded-by-set2kernelcallback4xi: " + 'PPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'PZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step Q/33) - QPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step Q/33) 
        # ----------------------------------------------------------------------------- 
        if 'QPU' in keys2task:
            message2print = "{(Step Q/33) passing" + "; task-passing-to-set2kernelcallback4qpu: " + str(task4set2kernelcallback['QPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            kernel4xi ['QPU'] ['CALLBACK'] = set2kernelcallback4qpu()                                                      # 
         
            message2print = "{(Step Q1/33) set" + "; qpu-kernel-set-by-set2kernelcallback4qpu to: " + str(kernel4xi ['QPU'] ['CALLBACK'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
            code2ack  = code2ack + 'Q1-'
        else:
            pass    
    except:
        message2print = "{(Step QZ1/33) yielded" + "; qpu-yielded-by-set2kernelcallback4xi: " + 'QPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'QZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step R/33) - RPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step R/33) 
        # ----------------------------------------------------------------------------- 
        if 'RPU' in keys2task:
            message2print = "{(Step R/33) passing" + "; task-passing-to-set2kernelcallback4rpu: " + str(task4set2kernelcallback['RPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            kernel4xi ['RPU'] ['CALLBACK'] = set2kernelcallback4rpu()                                                      # 
         
            message2print = "{(Step R1/33) set" + "; rpu-kernel-set-by-set2kernelcallback4rpu to: " + str(kernel4xi ['RPU'] ['CALLBACK'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
            code2ack  = code2ack + 'R1-'
        else:
            pass    
    except:
        message2print = "{(Step RZ1/33) yielded" + "; rpu-yielded-by-set2kernelcallback4xi: " + 'RPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'RZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step S/33) - SPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step S/33) 
        # ----------------------------------------------------------------------------- 
        if 'SPU' in keys2task:
            message2print = "{(Step S/33) passing" + "; task-passing-to-set2kernelcallback4spu: " + str(task4set2kernelcallback['SPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            kernel4xi ['SPU'] ['CALLBACK'] = set2kernelcallback4spu()                                                      # 
         
            message2print = "{(Step S1/33) set" + "; spu-kernel-set-by-set2kernelcallback4spu to: " + str(kernel4xi ['SPU'] ['CALLBACK'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
            code2ack  = code2ack + 'S1-'
        else:
            pass    
    except:
        message2print = "{(Step SZ1/33) yielded" + "; spu-yielded-by-set2kernelcallback4xi: " + 'SPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'SZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step T/33) - TPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step T/33) 
        # ----------------------------------------------------------------------------- 
        if 'TPU' in keys2task:
            message2print = "{(Step T/33) passing" + "; task-passing-to-set2kernelcallback4tpu: " + str(task4set2kernelcallback['TPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            kernel4xi ['TPU'] ['CALLBACK'] = set2kernelcallback4tpu()                                                      # 
         
            message2print = "{(Step T1/33) set" + "; tpu-kernel-set-by-set2kernelcallback4tpu to: " + str(kernel4xi ['TPU'] ['CALLBACK'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
            code2ack  = code2ack + 'T1-'
        else:
            pass    
    except:
        message2print = "{(Step TZ1/33) yielded" + "; tpu-yielded-by-set2kernelcallback4xi: " + 'TPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'TZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step U/33) - UPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step U/33) 
        # ----------------------------------------------------------------------------- 
        if 'UPU' in keys2task:
            message2print = "{(Step U/33) passing" + "; task-passing-to-set2kernelcallback4upu: " + str(task4set2kernelcallback['UPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            kernel4xi ['UPU'] ['CALLBACK'] = set2kernelcallback4upu()                                                      # 
         
            message2print = "{(Step U1/33) set" + "; upu-kernel-set-by-set2kernelcallback4upu to: " + str(kernel4xi ['UPU'] ['CALLBACK'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
            code2ack  = code2ack + 'U1-'
        else:
            pass    
    except:
        message2print = "{(Step UZ1/33) yielded" + "; upu-yielded-by-set2kernelcallback4xi: " + 'UPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'UZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step V/33) - VPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step V/33) 
        # ----------------------------------------------------------------------------- 
        if 'VPU' in keys2task:
            message2print = "{(Step V/33) passing" + "; task-passing-to-set2kernelcallback4vpu: " + str(task4set2kernelcallback['VPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            kernel4xi ['VPU'] ['CALLBACK'] = set2kernelcallback4vpu()                                                      # 
         
            message2print = "{(Step V1/33) set" + "; vpu-kernel-set-by-set2kernelcallback4vpu to: " + str(kernel4xi ['VPU'] ['CALLBACK'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
            code2ack  = code2ack + 'V1-'
        else:
            pass    
    except:
        message2print = "{(Step VZ1/33) yielded" + "; vpu-yielded-by-set2kernelcallback4xi: " + 'VPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'VZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step W/33) - WPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step W/33) 
        # ----------------------------------------------------------------------------- 
        if 'WPU' in keys2task:
            message2print = "{(Step W/33) passing" + "; task-passing-to-set2kernelcallback4wpu: " + str(task4set2kernelcallback['WPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            kernel4xi ['WPU'] ['CALLBACK'] = set2kernelcallback4wpu()                                                      # 
         
            message2print = "{(Step W1/33) set" + "; wpu-kernel-set-by-set2kernelcallback4wpu to: " + str(kernel4xi ['WPU'] ['CALLBACK'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
            code2ack  = code2ack + 'W1-'
        else:
            pass    
    except:
        message2print = "{(Step WZ1/33) yielded" + "; wpu-yielded-by-set2kernelcallback4xi: " + 'WPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'WZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step X/33) - XPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step X/33) 
        # ----------------------------------------------------------------------------- 
        if 'XPU' in keys2task:
            message2print = "{(Step X/33) passing" + "; task-passing-to-set2kernelcallback4xpu: " + str(task4set2kernelcallback['XPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            kernel4xi ['XPU'] ['CALLBACK'] = set2kernelcallback4xpu()                                                      # 
         
            message2print = "{(Step X1/33) set" + "; xpu-kernel-set-by-set2kernelcallback4xpu to: " + str(kernel4xi ['XPU'] ['CALLBACK'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
            if debug is True:
                print("{(Step X2/33) of set2kernelcallback4xi - set callback4xi of XPU kernel to: ", kernel4xi ['XPU'] ['CALLBACK'])
            code2ack  = code2ack + 'X1-'
        else:
            pass    
    except:
        message2print = "{(Step XZ1/33) yielded" + "; xpu-yielded-by-set2kernelcallback4xi: " + 'XPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'XZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step Y/33) - YPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step Y/33) 
        # ----------------------------------------------------------------------------- 
        if 'YPU' in keys2task:
            message2print = "{(Step Y/33) passing" + "; task-passing-to-set2kernelcallback4ypu: " + str(task4set2kernelcallback['YPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            kernel4xi ['YPU'] ['CALLBACK'] = set2kernelcallback4ypu()                                                      # 
         
            message2print = "{(Step Y1/33) set" + "; ypu-kernel-set-by-set2kernelcallback4ypu to: " + str(kernel4xi ['YPU'] ['CALLBACK'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
            code2ack  = code2ack + 'Y1-'
        else:
            pass    
    except:
        message2print = "{(Step YZ1/33) yielded" + "; ypu-yielded-by-set2kernelcallback4xi: " + 'YPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'YZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step Z/33) - ZPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step Z/33) 
        # ----------------------------------------------------------------------------- 
        if 'ZPU' in keys2task:
            message2print = "{(Step Z/33) passing" + "; task-passing-to-set2kernelcallback4zpu: " + str(task4set2kernelcallback['ZPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            kernel4xi ['ZPU'] ['CALLBACK'] = set2kernelcallback4zpu()                                                      # 
         
            message2print = "{(Step Z1/33) set" + "; zpu-kernel-set-by-set2kernelcallback4zpu to: " + str(kernel4xi ['ZPU'] ['CALLBACK'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
            if debug is True:
                print("{(Step Z2/33) of set2kernelcallback4xi - set callback4xi of ZPU kernel to: ", kernel4xi ['ZPU'] ['CALLBACK'])
            code2ack  = code2ack + 'Z1-'
        else:
            pass    
    except:
        message2print = "{(Step ZZ1/33) yielded" + "; zpu-yielded-by-set2kernelcallback4xi: " + 'ZPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'ZZ1-'

                                                
    # -----------------------------------------------------------------------------------------
    # (Step 33/3)           
    # -----------------------------------------------------------------------------------------
    if debug is True:
        print("{(Step 33/33) of set2kernelcallback4xi - RETURNING KERNEL4XI: ", kernel4xi)
    
    message2print = "{(Step 33/33) returning" + "; kernel4xi-returning-by-set2kernelcallback4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)
    # 
    
    return kernel4xi
         
#</function4xi> 

# -------------------------------------------------------------------------------------------------
#<function4xi function = "create2kernel4xi" usage = "
#     
#   print('=' *33)          
#   print('(Step 2A/700) OF KERNEL4XI5TEST - TRYING TO CREATE KERNEL FOR XI ', time4xi())      
#   print('=' *33)        
#   # 
#   try:
#       response4create2kernel = create2kernel4xi()                                                                 
#       print('(Step 2B/700) OF KERNEL4XI5TEST - CREATED KERNEL4XI ', time4xi())
#       keys2response = response4create2kernel.keys()
#       for key2response in sorted(keys2response):
#           print(key2response, ' : ', response4create2kernel[key2response])
#           # 
#   except:
#       print('(Step 2Z1/700) OF KERNEL4XI5TEST *** FAILED TO CREATE KERNEL FOR XI *** ', time4xi())
#  
#">

# -------------------------------------------------------------------------------------------------   
def create2kernel4xi(task4create2kernel=None):

    '''
    creates kernel for xi
    '''
    global platform2xi
    global device2xi
    global context2xi 
    global kernel4xi
    global info2kernel4xi                                                                                              
    
    # -----------------------------------------------------------------------------------------
    # (Step 1/70) - CHECK PARAMETERS           
    # -----------------------------------------------------------------------------------------          
    debug = False
        
    class2print = "create2kernel4xi" 
    method2print = "create2kernel4xi"

    message2print = "{(Step 1A/70) started" + "; create2kernel4xi-started: " + str(create2kernel4xi)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)
    # 
  
             
    message2print = "{(Step 1B/70) passed" + "; task4create2kernel-to-create2kernel4xi: " + str(task4create2kernel) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                                                              
    # 

    code2ack  = ' '
    code2nack = ' '    
    
    ack2all = False             
    if task4create2kernel is None:
        # -----------------------------------------------------------------------------------------
        # NO PARAMETERS GIVEN BY CALLER FOR INITIALIZATION - SYSTEM CREATES ALL
        # -----------------------------------------------------------------------------------------    
        ack2all = True                                                                                                
        code2ack  = code2ack + '1C-'
    else:
        # -----------------------------------------------------------------------------------------
        # SOME PARAMETERS GIVEN BY CALLER FOR INITIALIZATION - KERNEL4XI NEEDS INITIALIZATION
        # -----------------------------------------------------------------------------------------        
        try:
            if kernel4xi is None:                                                                                       
                kernel4xi = {} 
                code2ack  = code2ack + '1D-'
        except:
            kernel4xi = {} 
            code2ack  = code2ack + '1D-'
                        
    # -----------------------------------------------------------------------------------------
    # (Step 2/33)
    # -----------------------------------------------------------------------------------------                  
    message2print = "{(Step 2A/3) try" + "; task4create2kernel-try-by-create2kernel4xi: " + str(task4create2kernel)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print) 
    # None 
    
    if ack2all is True:
        try:
            # -----------------------------------------------------------------------------------------
            # (Step 3/33) - ALL DEVICES
            # ----------------------------------------------------------------------------------------- 
            kernel4xi = {}
            message2print = "{(Step 3A/33) initialized" + "; kernel4xi-initialized-by-create2kernel4xi to: " + str(kernel4xi)  + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print)                                                      
            #                                     
            kernel4xi['APU'] = create2kernel4apu()                                                                        
            kernel4xi['BPU'] = create2kernel4bpu()   
            kernel4xi['CPU'] = create2kernel4cpu()   
            kernel4xi['DPU'] = create2kernel4dpu()   
            kernel4xi['EPU'] = create2kernel4epu()   
            kernel4xi['FPU'] = create2kernel4fpu()   
            kernel4xi['GPU'] = create2kernel4gpu()   
            kernel4xi['HPU'] = create2kernel4hpu()   
            kernel4xi['IPU'] = create2kernel4ipu()   
            kernel4xi['JPU'] = create2kernel4jpu()   
            kernel4xi['KPU'] = create2kernel4kpu()   
            kernel4xi['LPU'] = create2kernel4lpu()   
            kernel4xi['MPU'] = create2kernel4mpu()   
            kernel4xi['NPU'] = create2kernel4npu()   
            kernel4xi['OPU'] = create2kernel4opu()   
            kernel4xi['PPU'] = create2kernel4ppu()   
            kernel4xi['QPU'] = create2kernel4qpu()   
            kernel4xi['RPU'] = create2kernel4rpu()   
            kernel4xi['SPU'] = create2kernel4spu()   
            kernel4xi['TPU'] = create2kernel4tpu()   
            kernel4xi['UPU'] = create2kernel4upu()   
            kernel4xi['VPU'] = create2kernel4vpu()   
            kernel4xi['XPU'] = create2kernel4xpu()   
            kernel4xi['WPU'] = create2kernel4wpu()   
            kernel4xi['YPU'] = create2kernel4ypu()   
            kernel4xi['ZPU'] = create2kernel4zpu()   
            
            message2print = "{(Step 3A/33) created" + "; kernel4xi-created-by-create2kernel4xi to: " + str(kernel4xi)  + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print)                                                      
            # 
            
            code2ack  = code2ack + '3A-'
        except:
            message2print = "{(Step 3Z1/33) yielded" + "; kernel4xi-yielded-by-create2kernel4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                               #   
            code2nack  = code2nack + '3Z1-'
    else:    
    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step A/33) - APU
            # -----------------------------------------------------------------------------------------               
            kernel4xi['APU'] = create2kernel4apu(task4create2kernel['APU'])
            
            message2print = "{(Step A/33) initialized" + "; apu-initialized-by-create2kernel4xi to: " + str(kernel4xi['APU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'A-'
        except: 
            message2print = "{(Step AZ1/33) yielded" + "; apu-yielded-by-create2kernel4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'AZ1-'          
        
        try:
            # -----------------------------------------------------------------------------------------
            # (Step B/33) - BPU
            # -----------------------------------------------------------------------------------------               
            kernel4xi['BPU'] = create2kernel4bpu(task4create2kernel['BPU'])
            
            message2print = "{(Step B/33) initialized" + "; bpu-initialized-by-create2kernel4xi to: " + str(kernel4xi['BPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'B-'
        except: 
            message2print = "{(Step BZ1/33) yielded" + "; bpu-yielded-by-create2kernel4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'BZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step C/33) - CPU
            # -----------------------------------------------------------------------------------------               
            kernel4xi['CPU'] = create2kernel4cpu(task4create2kernel['CPU'])
            
            message2print = "{(Step C/33) initialized" + "; cpu-initialized-by-create2kernel4xi to: " + str(kernel4xi['CPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'C-'
        except: 
            message2print = "{(Step CZ1/33) yielded" + "; cpu-yielded-by-create2kernel4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'CZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step D/33) - DPU
            # -----------------------------------------------------------------------------------------               
            kernel4xi['DPU'] = create2kernel4dpu(task4create2kernel['DPU'])
            
            message2print = "{(Step D/33) initialized" + "; dpu-initialized-by-create2kernel4xi to: " + str(kernel4xi['DPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'D-'
        except: 
            message2print = "{(Step DZ1/33) yielded" + "; dpu-yielded-by-create2kernel4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'DZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step E/33) - EPU
            # -----------------------------------------------------------------------------------------               
            kernel4xi['EPU'] = create2kernel4epu(task4create2kernel['EPU'])
            
            message2print = "{(Step E/33) initialized" + "; epu-initialized-by-create2kernel4xi to: " + str(kernel4xi['EPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'E-'
        except: 
            message2print = "{(Step EZ1/33) yielded" + "; epu-yielded-by-create2kernel4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'EZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step F/33) - FPU
            # -----------------------------------------------------------------------------------------               
            kernel4xi['FPU'] = create2kernel4fpu(task4create2kernel['FPU'])
            
            message2print = "{(Step F/33) initialized" + "; fpu-initialized-by-create2kernel4xi to: " + str(kernel4xi['FPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'F-'
        except: 
            message2print = "{(Step FZ1/33) yielded" + "; fpu-yielded-by-create2kernel4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'FZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step G/33) - GPU
            # -----------------------------------------------------------------------------------------               
            kernel4xi['GPU'] = create2kernel4gpu(task4create2kernel['GPU'])
            
            message2print = "{(Step G/33) initialized" + "; gpu-initialized-by-create2kernel4xi to: " + str(kernel4xi['GPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'G-'
        except: 
            message2print = "{(Step GZ1/33) yielded" + "; gpu-yielded-by-create2kernel4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'GZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step H/33) - HPU
            # -----------------------------------------------------------------------------------------               
            kernel4xi['HPU'] = create2kernel4hpu(task4create2kernel['HPU'])
            
            message2print = "{(Step H/33) initialized" + "; hpu-initialized-by-create2kernel4xi to: " + str(kernel4xi['HPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'H-'
        except: 
            message2print = "{(Step HZ1/33) yielded" + "; hpu-yielded-by-create2kernel4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'HZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step I/33) - IPU
            # -----------------------------------------------------------------------------------------               
            kernel4xi['IPU'] = create2kernel4ipu(task4create2kernel['IPU'])
            
            message2print = "{(Step I/33) initialized" + "; ipu-initialized-by-create2kernel4xi to: " + str(kernel4xi['IPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'I-'
        except: 
            message2print = "{(Step IZ1/33) yielded" + "; ipu-yielded-by-create2kernel4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'IZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step J/33) - JPU
            # -----------------------------------------------------------------------------------------               
            kernel4xi['JPU'] = create2kernel4jpu(task4create2kernel['JPU'])
            
            message2print = "{(Step J/33) initialized" + "; jpu-initialized-by-create2kernel4xi to: " + str(kernel4xi['JPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'J-'
        except: 
            message2print = "{(Step JZ1/33) yielded" + "; jpu-yielded-by-create2kernel4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'JZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step K/33) - KPU
            # -----------------------------------------------------------------------------------------               
            kernel4xi['KPU'] = create2kernel4kpu(task4create2kernel['KPU'])
            
            message2print = "{(Step K/33) initialized" + "; kpu-initialized-by-create2kernel4xi to: " + str(kernel4xi['KPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'K-'
        except: 
            message2print = "{(Step KZ1/33) yielded" + "; kpu-yielded-by-create2kernel4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'KZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step L/33) - LPU
            # -----------------------------------------------------------------------------------------               
            kernel4xi['LPU'] = create2kernel4lpu(task4create2kernel['LPU'])
            
            message2print = "{(Step L/33) initialized" + "; lpu-initialized-by-create2kernel4xi to: " + str(kernel4xi['LPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'L-'
        except: 
            message2print = "{(Step LZ1/33) yielded" + "; lpu-yielded-by-create2kernel4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'LZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step M/33) - MPU
            # -----------------------------------------------------------------------------------------               
            kernel4xi['MPU'] = create2kernel4mpu(task4create2kernel['MPU'])
            
            message2print = "{(Step M/33) initialized" + "; mpu-initialized-by-create2kernel4xi to: " + str(kernel4xi['MPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'M-'
        except: 
            message2print = "{(Step MZ1/33) yielded" + "; mpu-yielded-by-create2kernel4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'MZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step N/33) - NPU
            # -----------------------------------------------------------------------------------------               
            kernel4xi['NPU'] = create2kernel4npu(task4create2kernel['NPU'])
            
            message2print = "{(Step N/33) initialized" + "; npu-initialized-by-create2kernel4xi to: " + str(kernel4xi['NPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'N-'
        except: 
            message2print = "{(Step NZ1/33) yielded" + "; npu-yielded-by-create2kernel4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'NZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step O/33) - OPU
            # -----------------------------------------------------------------------------------------               
            kernel4xi['OPU'] = create2kernel4opu(task4create2kernel['OPU'])
            
            message2print = "{(Step O/33) initialized" + "; opu-initialized-by-create2kernel4xi to: " + str(kernel4xi['OPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'O-'
        except: 
            message2print = "{(Step OZ1/33) yielded" + "; opu-yielded-by-create2kernel4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'OZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step P/33) - PPU
            # -----------------------------------------------------------------------------------------               
            kernel4xi['PPU'] = create2kernel4ppu(task4create2kernel['PPU'])
            
            message2print = "{(Step P/33) initialized" + "; ppu-initialized-by-create2kernel4xi to: " + str(kernel4xi['PPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'P-'
        except: 
            message2print = "{(Step PZ1/33) yielded" + "; ppu-yielded-by-create2kernel4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'PZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step Q/33) - QPU
            # -----------------------------------------------------------------------------------------               
            kernel4xi['QPU'] = create2kernel4qpu(task4create2kernel['QPU'])
            
            message2print = "{(Step Q/33) initialized" + "; qpu-initialized-by-create2kernel4xi to: " + str(kernel4xi['QPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'Q-'
        except: 
            message2print = "{(Step QZ1/33) yielded" + "; qpu-yielded-by-create2kernel4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'QZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step R/33) - RPU
            # -----------------------------------------------------------------------------------------               
            kernel4xi['RPU'] = create2kernel4rpu(task4create2kernel['RPU'])
            
            message2print = "{(Step R/33) initialized" + "; rpu-initialized-by-create2kernel4xi to: " + str(kernel4xi['RPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'R-'
        except: 
            message2print = "{(Step RZ1/33) yielded" + "; rpu-yielded-by-create2kernel4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'RZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step S/33) - SPU
            # -----------------------------------------------------------------------------------------               
            kernel4xi['SPU'] = create2kernel4spu(task4create2kernel['SPU'])
            
            message2print = "{(Step S/33) initialized" + "; spu-initialized-by-create2kernel4xi to: " + str(kernel4xi['SPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'S-'
        except: 
            message2print = "{(Step SZ1/33) yielded" + "; spu-yielded-by-create2kernel4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'SZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step T/33) - TPU
            # -----------------------------------------------------------------------------------------               
            kernel4xi['TPU'] = create2kernel4tpu(task4create2kernel['TPU'])
            
            message2print = "{(Step T/33) initialized" + "; tpu-initialized-by-create2kernel4xi to: " + str(kernel4xi['TPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'T-'
        except: 
            message2print = "{(Step TZ1/33) yielded" + "; tpu-yielded-by-create2kernel4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'TZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step U/33) - UPU
            # -----------------------------------------------------------------------------------------               
            kernel4xi['UPU'] = create2kernel4upu(task4create2kernel['UPU'])
            
            message2print = "{(Step U/33) initialized" + "; upu-initialized-by-create2kernel4xi to: " + str(kernel4xi['UPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'U-'
        except: 
            message2print = "{(Step UZ1/33) yielded" + "; upu-yielded-by-create2kernel4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'UZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step V/33) - VPU
            # -----------------------------------------------------------------------------------------               
            kernel4xi['VPU'] = create2kernel4vpu(task4create2kernel['VPU'])
            
            message2print = "{(Step V/33) initialized" + "; vpu-initialized-by-create2kernel4xi to: " + str(kernel4xi['VPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'V-'
        except: 
            message2print = "{(Step VZ1/33) yielded" + "; vpu-yielded-by-create2kernel4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'VZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step W/33) - WPU
            # -----------------------------------------------------------------------------------------               
            kernel4xi['WPU'] = create2kernel4wpu(task4create2kernel['WPU'])
            
            message2print = "{(Step W/33) initialized" + "; wpu-initialized-by-create2kernel4xi to: " + str(kernel4xi['WPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'W-'
        except: 
            message2print = "{(Step WZ1/33) yielded" + "; wpu-yielded-by-create2kernel4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'WZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step X/33) - XPU
            # -----------------------------------------------------------------------------------------               
            kernel4xi['XPU'] = create2kernel4xpu(task4create2kernel['XPU'])
            
            message2print = "{(Step X/33) initialized" + "; xpu-initialized-by-create2kernel4xi to: " + str(kernel4xi['XPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'X-'
        except: 
            message2print = "{(Step XZ1/33) yielded" + "; xpu-yielded-by-create2kernel4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'XZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step Y/33) - YPU
            # -----------------------------------------------------------------------------------------               
            kernel4xi['YPU'] = create2kernel4ypu(task4create2kernel['YPU'])
            
            message2print = "{(Step Y/33) initialized" + "; ypu-initialized-by-create2kernel4xi to: " + str(kernel4xi['YPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'Y-'
        except: 
            message2print = "{(Step YZ1/33) yielded" + "; ypu-yielded-by-create2kernel4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'YZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step Z/33) - ZPU
            # -----------------------------------------------------------------------------------------               
            kernel4xi['ZPU'] = create2kernel4zpu(task4create2kernel['ZPU'])
            
            message2print = "{(Step Z/33) initialized" + "; zpu-initialized-by-create2kernel4xi to: " + str(kernel4xi['ZPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'Z-'
        except: 
            message2print = "{(Step ZZ1/33) yielded" + "; zpu-yielded-by-create2kernel4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'ZZ1-'                 

            
          
    # -----------------------------------------------------------------------------------------
    # (Step 33/3)           
    # -----------------------------------------------------------------------------------------
    if debug is True:
        print("{(Step 33/33) of create2kernel4xi - RETURNING KERNEL4XI: ", kernel4xi)
            
    message2print = "{(Step 33/33) returning" + "; kernel4xi-returning-by-create2kernel4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"  
    print4xi(class2print, method2print, message2print)                                                              
    # 

    return kernel4xi
            
#</function4xi> 

# -------------------------------------------------------------------------------------------------
#<function4xi function = "create2kernelsinprogram4xi" usage = "
#     
#   print('=' *33)          
#   print('(Step 2A/700) OF KERNEL4XI5TEST - TRYING TO CREATE KERNELS IN PROGRAM FOR XI ', time4xi())      
#   print('=' *33)        
#   # 
#   try:
#       response4create2kernelsinprogram = create2kernelsinprogram4xi()                                                                 
#       print('(Step 2B/700) OF KERNEL4XI5TEST - CREATED KERNELS IN PROGRAM FOR XI ', time4xi())
#       keys2response = response4create2kernelsinprogram.keys()
#       for key2response in sorted(keys2response):
#           print(key2response, ' : ', response4create2kernelsinprogram[key2response])
#           # 
#   except:
#       print('(Step 2Z1/700) OF KERNEL4XI5TEST *** FAILED TO CREATE KERNELS IN PROGRAM FOR XI *** ', time4xi())
#  
#">

# -------------------------------------------------------------------------------------------------   
def create2kernelsinprogram4xi(task4create2kernelsinprogram=None):

    '''
    creates kernels in program for xi
    '''
    global platform2xi
    global device2xi
    global context2xi 
    global kernel4xi
    global info2kernel4xi                                                                                              
    
    # -----------------------------------------------------------------------------------------
    # (Step 1/70) - CHECK PARAMETERS           
    # -----------------------------------------------------------------------------------------          
    debug = False
        
    class2print = "create2kernelsinprogram4xi" 
    method2print = "create2kernelsinprogram4xi"

    message2print = "{(Step 1A/70) started" + "; create2kernelsinprogram4xi-started: " + str(create2kernelsinprogram4xi)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)
    # 
  
             
    message2print = "{(Step 1B/70) passed" + "; task4create2kernelsinprogram-to-create2kernelsinprogram4xi: " + str(task4create2kernelsinprogram) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                                                              
    # 

    code2ack  = ' '
    code2nack = ' '    
    
    ack2all = False             
    if task4create2kernelsinprogram is None:
        # -----------------------------------------------------------------------------------------
        # NO PARAMETERS GIVEN BY CALLER FOR INITIALIZATION - SYSTEM CREATES ALL
        # -----------------------------------------------------------------------------------------    
        ack2all = True                                                                                                
        code2ack  = code2ack + '1C-'
    else:
        # -----------------------------------------------------------------------------------------
        # SOME PARAMETERS GIVEN BY CALLER FOR INITIALIZATION - KERNEL4XI NEEDS INITIALIZATION
        # -----------------------------------------------------------------------------------------        
        try:
            if kernel4xi is None:                                                                                       
                kernel4xi = {} 
                code2ack  = code2ack + '1D-'
        except:
            kernel4xi = {} 
            code2ack  = code2ack + '1D-'
                        
    # -----------------------------------------------------------------------------------------
    # (Step 2/33)
    # -----------------------------------------------------------------------------------------                  
    message2print = "{(Step 2A/3) try" + "; task4create2kernelsinprogram-try-by-create2kernelsinprogram4xi: " + str(task4create2kernelsinprogram)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print) 
    # None 
    
    if ack2all is True:
        try:
            # -----------------------------------------------------------------------------------------
            # (Step 3/33) - ALL DEVICES
            # ----------------------------------------------------------------------------------------- 
            kernel4xi = {}
            message2print = "{(Step 3A/33) initialized" + "; kernel4xi-initialized-by-create2kernelsinprogram4xi to: " + str(kernel4xi)  + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print)                                                      
            #                                     
            kernel4xi['APU'] = create2kernelsinprogram4apu()                                                                        
            kernel4xi['BPU'] = create2kernelsinprogram4bpu()   
            kernel4xi['CPU'] = create2kernelsinprogram4cpu()   
            kernel4xi['DPU'] = create2kernelsinprogram4dpu()   
            kernel4xi['EPU'] = create2kernelsinprogram4epu()   
            kernel4xi['FPU'] = create2kernelsinprogram4fpu()   
            kernel4xi['GPU'] = create2kernelsinprogram4gpu()   
            kernel4xi['HPU'] = create2kernelsinprogram4hpu()   
            kernel4xi['IPU'] = create2kernelsinprogram4ipu()   
            kernel4xi['JPU'] = create2kernelsinprogram4jpu()   
            kernel4xi['KPU'] = create2kernelsinprogram4kpu()   
            kernel4xi['LPU'] = create2kernelsinprogram4lpu()   
            kernel4xi['MPU'] = create2kernelsinprogram4mpu()   
            kernel4xi['NPU'] = create2kernelsinprogram4npu()   
            kernel4xi['OPU'] = create2kernelsinprogram4opu()   
            kernel4xi['PPU'] = create2kernelsinprogram4ppu()   
            kernel4xi['QPU'] = create2kernelsinprogram4qpu()   
            kernel4xi['RPU'] = create2kernelsinprogram4rpu()   
            kernel4xi['SPU'] = create2kernelsinprogram4spu()   
            kernel4xi['TPU'] = create2kernelsinprogram4tpu()   
            kernel4xi['UPU'] = create2kernelsinprogram4upu()   
            kernel4xi['VPU'] = create2kernelsinprogram4vpu()   
            kernel4xi['XPU'] = create2kernelsinprogram4xpu()   
            kernel4xi['WPU'] = create2kernelsinprogram4wpu()   
            kernel4xi['YPU'] = create2kernelsinprogram4ypu()   
            kernel4xi['ZPU'] = create2kernelsinprogram4zpu()   
            
            message2print = "{(Step 3A/33) created" + "; kernel4xi-created-by-create2kernelsinprogram4xi to: " + str(kernel4xi)  + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print)                                                      
            # 
            
            code2ack  = code2ack + '3A-'
        except:
            message2print = "{(Step 3Z1/33) yielded" + "; kernel4xi-yielded-by-create2kernelsinprogram4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                               #   
            code2nack  = code2nack + '3Z1-'
    else:    
    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step A/33) - APU
            # -----------------------------------------------------------------------------------------               
            kernel4xi['APU'] = create2kernelsinprogram4apu(task4create2kernelsinprogram['APU'])
            
            message2print = "{(Step A/33) initialized" + "; apu-initialized-by-create2kernelsinprogram4xi to: " + str(kernel4xi['APU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'A-'
        except: 
            message2print = "{(Step AZ1/33) yielded" + "; apu-yielded-by-create2kernelsinprogram4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'AZ1-'          
        
        try:
            # -----------------------------------------------------------------------------------------
            # (Step B/33) - BPU
            # -----------------------------------------------------------------------------------------               
            kernel4xi['BPU'] = create2kernelsinprogram4bpu(task4create2kernelsinprogram['BPU'])
            
            message2print = "{(Step B/33) initialized" + "; bpu-initialized-by-create2kernelsinprogram4xi to: " + str(kernel4xi['BPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'B-'
        except: 
            message2print = "{(Step BZ1/33) yielded" + "; bpu-yielded-by-create2kernelsinprogram4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'BZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step C/33) - CPU
            # -----------------------------------------------------------------------------------------               
            kernel4xi['CPU'] = create2kernelsinprogram4cpu(task4create2kernelsinprogram['CPU'])
            
            message2print = "{(Step C/33) initialized" + "; cpu-initialized-by-create2kernelsinprogram4xi to: " + str(kernel4xi['CPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'C-'
        except: 
            message2print = "{(Step CZ1/33) yielded" + "; cpu-yielded-by-create2kernelsinprogram4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'CZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step D/33) - DPU
            # -----------------------------------------------------------------------------------------               
            kernel4xi['DPU'] = create2kernelsinprogram4dpu(task4create2kernelsinprogram['DPU'])
            
            message2print = "{(Step D/33) initialized" + "; dpu-initialized-by-create2kernelsinprogram4xi to: " + str(kernel4xi['DPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'D-'
        except: 
            message2print = "{(Step DZ1/33) yielded" + "; dpu-yielded-by-create2kernelsinprogram4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'DZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step E/33) - EPU
            # -----------------------------------------------------------------------------------------               
            kernel4xi['EPU'] = create2kernelsinprogram4epu(task4create2kernelsinprogram['EPU'])
            
            message2print = "{(Step E/33) initialized" + "; epu-initialized-by-create2kernelsinprogram4xi to: " + str(kernel4xi['EPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'E-'
        except: 
            message2print = "{(Step EZ1/33) yielded" + "; epu-yielded-by-create2kernelsinprogram4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'EZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step F/33) - FPU
            # -----------------------------------------------------------------------------------------               
            kernel4xi['FPU'] = create2kernelsinprogram4fpu(task4create2kernelsinprogram['FPU'])
            
            message2print = "{(Step F/33) initialized" + "; fpu-initialized-by-create2kernelsinprogram4xi to: " + str(kernel4xi['FPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'F-'
        except: 
            message2print = "{(Step FZ1/33) yielded" + "; fpu-yielded-by-create2kernelsinprogram4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'FZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step G/33) - GPU
            # -----------------------------------------------------------------------------------------               
            kernel4xi['GPU'] = create2kernelsinprogram4gpu(task4create2kernelsinprogram['GPU'])
            
            message2print = "{(Step G/33) initialized" + "; gpu-initialized-by-create2kernelsinprogram4xi to: " + str(kernel4xi['GPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'G-'
        except: 
            message2print = "{(Step GZ1/33) yielded" + "; gpu-yielded-by-create2kernelsinprogram4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'GZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step H/33) - HPU
            # -----------------------------------------------------------------------------------------               
            kernel4xi['HPU'] = create2kernelsinprogram4hpu(task4create2kernelsinprogram['HPU'])
            
            message2print = "{(Step H/33) initialized" + "; hpu-initialized-by-create2kernelsinprogram4xi to: " + str(kernel4xi['HPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'H-'
        except: 
            message2print = "{(Step HZ1/33) yielded" + "; hpu-yielded-by-create2kernelsinprogram4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'HZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step I/33) - IPU
            # -----------------------------------------------------------------------------------------               
            kernel4xi['IPU'] = create2kernelsinprogram4ipu(task4create2kernelsinprogram['IPU'])
            
            message2print = "{(Step I/33) initialized" + "; ipu-initialized-by-create2kernelsinprogram4xi to: " + str(kernel4xi['IPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'I-'
        except: 
            message2print = "{(Step IZ1/33) yielded" + "; ipu-yielded-by-create2kernelsinprogram4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'IZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step J/33) - JPU
            # -----------------------------------------------------------------------------------------               
            kernel4xi['JPU'] = create2kernelsinprogram4jpu(task4create2kernelsinprogram['JPU'])
            
            message2print = "{(Step J/33) initialized" + "; jpu-initialized-by-create2kernelsinprogram4xi to: " + str(kernel4xi['JPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'J-'
        except: 
            message2print = "{(Step JZ1/33) yielded" + "; jpu-yielded-by-create2kernelsinprogram4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'JZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step K/33) - KPU
            # -----------------------------------------------------------------------------------------               
            kernel4xi['KPU'] = create2kernelsinprogram4kpu(task4create2kernelsinprogram['KPU'])
            
            message2print = "{(Step K/33) initialized" + "; kpu-initialized-by-create2kernelsinprogram4xi to: " + str(kernel4xi['KPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'K-'
        except: 
            message2print = "{(Step KZ1/33) yielded" + "; kpu-yielded-by-create2kernelsinprogram4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'KZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step L/33) - LPU
            # -----------------------------------------------------------------------------------------               
            kernel4xi['LPU'] = create2kernelsinprogram4lpu(task4create2kernelsinprogram['LPU'])
            
            message2print = "{(Step L/33) initialized" + "; lpu-initialized-by-create2kernelsinprogram4xi to: " + str(kernel4xi['LPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'L-'
        except: 
            message2print = "{(Step LZ1/33) yielded" + "; lpu-yielded-by-create2kernelsinprogram4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'LZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step M/33) - MPU
            # -----------------------------------------------------------------------------------------               
            kernel4xi['MPU'] = create2kernelsinprogram4mpu(task4create2kernelsinprogram['MPU'])
            
            message2print = "{(Step M/33) initialized" + "; mpu-initialized-by-create2kernelsinprogram4xi to: " + str(kernel4xi['MPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'M-'
        except: 
            message2print = "{(Step MZ1/33) yielded" + "; mpu-yielded-by-create2kernelsinprogram4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'MZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step N/33) - NPU
            # -----------------------------------------------------------------------------------------               
            kernel4xi['NPU'] = create2kernelsinprogram4npu(task4create2kernelsinprogram['NPU'])
            
            message2print = "{(Step N/33) initialized" + "; npu-initialized-by-create2kernelsinprogram4xi to: " + str(kernel4xi['NPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'N-'
        except: 
            message2print = "{(Step NZ1/33) yielded" + "; npu-yielded-by-create2kernelsinprogram4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'NZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step O/33) - OPU
            # -----------------------------------------------------------------------------------------               
            kernel4xi['OPU'] = create2kernelsinprogram4opu(task4create2kernelsinprogram['OPU'])
            
            message2print = "{(Step O/33) initialized" + "; opu-initialized-by-create2kernelsinprogram4xi to: " + str(kernel4xi['OPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'O-'
        except: 
            message2print = "{(Step OZ1/33) yielded" + "; opu-yielded-by-create2kernelsinprogram4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'OZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step P/33) - PPU
            # -----------------------------------------------------------------------------------------               
            kernel4xi['PPU'] = create2kernelsinprogram4ppu(task4create2kernelsinprogram['PPU'])
            
            message2print = "{(Step P/33) initialized" + "; ppu-initialized-by-create2kernelsinprogram4xi to: " + str(kernel4xi['PPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'P-'
        except: 
            message2print = "{(Step PZ1/33) yielded" + "; ppu-yielded-by-create2kernelsinprogram4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'PZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step Q/33) - QPU
            # -----------------------------------------------------------------------------------------               
            kernel4xi['QPU'] = create2kernelsinprogram4qpu(task4create2kernelsinprogram['QPU'])
            
            message2print = "{(Step Q/33) initialized" + "; qpu-initialized-by-create2kernelsinprogram4xi to: " + str(kernel4xi['QPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'Q-'
        except: 
            message2print = "{(Step QZ1/33) yielded" + "; qpu-yielded-by-create2kernelsinprogram4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'QZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step R/33) - RPU
            # -----------------------------------------------------------------------------------------               
            kernel4xi['RPU'] = create2kernelsinprogram4rpu(task4create2kernelsinprogram['RPU'])
            
            message2print = "{(Step R/33) initialized" + "; rpu-initialized-by-create2kernelsinprogram4xi to: " + str(kernel4xi['RPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'R-'
        except: 
            message2print = "{(Step RZ1/33) yielded" + "; rpu-yielded-by-create2kernelsinprogram4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'RZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step S/33) - SPU
            # -----------------------------------------------------------------------------------------               
            kernel4xi['SPU'] = create2kernelsinprogram4spu(task4create2kernelsinprogram['SPU'])
            
            message2print = "{(Step S/33) initialized" + "; spu-initialized-by-create2kernelsinprogram4xi to: " + str(kernel4xi['SPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'S-'
        except: 
            message2print = "{(Step SZ1/33) yielded" + "; spu-yielded-by-create2kernelsinprogram4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'SZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step T/33) - TPU
            # -----------------------------------------------------------------------------------------               
            kernel4xi['TPU'] = create2kernelsinprogram4tpu(task4create2kernelsinprogram['TPU'])
            
            message2print = "{(Step T/33) initialized" + "; tpu-initialized-by-create2kernelsinprogram4xi to: " + str(kernel4xi['TPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'T-'
        except: 
            message2print = "{(Step TZ1/33) yielded" + "; tpu-yielded-by-create2kernelsinprogram4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'TZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step U/33) - UPU
            # -----------------------------------------------------------------------------------------               
            kernel4xi['UPU'] = create2kernelsinprogram4upu(task4create2kernelsinprogram['UPU'])
            
            message2print = "{(Step U/33) initialized" + "; upu-initialized-by-create2kernelsinprogram4xi to: " + str(kernel4xi['UPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'U-'
        except: 
            message2print = "{(Step UZ1/33) yielded" + "; upu-yielded-by-create2kernelsinprogram4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'UZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step V/33) - VPU
            # -----------------------------------------------------------------------------------------               
            kernel4xi['VPU'] = create2kernelsinprogram4vpu(task4create2kernelsinprogram['VPU'])
            
            message2print = "{(Step V/33) initialized" + "; vpu-initialized-by-create2kernelsinprogram4xi to: " + str(kernel4xi['VPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'V-'
        except: 
            message2print = "{(Step VZ1/33) yielded" + "; vpu-yielded-by-create2kernelsinprogram4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'VZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step W/33) - WPU
            # -----------------------------------------------------------------------------------------               
            kernel4xi['WPU'] = create2kernelsinprogram4wpu(task4create2kernelsinprogram['WPU'])
            
            message2print = "{(Step W/33) initialized" + "; wpu-initialized-by-create2kernelsinprogram4xi to: " + str(kernel4xi['WPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'W-'
        except: 
            message2print = "{(Step WZ1/33) yielded" + "; wpu-yielded-by-create2kernelsinprogram4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'WZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step X/33) - XPU
            # -----------------------------------------------------------------------------------------               
            kernel4xi['XPU'] = create2kernelsinprogram4xpu(task4create2kernelsinprogram['XPU'])
            
            message2print = "{(Step X/33) initialized" + "; xpu-initialized-by-create2kernelsinprogram4xi to: " + str(kernel4xi['XPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'X-'
        except: 
            message2print = "{(Step XZ1/33) yielded" + "; xpu-yielded-by-create2kernelsinprogram4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'XZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step Y/33) - YPU
            # -----------------------------------------------------------------------------------------               
            kernel4xi['YPU'] = create2kernelsinprogram4ypu(task4create2kernelsinprogram['YPU'])
            
            message2print = "{(Step Y/33) initialized" + "; ypu-initialized-by-create2kernelsinprogram4xi to: " + str(kernel4xi['YPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'Y-'
        except: 
            message2print = "{(Step YZ1/33) yielded" + "; ypu-yielded-by-create2kernelsinprogram4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'YZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step Z/33) - ZPU
            # -----------------------------------------------------------------------------------------               
            kernel4xi['ZPU'] = create2kernelsinprogram4zpu(task4create2kernelsinprogram['ZPU'])
            
            message2print = "{(Step Z/33) initialized" + "; zpu-initialized-by-create2kernelsinprogram4xi to: " + str(kernel4xi['ZPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'Z-'
        except: 
            message2print = "{(Step ZZ1/33) yielded" + "; zpu-yielded-by-create2kernelsinprogram4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'ZZ1-'                 

            
          
    # -----------------------------------------------------------------------------------------
    # (Step 33/3)           
    # -----------------------------------------------------------------------------------------
    if debug is True:
        print("{(Step 33/33) of create2kernelsinprogram4xi - RETURNING KERNEL4XI: ", kernel4xi)
            
    message2print = "{(Step 33/33) returning" + "; kernel4xi-returning-by-create2kernelsinprogram4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"  
    print4xi(class2print, method2print, message2print)                                                              
    # 

    return kernel4xi
            
#</function4xi> 



# -------------------------------------------------------------------------------------------------
#<function4xi function = "set2kernel4xi" usage = "
#     
#   print('=' *33)          
#   print('(Step 2A/700) OF KERNEL4XI5TEST - TRYING TO SET KERNEL FOR XI ', time4xi())      
#   print('=' *33)        
#   # 
#   try:
#       response4set2kernel = set2kernel4xi()                                                                 
#       print('(Step 2B/700) OF KERNEL4XI5TEST - SET KERNEL FOR XI ', time4xi())
#       keys2response = response4set2kernel.keys()
#       for key2response in sorted(keys2response):
#           print(key2response, ' : ', response4set2kernel[key2response])
#           # 
#   except:
#       print('(Step 2Z1/700) OF KERNEL4XI5TEST *** FAILED TO SET KERNEL FOR XI *** ', time4xi())
#   
#">

# -------------------------------------------------------------------------------------------------   
def set2kernel4xi(task4set2kernel=None):

    '''
    sets kernel  for xi
    '''
    global platform2xi
    global device2xi
    global context2xi 
    global kernel4xi
    global info2kernel4xi                                                                                              
    
    # -----------------------------------------------------------------------------------------
    # (Step 1/70) - START           
    # -----------------------------------------------------------------------------------------          
    debug = False
    response4set2kernel = {}
        
    class2print = "set2kernel4xi" 
    method2print = "set2kernel4xi"

    message2print = "{(Step 1A/70) started" + "; set2kernel4xi-started: " + str(set2kernel4xi)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)
    # 
  
             
    message2print = "{(Step 1B/70) passed" + "; task4set2kernel-to-set2kernel4xi: " + str(task4set2kernel) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                                                              
    # 

    code2ack  = ' '
    code2nack = ' '    
    
    ack2all = False             
    if task4set2kernel is None:
        # -----------------------------------------------------------------------------------------
        # NO PARAMETERS GIVEN BY CALLER FOR INITIALIZATION - SYSTEM CREATES ALL
        # -----------------------------------------------------------------------------------------    
        ack2all = True                                                                                                
        code2ack  = code2ack + '1C-'
    else:
        # -----------------------------------------------------------------------------------------
        # SOME PARAMETERS GIVEN BY CALLER FOR INITIALIZATION - KERNEL4XI NEEDS INITIALIZATION
        # -----------------------------------------------------------------------------------------        
        try:
            if kernel4xi is None:                                                                                       
                kernel4xi = create2kernel4xi()
                code2ack  = code2ack + '1D-'
        except:
            kernel4xi = create2kernel4xi()
            code2ack  = code2ack + '1D-'
                        
    # -----------------------------------------------------------------------------------------
    # (Step 2/33)
    # -----------------------------------------------------------------------------------------                  
    message2print = "{(Step 2A/3) try" + "; task4set2kernel-try-by-set2kernel4xi: " + str(task4set2kernel)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print) 
    # None 
    
    if ack2all is True:
        try:
            # -----------------------------------------------------------------------------------------
            # (Step 3/33) - ALL DEVICES
            # ----------------------------------------------------------------------------------------- 
            response4set2kernel['APU'] = set2kernel4apu()                                                                        
            response4set2kernel['BPU'] = set2kernel4bpu()   
            response4set2kernel['CPU'] = set2kernel4cpu()   
            response4set2kernel['DPU'] = set2kernel4dpu()   
            response4set2kernel['EPU'] = set2kernel4epu()   
            response4set2kernel['FPU'] = set2kernel4fpu()   
            response4set2kernel['GPU'] = set2kernel4gpu()   
            response4set2kernel['HPU'] = set2kernel4hpu()   
            response4set2kernel['IPU'] = set2kernel4ipu()   
            response4set2kernel['JPU'] = set2kernel4jpu()   
            response4set2kernel['KPU'] = set2kernel4kpu()   
            response4set2kernel['LPU'] = set2kernel4lpu()   
            response4set2kernel['MPU'] = set2kernel4mpu()   
            response4set2kernel['NPU'] = set2kernel4npu()   
            response4set2kernel['OPU'] = set2kernel4opu()   
            response4set2kernel['PPU'] = set2kernel4ppu()   
            response4set2kernel['QPU'] = set2kernel4qpu()   
            response4set2kernel['RPU'] = set2kernel4rpu()   
            response4set2kernel['SPU'] = set2kernel4spu()   
            response4set2kernel['TPU'] = set2kernel4tpu()   
            response4set2kernel['UPU'] = set2kernel4upu()   
            response4set2kernel['VPU'] = set2kernel4vpu()   
            response4set2kernel['XPU'] = set2kernel4xpu()   
            response4set2kernel['WPU'] = set2kernel4wpu()   
            response4set2kernel['YPU'] = set2kernel4ypu()   
            response4set2kernel['ZPU'] = set2kernel4zpu()   
            
            message2print = "{(Step 3A/33) got" + "; kernel4xi-got-by-set2kernel4xi: " + str(response4set2kernel)  + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print)                                                      
            # 
            
            code2ack  = code2ack + '3A-'
        except:
            message2print = "{(Step 3Z1/33) yielded" + "; kernel4xi-yielded-by-set2kernel4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                               #   
            code2nack  = code2nack + '3Z1-'
    else:    
    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step A/33) - APU
            # -----------------------------------------------------------------------------------------               
            response4set2kernel['APU'] = set2kernel4apu(task4set2kernel['APU'])
            
            message2print = "{(Step A/33) got" + "; apu-got-by-set2kernel4xi: " + str(response4set2kernel['APU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'A-'
        except: 
            message2print = "{(Step AZ1/33) yielded" + "; apu-yielded-by-set2kernel4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'AZ1-'          
        
        try:
            # -----------------------------------------------------------------------------------------
            # (Step B/33) - BPU
            # -----------------------------------------------------------------------------------------               
            response4set2kernel['BPU'] = set2kernel4bpu(task4set2kernel['BPU'])
            
            message2print = "{(Step B/33) got" + "; bpu-got-by-set2kernel4xi: " + str(response4set2kernel['BPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'B-'
        except: 
            message2print = "{(Step BZ1/33) yielded" + "; bpu-yielded-by-set2kernel4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'BZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step C/33) - CPU
            # -----------------------------------------------------------------------------------------               
            response4set2kernel['CPU'] = set2kernel4cpu(task4set2kernel['CPU'])
            
            message2print = "{(Step C/33) got" + "; cpu-got-by-set2kernel4xi: " + str(response4set2kernel['CPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'C-'
        except: 
            message2print = "{(Step CZ1/33) yielded" + "; cpu-yielded-by-set2kernel4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'CZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step D/33) - DPU
            # -----------------------------------------------------------------------------------------               
            response4set2kernel['DPU'] = set2kernel4dpu(task4set2kernel['DPU'])
            
            message2print = "{(Step D/33) got" + "; dpu-got-by-set2kernel4xi: " + str(response4set2kernel['DPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'D-'
        except: 
            message2print = "{(Step DZ1/33) yielded" + "; dpu-yielded-by-set2kernel4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'DZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step E/33) - EPU
            # -----------------------------------------------------------------------------------------               
            response4set2kernel['EPU'] = set2kernel4epu(task4set2kernel['EPU'])
            
            message2print = "{(Step E/33) got" + "; epu-got-by-set2kernel4xi: " + str(response4set2kernel['EPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'E-'
        except: 
            message2print = "{(Step EZ1/33) yielded" + "; epu-yielded-by-set2kernel4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'EZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step F/33) - FPU
            # -----------------------------------------------------------------------------------------               
            response4set2kernel['FPU'] = set2kernel4fpu(task4set2kernel['FPU'])
            
            message2print = "{(Step F/33) got" + "; fpu-got-by-set2kernel4xi: " + str(response4set2kernel['FPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'F-'
        except: 
            message2print = "{(Step FZ1/33) yielded" + "; fpu-yielded-by-set2kernel4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'FZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step G/33) - GPU
            # -----------------------------------------------------------------------------------------               
            response4set2kernel['GPU'] = set2kernel4gpu(task4set2kernel['GPU'])
            
            message2print = "{(Step G/33) got" + "; gpu-got-by-set2kernel4xi: " + str(response4set2kernel['GPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'G-'
        except: 
            message2print = "{(Step GZ1/33) yielded" + "; gpu-yielded-by-set2kernel4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'GZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step H/33) - HPU
            # -----------------------------------------------------------------------------------------               
            response4set2kernel['HPU'] = set2kernel4hpu(task4set2kernel['HPU'])
            
            message2print = "{(Step H/33) got" + "; hpu-got-by-set2kernel4xi: " + str(response4set2kernel['HPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'H-'
        except: 
            message2print = "{(Step HZ1/33) yielded" + "; hpu-yielded-by-set2kernel4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'HZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step I/33) - IPU
            # -----------------------------------------------------------------------------------------               
            response4set2kernel['IPU'] = set2kernel4ipu(task4set2kernel['IPU'])
            
            message2print = "{(Step I/33) got" + "; ipu-got-by-set2kernel4xi: " + str(response4set2kernel['IPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'I-'
        except: 
            message2print = "{(Step IZ1/33) yielded" + "; ipu-yielded-by-set2kernel4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'IZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step J/33) - JPU
            # -----------------------------------------------------------------------------------------               
            response4set2kernel['JPU'] = set2kernel4jpu(task4set2kernel['JPU'])
            
            message2print = "{(Step J/33) got" + "; jpu-got-by-set2kernel4xi: " + str(response4set2kernel['JPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'J-'
        except: 
            message2print = "{(Step JZ1/33) yielded" + "; jpu-yielded-by-set2kernel4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'JZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step K/33) - KPU
            # -----------------------------------------------------------------------------------------               
            response4set2kernel['KPU'] = set2kernel4kpu(task4set2kernel['KPU'])
            
            message2print = "{(Step K/33) got" + "; kpu-got-by-set2kernel4xi: " + str(response4set2kernel['KPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'K-'
        except: 
            message2print = "{(Step KZ1/33) yielded" + "; kpu-yielded-by-set2kernel4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'KZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step L/33) - LPU
            # -----------------------------------------------------------------------------------------               
            response4set2kernel['LPU'] = set2kernel4lpu(task4set2kernel['LPU'])
            
            message2print = "{(Step L/33) got" + "; lpu-got-by-set2kernel4xi: " + str(response4set2kernel['LPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'L-'
        except: 
            message2print = "{(Step LZ1/33) yielded" + "; lpu-yielded-by-set2kernel4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'LZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step M/33) - MPU
            # -----------------------------------------------------------------------------------------               
            response4set2kernel['MPU'] = set2kernel4mpu(task4set2kernel['MPU'])
            
            message2print = "{(Step M/33) got" + "; mpu-got-by-set2kernel4xi: " + str(response4set2kernel['MPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'M-'
        except: 
            message2print = "{(Step MZ1/33) yielded" + "; mpu-yielded-by-set2kernel4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'MZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step N/33) - NPU
            # -----------------------------------------------------------------------------------------               
            response4set2kernel['NPU'] = set2kernel4npu(task4set2kernel['NPU'])
            
            message2print = "{(Step N/33) got" + "; npu-got-by-set2kernel4xi: " + str(response4set2kernel['NPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'N-'
        except: 
            message2print = "{(Step NZ1/33) yielded" + "; npu-yielded-by-set2kernel4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'NZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step O/33) - OPU
            # -----------------------------------------------------------------------------------------               
            response4set2kernel['OPU'] = set2kernel4opu(task4set2kernel['OPU'])
            
            message2print = "{(Step O/33) got" + "; opu-got-by-set2kernel4xi: " + str(response4set2kernel['OPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'O-'
        except: 
            message2print = "{(Step OZ1/33) yielded" + "; opu-yielded-by-set2kernel4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'OZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step P/33) - PPU
            # -----------------------------------------------------------------------------------------               
            response4set2kernel['PPU'] = set2kernel4ppu(task4set2kernel['PPU'])
            
            message2print = "{(Step P/33) got" + "; ppu-got-by-set2kernel4xi: " + str(response4set2kernel['PPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'P-'
        except: 
            message2print = "{(Step PZ1/33) yielded" + "; ppu-yielded-by-set2kernel4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'PZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step Q/33) - QPU
            # -----------------------------------------------------------------------------------------               
            response4set2kernel['QPU'] = set2kernel4qpu(task4set2kernel['QPU'])
            
            message2print = "{(Step Q/33) got" + "; qpu-got-by-set2kernel4xi: " + str(response4set2kernel['QPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'Q-'
        except: 
            message2print = "{(Step QZ1/33) yielded" + "; qpu-yielded-by-set2kernel4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'QZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step R/33) - RPU
            # -----------------------------------------------------------------------------------------               
            response4set2kernel['RPU'] = set2kernel4rpu(task4set2kernel['RPU'])
            
            message2print = "{(Step R/33) got" + "; rpu-got-by-set2kernel4xi: " + str(response4set2kernel['RPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'R-'
        except: 
            message2print = "{(Step RZ1/33) yielded" + "; rpu-yielded-by-set2kernel4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'RZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step S/33) - SPU
            # -----------------------------------------------------------------------------------------               
            response4set2kernel['SPU'] = set2kernel4spu(task4set2kernel['SPU'])
            
            message2print = "{(Step S/33) got" + "; spu-got-by-set2kernel4xi: " + str(response4set2kernel['SPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'S-'
        except: 
            message2print = "{(Step SZ1/33) yielded" + "; spu-yielded-by-set2kernel4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'SZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step T/33) - TPU
            # -----------------------------------------------------------------------------------------               
            response4set2kernel['TPU'] = set2kernel4tpu(task4set2kernel['TPU'])
            
            message2print = "{(Step T/33) got" + "; tpu-got-by-set2kernel4xi: " + str(response4set2kernel['TPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'T-'
        except: 
            message2print = "{(Step TZ1/33) yielded" + "; tpu-yielded-by-set2kernel4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'TZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step U/33) - UPU
            # -----------------------------------------------------------------------------------------               
            response4set2kernel['UPU'] = set2kernel4upu(task4set2kernel['UPU'])
            
            message2print = "{(Step U/33) got" + "; upu-got-by-set2kernel4xi: " + str(response4set2kernel['UPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'U-'
        except: 
            message2print = "{(Step UZ1/33) yielded" + "; upu-yielded-by-set2kernel4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'UZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step V/33) - VPU
            # -----------------------------------------------------------------------------------------               
            response4set2kernel['VPU'] = set2kernel4vpu(task4set2kernel['VPU'])
            
            message2print = "{(Step V/33) got" + "; vpu-got-by-set2kernel4xi: " + str(response4set2kernel['VPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'V-'
        except: 
            message2print = "{(Step VZ1/33) yielded" + "; vpu-yielded-by-set2kernel4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'VZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step W/33) - WPU
            # -----------------------------------------------------------------------------------------               
            response4set2kernel['WPU'] = set2kernel4wpu(task4set2kernel['WPU'])
            
            message2print = "{(Step W/33) got" + "; wpu-got-by-set2kernel4xi: " + str(response4set2kernel['WPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'W-'
        except: 
            message2print = "{(Step WZ1/33) yielded" + "; wpu-yielded-by-set2kernel4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'WZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step X/33) - XPU
            # -----------------------------------------------------------------------------------------               
            response4set2kernel['XPU'] = set2kernel4xpu(task4set2kernel['XPU'])
            
            message2print = "{(Step X/33) got" + "; xpu-got-by-set2kernel4xi: " + str(response4set2kernel['XPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'X-'
        except: 
            message2print = "{(Step XZ1/33) yielded" + "; xpu-yielded-by-set2kernel4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'XZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step Y/33) - YPU
            # -----------------------------------------------------------------------------------------               
            response4set2kernel['YPU'] = set2kernel4ypu(task4set2kernel['YPU'])
            
            message2print = "{(Step Y/33) got" + "; ypu-got-by-set2kernel4xi: " + str(response4set2kernel['YPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'Y-'
        except: 
            message2print = "{(Step YZ1/33) yielded" + "; ypu-yielded-by-set2kernel4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'YZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step Z/33) - ZPU
            # -----------------------------------------------------------------------------------------               
            response4set2kernel['ZPU'] = set2kernel4zpu(task4set2kernel['ZPU'])
            
            message2print = "{(Step Z/33) got" + "; zpu-got-by-set2kernel4xi: " + str(response4set2kernel['ZPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'Z-'
        except: 
            message2print = "{(Step ZZ1/33) yielded" + "; zpu-yielded-by-set2kernel4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'ZZ1-'                 

            
          
    # -----------------------------------------------------------------------------------------
    # (Step 33/3)           
    # -----------------------------------------------------------------------------------------
    if debug is True:
        print("{(Step 33/33) of set2kernel4xi - RETURNING response4set2kernel: ", response4set2kernel)
            
    message2print = "{(Step 33/33) returning" + "; response4set2kernel-returning-by-set2kernel4xi: " + str(response4set2kernel) + "; time: " + time4xi() + "}"  
    print4xi(class2print, method2print, message2print)                                                              
    # 

    return response4set2kernel
            
#</function4xi>  


# -------------------------------------------------------------------------------------------------
#<function4xi function = "set2kernelarg4xi" usage = "
#     
#   print('=' *33)          
#   print('(Step 2A/700) OF KERNEL4XI5TEST - TRYING TO SET KERNEL ARGS FOR XI ', time4xi())      
#   print('=' *33)        
#   # 
#   try:
#       response4set2kernelarg = set2kernelarg4xi()                                                                 
#       print('(Step 2B/700) OF KERNEL4XI5TEST - SET KERNEL ARGS FOR XI ', time4xi())
#       keys2response = response4set2kernelarg.keys()
#       for key2response in sorted(keys2response):
#           print(key2response, ' : ', response4set2kernelarg[key2response])
#           # 
#   except:
#       print('(Step 2Z1/700) OF KERNEL4XI5TEST *** FAILED TO SET KERNEL ARGS FOR XI *** ', time4xi())
#   
#">

# -------------------------------------------------------------------------------------------------   
def set2kernelarg4xi(task4set2kernelarg=None):

    '''
    sets kernel arguments for xi
    '''
    global platform2xi
    global device2xi
    global context2xi 
    global kernel4xi
    global info2kernel4xi                                                                                              
    
    # -----------------------------------------------------------------------------------------
    # (Step 1/70) - START           
    # -----------------------------------------------------------------------------------------          
    debug = False
    response4set2kernelarg = {}
        
    class2print = "set2kernelarg4xi" 
    method2print = "set2kernelarg4xi"

    message2print = "{(Step 1A/70) started" + "; set2kernelarg4xi-started: " + str(set2kernelarg4xi)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)
    # 
  
             
    message2print = "{(Step 1B/70) passed" + "; task4set2kernelarg-to-set2kernelarg4xi: " + str(task4set2kernelarg) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                                                              
    # 

    code2ack  = ' '
    code2nack = ' '    
    
    ack2all = False             
    if task4set2kernelarg is None:
        # -----------------------------------------------------------------------------------------
        # NO PARAMETERS GIVEN BY CALLER FOR INITIALIZATION - SYSTEM CREATES ALL
        # -----------------------------------------------------------------------------------------    
        ack2all = True                                                                                                
        code2ack  = code2ack + '1C-'
    else:
        # -----------------------------------------------------------------------------------------
        # SOME PARAMETERS GIVEN BY CALLER FOR INITIALIZATION - KERNEL4XI NEEDS INITIALIZATION
        # -----------------------------------------------------------------------------------------        
        try:
            if kernel4xi is None:                                                                                       
                kernel4xi = create2kernel4xi()
                code2ack  = code2ack + '1D-'
        except:
            kernel4xi = create2kernel4xi()
            code2ack  = code2ack + '1D-'
                        
    # -----------------------------------------------------------------------------------------
    # (Step 2/33)
    # -----------------------------------------------------------------------------------------                  
    message2print = "{(Step 2A/3) try" + "; task4set2kernelarg-try-by-set2kernelarg4xi: " + str(task4set2kernelarg)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print) 
    # None 
    
    if ack2all is True:
        try:
            # -----------------------------------------------------------------------------------------
            # (Step 3/33) - ALL DEVICES
            # ----------------------------------------------------------------------------------------- 
            response4set2kernelarg['APU'] = set2kernelarg4apu()                                                                        
            response4set2kernelarg['BPU'] = set2kernelarg4bpu()   
            response4set2kernelarg['CPU'] = set2kernelarg4cpu()   
            response4set2kernelarg['DPU'] = set2kernelarg4dpu()   
            response4set2kernelarg['EPU'] = set2kernelarg4epu()   
            response4set2kernelarg['FPU'] = set2kernelarg4fpu()   
            response4set2kernelarg['GPU'] = set2kernelarg4gpu()   
            response4set2kernelarg['HPU'] = set2kernelarg4hpu()   
            response4set2kernelarg['IPU'] = set2kernelarg4ipu()   
            response4set2kernelarg['JPU'] = set2kernelarg4jpu()   
            response4set2kernelarg['KPU'] = set2kernelarg4kpu()   
            response4set2kernelarg['LPU'] = set2kernelarg4lpu()   
            response4set2kernelarg['MPU'] = set2kernelarg4mpu()   
            response4set2kernelarg['NPU'] = set2kernelarg4npu()   
            response4set2kernelarg['OPU'] = set2kernelarg4opu()   
            response4set2kernelarg['PPU'] = set2kernelarg4ppu()   
            response4set2kernelarg['QPU'] = set2kernelarg4qpu()   
            response4set2kernelarg['RPU'] = set2kernelarg4rpu()   
            response4set2kernelarg['SPU'] = set2kernelarg4spu()   
            response4set2kernelarg['TPU'] = set2kernelarg4tpu()   
            response4set2kernelarg['UPU'] = set2kernelarg4upu()   
            response4set2kernelarg['VPU'] = set2kernelarg4vpu()   
            response4set2kernelarg['XPU'] = set2kernelarg4xpu()   
            response4set2kernelarg['WPU'] = set2kernelarg4wpu()   
            response4set2kernelarg['YPU'] = set2kernelarg4ypu()   
            response4set2kernelarg['ZPU'] = set2kernelarg4zpu()   
            
            message2print = "{(Step 3A/33) got" + "; kernel4xi-got-by-set2kernelarg4xi: " + str(response4set2kernelarg)  + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print)                                                      
            # 
            
            code2ack  = code2ack + '3A-'
        except:
            message2print = "{(Step 3Z1/33) yielded" + "; kernel4xi-yielded-by-set2kernelarg4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                               #   
            code2nack  = code2nack + '3Z1-'
    else:    
    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step A/33) - APU
            # -----------------------------------------------------------------------------------------               
            response4set2kernelarg['APU'] = set2kernelarg4apu(task4set2kernelarg['APU'])
            
            message2print = "{(Step A/33) got" + "; apu-got-by-set2kernelarg4xi: " + str(response4set2kernelarg['APU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'A-'
        except: 
            message2print = "{(Step AZ1/33) yielded" + "; apu-yielded-by-set2kernelarg4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'AZ1-'          
        
        try:
            # -----------------------------------------------------------------------------------------
            # (Step B/33) - BPU
            # -----------------------------------------------------------------------------------------               
            response4set2kernelarg['BPU'] = set2kernelarg4bpu(task4set2kernelarg['BPU'])
            
            message2print = "{(Step B/33) got" + "; bpu-got-by-set2kernelarg4xi: " + str(response4set2kernelarg['BPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'B-'
        except: 
            message2print = "{(Step BZ1/33) yielded" + "; bpu-yielded-by-set2kernelarg4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'BZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step C/33) - CPU
            # -----------------------------------------------------------------------------------------               
            response4set2kernelarg['CPU'] = set2kernelarg4cpu(task4set2kernelarg['CPU'])
            
            message2print = "{(Step C/33) got" + "; cpu-got-by-set2kernelarg4xi: " + str(response4set2kernelarg['CPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'C-'
        except: 
            message2print = "{(Step CZ1/33) yielded" + "; cpu-yielded-by-set2kernelarg4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'CZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step D/33) - DPU
            # -----------------------------------------------------------------------------------------               
            response4set2kernelarg['DPU'] = set2kernelarg4dpu(task4set2kernelarg['DPU'])
            
            message2print = "{(Step D/33) got" + "; dpu-got-by-set2kernelarg4xi: " + str(response4set2kernelarg['DPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'D-'
        except: 
            message2print = "{(Step DZ1/33) yielded" + "; dpu-yielded-by-set2kernelarg4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'DZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step E/33) - EPU
            # -----------------------------------------------------------------------------------------               
            response4set2kernelarg['EPU'] = set2kernelarg4epu(task4set2kernelarg['EPU'])
            
            message2print = "{(Step E/33) got" + "; epu-got-by-set2kernelarg4xi: " + str(response4set2kernelarg['EPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'E-'
        except: 
            message2print = "{(Step EZ1/33) yielded" + "; epu-yielded-by-set2kernelarg4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'EZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step F/33) - FPU
            # -----------------------------------------------------------------------------------------               
            response4set2kernelarg['FPU'] = set2kernelarg4fpu(task4set2kernelarg['FPU'])
            
            message2print = "{(Step F/33) got" + "; fpu-got-by-set2kernelarg4xi: " + str(response4set2kernelarg['FPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'F-'
        except: 
            message2print = "{(Step FZ1/33) yielded" + "; fpu-yielded-by-set2kernelarg4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'FZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step G/33) - GPU
            # -----------------------------------------------------------------------------------------               
            response4set2kernelarg['GPU'] = set2kernelarg4gpu(task4set2kernelarg['GPU'])
            
            message2print = "{(Step G/33) got" + "; gpu-got-by-set2kernelarg4xi: " + str(response4set2kernelarg['GPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'G-'
        except: 
            message2print = "{(Step GZ1/33) yielded" + "; gpu-yielded-by-set2kernelarg4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'GZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step H/33) - HPU
            # -----------------------------------------------------------------------------------------               
            response4set2kernelarg['HPU'] = set2kernelarg4hpu(task4set2kernelarg['HPU'])
            
            message2print = "{(Step H/33) got" + "; hpu-got-by-set2kernelarg4xi: " + str(response4set2kernelarg['HPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'H-'
        except: 
            message2print = "{(Step HZ1/33) yielded" + "; hpu-yielded-by-set2kernelarg4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'HZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step I/33) - IPU
            # -----------------------------------------------------------------------------------------               
            response4set2kernelarg['IPU'] = set2kernelarg4ipu(task4set2kernelarg['IPU'])
            
            message2print = "{(Step I/33) got" + "; ipu-got-by-set2kernelarg4xi: " + str(response4set2kernelarg['IPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'I-'
        except: 
            message2print = "{(Step IZ1/33) yielded" + "; ipu-yielded-by-set2kernelarg4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'IZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step J/33) - JPU
            # -----------------------------------------------------------------------------------------               
            response4set2kernelarg['JPU'] = set2kernelarg4jpu(task4set2kernelarg['JPU'])
            
            message2print = "{(Step J/33) got" + "; jpu-got-by-set2kernelarg4xi: " + str(response4set2kernelarg['JPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'J-'
        except: 
            message2print = "{(Step JZ1/33) yielded" + "; jpu-yielded-by-set2kernelarg4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'JZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step K/33) - KPU
            # -----------------------------------------------------------------------------------------               
            response4set2kernelarg['KPU'] = set2kernelarg4kpu(task4set2kernelarg['KPU'])
            
            message2print = "{(Step K/33) got" + "; kpu-got-by-set2kernelarg4xi: " + str(response4set2kernelarg['KPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'K-'
        except: 
            message2print = "{(Step KZ1/33) yielded" + "; kpu-yielded-by-set2kernelarg4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'KZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step L/33) - LPU
            # -----------------------------------------------------------------------------------------               
            response4set2kernelarg['LPU'] = set2kernelarg4lpu(task4set2kernelarg['LPU'])
            
            message2print = "{(Step L/33) got" + "; lpu-got-by-set2kernelarg4xi: " + str(response4set2kernelarg['LPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'L-'
        except: 
            message2print = "{(Step LZ1/33) yielded" + "; lpu-yielded-by-set2kernelarg4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'LZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step M/33) - MPU
            # -----------------------------------------------------------------------------------------               
            response4set2kernelarg['MPU'] = set2kernelarg4mpu(task4set2kernelarg['MPU'])
            
            message2print = "{(Step M/33) got" + "; mpu-got-by-set2kernelarg4xi: " + str(response4set2kernelarg['MPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'M-'
        except: 
            message2print = "{(Step MZ1/33) yielded" + "; mpu-yielded-by-set2kernelarg4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'MZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step N/33) - NPU
            # -----------------------------------------------------------------------------------------               
            response4set2kernelarg['NPU'] = set2kernelarg4npu(task4set2kernelarg['NPU'])
            
            message2print = "{(Step N/33) got" + "; npu-got-by-set2kernelarg4xi: " + str(response4set2kernelarg['NPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'N-'
        except: 
            message2print = "{(Step NZ1/33) yielded" + "; npu-yielded-by-set2kernelarg4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'NZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step O/33) - OPU
            # -----------------------------------------------------------------------------------------               
            response4set2kernelarg['OPU'] = set2kernelarg4opu(task4set2kernelarg['OPU'])
            
            message2print = "{(Step O/33) got" + "; opu-got-by-set2kernelarg4xi: " + str(response4set2kernelarg['OPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'O-'
        except: 
            message2print = "{(Step OZ1/33) yielded" + "; opu-yielded-by-set2kernelarg4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'OZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step P/33) - PPU
            # -----------------------------------------------------------------------------------------               
            response4set2kernelarg['PPU'] = set2kernelarg4ppu(task4set2kernelarg['PPU'])
            
            message2print = "{(Step P/33) got" + "; ppu-got-by-set2kernelarg4xi: " + str(response4set2kernelarg['PPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'P-'
        except: 
            message2print = "{(Step PZ1/33) yielded" + "; ppu-yielded-by-set2kernelarg4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'PZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step Q/33) - QPU
            # -----------------------------------------------------------------------------------------               
            response4set2kernelarg['QPU'] = set2kernelarg4qpu(task4set2kernelarg['QPU'])
            
            message2print = "{(Step Q/33) got" + "; qpu-got-by-set2kernelarg4xi: " + str(response4set2kernelarg['QPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'Q-'
        except: 
            message2print = "{(Step QZ1/33) yielded" + "; qpu-yielded-by-set2kernelarg4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'QZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step R/33) - RPU
            # -----------------------------------------------------------------------------------------               
            response4set2kernelarg['RPU'] = set2kernelarg4rpu(task4set2kernelarg['RPU'])
            
            message2print = "{(Step R/33) got" + "; rpu-got-by-set2kernelarg4xi: " + str(response4set2kernelarg['RPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'R-'
        except: 
            message2print = "{(Step RZ1/33) yielded" + "; rpu-yielded-by-set2kernelarg4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'RZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step S/33) - SPU
            # -----------------------------------------------------------------------------------------               
            response4set2kernelarg['SPU'] = set2kernelarg4spu(task4set2kernelarg['SPU'])
            
            message2print = "{(Step S/33) got" + "; spu-got-by-set2kernelarg4xi: " + str(response4set2kernelarg['SPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'S-'
        except: 
            message2print = "{(Step SZ1/33) yielded" + "; spu-yielded-by-set2kernelarg4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'SZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step T/33) - TPU
            # -----------------------------------------------------------------------------------------               
            response4set2kernelarg['TPU'] = set2kernelarg4tpu(task4set2kernelarg['TPU'])
            
            message2print = "{(Step T/33) got" + "; tpu-got-by-set2kernelarg4xi: " + str(response4set2kernelarg['TPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'T-'
        except: 
            message2print = "{(Step TZ1/33) yielded" + "; tpu-yielded-by-set2kernelarg4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'TZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step U/33) - UPU
            # -----------------------------------------------------------------------------------------               
            response4set2kernelarg['UPU'] = set2kernelarg4upu(task4set2kernelarg['UPU'])
            
            message2print = "{(Step U/33) got" + "; upu-got-by-set2kernelarg4xi: " + str(response4set2kernelarg['UPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'U-'
        except: 
            message2print = "{(Step UZ1/33) yielded" + "; upu-yielded-by-set2kernelarg4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'UZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step V/33) - VPU
            # -----------------------------------------------------------------------------------------               
            response4set2kernelarg['VPU'] = set2kernelarg4vpu(task4set2kernelarg['VPU'])
            
            message2print = "{(Step V/33) got" + "; vpu-got-by-set2kernelarg4xi: " + str(response4set2kernelarg['VPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'V-'
        except: 
            message2print = "{(Step VZ1/33) yielded" + "; vpu-yielded-by-set2kernelarg4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'VZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step W/33) - WPU
            # -----------------------------------------------------------------------------------------               
            response4set2kernelarg['WPU'] = set2kernelarg4wpu(task4set2kernelarg['WPU'])
            
            message2print = "{(Step W/33) got" + "; wpu-got-by-set2kernelarg4xi: " + str(response4set2kernelarg['WPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'W-'
        except: 
            message2print = "{(Step WZ1/33) yielded" + "; wpu-yielded-by-set2kernelarg4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'WZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step X/33) - XPU
            # -----------------------------------------------------------------------------------------               
            response4set2kernelarg['XPU'] = set2kernelarg4xpu(task4set2kernelarg['XPU'])
            
            message2print = "{(Step X/33) got" + "; xpu-got-by-set2kernelarg4xi: " + str(response4set2kernelarg['XPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'X-'
        except: 
            message2print = "{(Step XZ1/33) yielded" + "; xpu-yielded-by-set2kernelarg4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'XZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step Y/33) - YPU
            # -----------------------------------------------------------------------------------------               
            response4set2kernelarg['YPU'] = set2kernelarg4ypu(task4set2kernelarg['YPU'])
            
            message2print = "{(Step Y/33) got" + "; ypu-got-by-set2kernelarg4xi: " + str(response4set2kernelarg['YPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'Y-'
        except: 
            message2print = "{(Step YZ1/33) yielded" + "; ypu-yielded-by-set2kernelarg4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'YZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step Z/33) - ZPU
            # -----------------------------------------------------------------------------------------               
            response4set2kernelarg['ZPU'] = set2kernelarg4zpu(task4set2kernelarg['ZPU'])
            
            message2print = "{(Step Z/33) got" + "; zpu-got-by-set2kernelarg4xi: " + str(response4set2kernelarg['ZPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'Z-'
        except: 
            message2print = "{(Step ZZ1/33) yielded" + "; zpu-yielded-by-set2kernelarg4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'ZZ1-'                 

            
          
    # -----------------------------------------------------------------------------------------
    # (Step 33/3)           
    # -----------------------------------------------------------------------------------------
    if debug is True:
        print("{(Step 33/33) of set2kernelarg4xi - RETURNING response4set2kernelarg: ", response4set2kernelarg)
            
    message2print = "{(Step 33/33) returning" + "; response4set2kernelarg-returning-by-set2kernelarg4xi: " + str(response4set2kernelarg) + "; time: " + time4xi() + "}"  
    print4xi(class2print, method2print, message2print)                                                              
    # 

    return response4set2kernelarg
            
#</function4xi>  


# -------------------------------------------------------------------------------------------------
#<function4xi function = "release2kernel4xi" usage = "
#     
#   print('=' *33)          
#   print('(Step 2A/700) OF KERNEL4XI5TEST - TRYING TO RELEASE KERNEL OF XI ', time4xi())      
#   print('=' *33)        
#   # 
#   try:
#       response4release2kernel = release2kernel4xi()                                                                 
#       print('(Step 2B/700) OF KERNEL4XI5TEST - RELEASE XI ', time4xi())
#       keys2response = response4release2kernel.keys()
#       for key2response in sorted(keys2response):
#           print(key2response, ' : ', response4release2kernel[key2response])
#           # 
#   except:
#       print('(Step 2Z1/700) OF KERNEL4XI5TEST *** FAILED TO RELEASE KERNEL OF XI *** ', time4xi())
#
#">

# -------------------------------------------------------------------------------------------------   
def release2kernel4xi(task4release2kernel=None):

    '''
    release kernel of xi
    '''
    global kernel4xi
    global platform2xi
    global device2xi
    global context2xi 
                                                                                         
    
    # -----------------------------------------------------------------------------------------
    # (Step 1/70) - START            
    # -----------------------------------------------------------------------------------------          
    debug = False
    response4release2kernel = None
    keys2task4release = task4release2kernel.keys()     
    class2print = "release2kernel4xi" 
    method2print = "release2kernel4xi"

    message2print = "{(Step 1A/70) started" + "; release2kernel4xi-started: " + str(release2kernel4xi)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)
    # 
  
             
    message2print = "{(Step 1B/70) passed" + "; task4release2kernel-to-release2kernel4xi: " + str(task4release2kernel) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                                                              
    # 

    code2ack  = ' '
    code2nack = ' '    
    
    ack2all = False             
    if task4release2kernel is None:
        # -----------------------------------------------------------------------------------------
        # NO PARAMETERS GIVEN BY CALLER FOR INITIALIZATION - SYSTEM CREATES ALL
        # -----------------------------------------------------------------------------------------    
        ack2all = True                                                                                                
        code2ack  = code2ack + '1C-'
    else:
        # -----------------------------------------------------------------------------------------
        # SOME PARAMETERS GIVEN BY CALLER FOR INITIALIZATION - KERNEL4XI NEEDS INITIALIZATION
        # -----------------------------------------------------------------------------------------        
        try:
            if response4release2kernel is None:                                                                                       
                response4release2kernel = create2kernel4xi() 
                code2ack  = code2ack + '1D-'
        except:
            response4release2kernel = create2kernel4xi()
            code2ack  = code2ack + '1D-'
                        
    # -----------------------------------------------------------------------------------------
    # (Step 2/33)
    # -----------------------------------------------------------------------------------------                  
    message2print = "{(Step 2A/3) try" + "; task4release2kernel-try-by-release2kernel4xi: " + str(task4release2kernel)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print) 
    # None 
    
    if ack2all is True:
        try:
            # -----------------------------------------------------------------------------------------
            # (Step 3/33) - ALL DEVICES
            # ----------------------------------------------------------------------------------------- 
            response4release2kernel = release2kernel4apu()                                                                        
            response4release2kernel = release2kernel4bpu()   
            response4release2kernel = release2kernel4cpu()   
            response4release2kernel = release2kernel4dpu()   
            response4release2kernel = release2kernel4epu()   
            response4release2kernel = release2kernel4fpu()   
            response4release2kernel = release2kernel4gpu()   
            response4release2kernel = release2kernel4hpu()   
            response4release2kernel = release2kernel4ipu()   
            response4release2kernel = release2kernel4jpu()   
            response4release2kernel = release2kernel4kpu()   
            response4release2kernel = release2kernel4lpu()   
            response4release2kernel = release2kernel4mpu()   
            response4release2kernel = release2kernel4npu()   
            response4release2kernel = release2kernel4opu()   
            response4release2kernel = release2kernel4ppu()   
            response4release2kernel = release2kernel4qpu()   
            response4release2kernel = release2kernel4rpu()   
            response4release2kernel = release2kernel4spu()   
            response4release2kernel = release2kernel4tpu()   
            response4release2kernel = release2kernel4upu()   
            response4release2kernel = release2kernel4vpu()   
            response4release2kernel = release2kernel4xpu()   
            response4release2kernel = release2kernel4wpu()   
            response4release2kernel = release2kernel4ypu()   
            response4release2kernel = release2kernel4zpu()   
            
            message2print = "{(Step 3A/33) set" + "; response4release2kernel-set-by-release2kernel4xi to: " + str(response4release2kernel)  + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print)                                                      
            # 
            
            code2ack  = code2ack + '3A-'
        except:
            message2print = "{(Step 3Z1/33) yielded" + "; response4release2kernel-yielded-by-release2kernel4xi: " + str(response4release2kernel) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                               #   
            code2nack  = code2nack + '3Z1-'
    else:    
        if 'APU' in keys2task4release:   
            try:
                # -----------------------------------------------------------------------------------------
                # (Step A/33) - APU
                # -----------------------------------------------------------------------------------------               
                response4release2kernel  = release2kernel4apu()
            
                message2print = "{(Step A/33) calculated" + "; apu-calculated-by-release2kernel4xi to: " + str(response4release2kernel)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'A-'
            except: 
                message2print = "{(Step AZ1/33) yielded" + "; apu-yielded-by-release2kernel4xi: " + str(response4release2kernel) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'AZ1-'          
        if 'BPU' in keys2task4release:
            try:
                # -----------------------------------------------------------------------------------------
                # (Step B/33) - BPU
                # -----------------------------------------------------------------------------------------               
                response4release2kernel   = release2kernel4bpu()
            
                message2print = "{(Step B/33) calculated" + "; bpu-calculated-by-release2kernel4xi to: " + str(response4release2kernel)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'B-'
            except: 
                message2print = "{(Step BZ1/33) yielded" + "; bpu-yielded-by-release2kernel4xi: " + str(response4release2kernel) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'BZ1-'     
        if 'CPU' in keys2task4release:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step C/33) - CPU
                # -----------------------------------------------------------------------------------------               
                response4release2kernel   = release2kernel4cpu()
            
                message2print = "{(Step C/33) calculated" + "; cpu-calculated-by-release2kernel4xi to: " + str(response4release2kernel)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'C-'
            except: 
                message2print = "{(Step CZ1/33) yielded" + "; cpu-yielded-by-release2kernel4xi: " + str(response4release2kernel) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'CZ1-'     
        if 'DPU' in keys2task4release:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step D/33) - DPU
                # -----------------------------------------------------------------------------------------               
                response4release2kernel   = release2kernel4dpu()
            
                message2print = "{(Step D/33) calculated" + "; dpu-calculated-by-release2kernel4xi to: " + str(response4release2kernel)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'D-'
            except: 
                message2print = "{(Step DZ1/33) yielded" + "; dpu-yielded-by-release2kernel4xi: " + str(response4release2kernel) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'DZ1-'     
        if 'EPU' in keys2task4release:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step E/33) - EPU
                # -----------------------------------------------------------------------------------------               
                response4release2kernel   = release2kernel4epu()
            
                message2print = "{(Step E/33) calculated" + "; epu-calculated-by-release2kernel4xi to: " + str(response4release2kernel)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'E-'
            except: 
                message2print = "{(Step EZ1/33) yielded" + "; epu-yielded-by-release2kernel4xi: " + str(response4release2kernel) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'EZ1-'     
        if 'FPU' in keys2task4release:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step F/33) - FPU
                # -----------------------------------------------------------------------------------------               
                response4release2kernel   = release2kernel4fpu()
            
                message2print = "{(Step F/33) calculated" + "; fpu-calculated-by-release2kernel4xi to: " + str(response4release2kernel)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'F-'
            except: 
                message2print = "{(Step FZ1/33) yielded" + "; fpu-yielded-by-release2kernel4xi: " + str(response4release2kernel) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'FZ1-'     
        if 'GPU' in keys2task4release:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step G/33) - GPU
                # -----------------------------------------------------------------------------------------               
                response4release2kernel   = release2kernel4gpu()
            
                message2print = "{(Step G/33) calculated" + "; gpu-calculated-by-release2kernel4xi to: " + str(response4release2kernel)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'G-'
            except: 
                message2print = "{(Step GZ1/33) yielded" + "; gpu-yielded-by-release2kernel4xi: " + str(response4release2kernel) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'GZ1-'     
        if 'HPU' in keys2task4release:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step H/33) - HPU
                # -----------------------------------------------------------------------------------------               
                response4release2kernel   = release2kernel4hpu()
            
                message2print = "{(Step H/33) calculated" + "; hpu-calculated-by-release2kernel4xi to: " + str(response4release2kernel)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'H-'
            except: 
                message2print = "{(Step HZ1/33) yielded" + "; hpu-yielded-by-release2kernel4xi: " + str(response4release2kernel) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'HZ1-'     
        if 'IPU' in keys2task4release:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step I/33) - IPU
                # -----------------------------------------------------------------------------------------               
                response4release2kernel   = release2kernel4ipu()
            
                message2print = "{(Step I/33) calculated" + "; ipu-calculated-by-release2kernel4xi to: " + str(response4release2kernel)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'I-'
            except: 
                message2print = "{(Step IZ1/33) yielded" + "; ipu-yielded-by-release2kernel4xi: " + str(response4release2kernel) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'IZ1-'     
        if 'JPU' in keys2task4release:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step J/33) - JPU
                # -----------------------------------------------------------------------------------------               
                response4release2kernel   = release2kernel4jpu()
            
                message2print = "{(Step J/33) calculated" + "; jpu-calculated-by-release2kernel4xi to: " + str(response4release2kernel)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'J-'
            except: 
                message2print = "{(Step JZ1/33) yielded" + "; jpu-yielded-by-release2kernel4xi: " + str(response4release2kernel) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'JZ1-'     
        if 'KPU' in keys2task4release:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step K/33) - KPU
                # -----------------------------------------------------------------------------------------               
                response4release2kernel   = release2kernel4kpu()
            
                message2print = "{(Step K/33) calculated" + "; kpu-calculated-by-release2kernel4xi to: " + str(response4release2kernel)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'K-'
            except: 
                message2print = "{(Step KZ1/33) yielded" + "; kpu-yielded-by-release2kernel4xi: " + str(response4release2kernel) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'KZ1-'     
        if 'LPU' in keys2task4release:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step L/33) - LPU
                # -----------------------------------------------------------------------------------------               
                response4release2kernel   = release2kernel4lpu()
            
                message2print = "{(Step L/33) calculated" + "; lpu-calculated-by-release2kernel4xi to: " + str(response4release2kernel)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'L-'
            except: 
                message2print = "{(Step LZ1/33) yielded" + "; lpu-yielded-by-release2kernel4xi: " + str(response4release2kernel) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'LZ1-'     
        if 'MPU' in keys2task4release:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step M/33) - MPU
                # -----------------------------------------------------------------------------------------               
                response4release2kernel   = release2kernel4mpu()
            
                message2print = "{(Step M/33) calculated" + "; mpu-calculated-by-release2kernel4xi to: " + str(response4release2kernel)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'M-'
            except: 
                message2print = "{(Step MZ1/33) yielded" + "; mpu-yielded-by-release2kernel4xi: " + str(response4release2kernel) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'MZ1-'     
        if 'NPU' in keys2task4release:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step N/33) - NPU
                # -----------------------------------------------------------------------------------------               
                response4release2kernel   = release2kernel4npu()
            
                message2print = "{(Step N/33) calculated" + "; npu-calculated-by-release2kernel4xi to: " + str(response4release2kernel)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'N-'
            except: 
                message2print = "{(Step NZ1/33) yielded" + "; npu-yielded-by-release2kernel4xi: " + str(response4release2kernel) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'NZ1-'     
        if 'OPU' in keys2task4release:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step O/33) - OPU
                # -----------------------------------------------------------------------------------------               
                response4release2kernel   = release2kernel4opu()
            
                message2print = "{(Step O/33) calculated" + "; opu-calculated-by-release2kernel4xi to: " + str(response4release2kernel)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'O-'
            except: 
                message2print = "{(Step OZ1/33) yielded" + "; opu-yielded-by-release2kernel4xi: " + str(response4release2kernel) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'OZ1-'     
        if 'PPU' in keys2task4release:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step P/33) - PPU
                # -----------------------------------------------------------------------------------------               
                response4release2kernel   = release2kernel4ppu()
            
                message2print = "{(Step P/33) calculated" + "; ppu-calculated-by-release2kernel4xi to: " + str(response4release2kernel)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'P-'
            except: 
                message2print = "{(Step PZ1/33) yielded" + "; ppu-yielded-by-release2kernel4xi: " + str(response4release2kernel) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'PZ1-'     
        if 'QPU' in keys2task4release:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step Q/33) - QPU
                # -----------------------------------------------------------------------------------------               
                response4release2kernel   = release2kernel4qpu()
            
                message2print = "{(Step Q/33) calculated" + "; qpu-calculated-by-release2kernel4xi to: " + str(response4release2kernel)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'Q-'
            except: 
                message2print = "{(Step QZ1/33) yielded" + "; qpu-yielded-by-release2kernel4xi: " + str(response4release2kernel) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'QZ1-'     
        if 'RPU' in keys2task4release:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step R/33) - RPU
                # -----------------------------------------------------------------------------------------               
                response4release2kernel   = release2kernel4rpu()
            
                message2print = "{(Step R/33) calculated" + "; rpu-calculated-by-release2kernel4xi to: " + str(response4release2kernel)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'R-'
            except: 
                message2print = "{(Step RZ1/33) yielded" + "; rpu-yielded-by-release2kernel4xi: " + str(response4release2kernel) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'RZ1-'     
        if 'SPU' in keys2task4release:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step S/33) - SPU
                # -----------------------------------------------------------------------------------------               
                response4release2kernel   = release2kernel4spu()
            
                message2print = "{(Step S/33) calculated" + "; spu-calculated-by-release2kernel4xi to: " + str(response4release2kernel)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'S-'
            except: 
                message2print = "{(Step SZ1/33) yielded" + "; spu-yielded-by-release2kernel4xi: " + str(response4release2kernel) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'SZ1-'     
        if 'TPU' in keys2task4release:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step T/33) - TPU
                # -----------------------------------------------------------------------------------------               
                response4release2kernel   = release2kernel4tpu()
            
                message2print = "{(Step T/33) calculated" + "; tpu-calculated-by-release2kernel4xi to: " + str(response4release2kernel)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'T-'
            except: 
                message2print = "{(Step TZ1/33) yielded" + "; tpu-yielded-by-release2kernel4xi: " + str(response4release2kernel) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'TZ1-'     
        if 'UPU' in keys2task4release:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step U/33) - UPU
                # -----------------------------------------------------------------------------------------               
                response4release2kernel   = release2kernel4upu()
            
                message2print = "{(Step U/33) calculated" + "; upu-calculated-by-release2kernel4xi to: " + str(response4release2kernel)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'U-'
            except: 
                message2print = "{(Step UZ1/33) yielded" + "; upu-yielded-by-release2kernel4xi: " + str(response4release2kernel) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'UZ1-'     
        if 'VPU' in keys2task4release:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step V/33) - VPU
                # -----------------------------------------------------------------------------------------               
                response4release2kernel   = release2kernel4vpu()
            
                message2print = "{(Step V/33) calculated" + "; vpu-calculated-by-release2kernel4xi to: " + str(response4release2kernel)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'V-'
            except: 
                message2print = "{(Step VZ1/33) yielded" + "; vpu-yielded-by-release2kernel4xi: " + str(response4release2kernel) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'VZ1-'     
        if 'WPU' in keys2task4release:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step W/33) - WPU
                # -----------------------------------------------------------------------------------------               
                response4release2kernel   = release2kernel4wpu()
            
                message2print = "{(Step W/33) calculated" + "; wpu-calculated-by-release2kernel4xi to: " + str(response4release2kernel)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'W-'
            except: 
                message2print = "{(Step WZ1/33) yielded" + "; wpu-yielded-by-release2kernel4xi: " + str(response4release2kernel) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'WZ1-'     
        if 'XPU' in keys2task4release:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step X/33) - XPU
                # -----------------------------------------------------------------------------------------               
                response4release2kernel   = release2kernel4xpu()
            
                message2print = "{(Step X/33) calculated" + "; xpu-calculated-by-release2kernel4xi to: " + str(response4release2kernel)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'X-'
            except: 
                message2print = "{(Step XZ1/33) yielded" + "; xpu-yielded-by-release2kernel4xi: " + str(response4release2kernel) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'XZ1-'     
        if 'YPU' in keys2task4release:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step Y/33) - YPU
                # -----------------------------------------------------------------------------------------               
                response4release2kernel   = release2kernel4ypu()
            
                message2print = "{(Step Y/33) calculated" + "; ypu-calculated-by-release2kernel4xi to: " + str(response4release2kernel)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'Y-'
            except: 
                message2print = "{(Step YZ1/33) yielded" + "; ypu-yielded-by-release2kernel4xi: " + str(response4release2kernel) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'YZ1-'     
        if 'ZPU' in keys2task4release:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step Z/33) - ZPU
                # -----------------------------------------------------------------------------------------               
                response4release2kernel   = release2kernel4zpu()
            
                message2print = "{(Step Z/33) calculated" + "; zpu-calculated-by-release2kernel4xi to: " + str(response4release2kernel)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'Z-'
            except: 
                message2print = "{(Step ZZ1/33) yielded" + "; zpu-yielded-by-release2kernel4xi: " + str(response4release2kernel) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'ZZ1-'                 

            
          
    # -----------------------------------------------------------------------------------------
    # (Step 33/3)           
    # -----------------------------------------------------------------------------------------
    if debug is True:
        print("{(Step 33/33) of release2kernel4xi - RETURNING KERNEL4XI: ", kernel4xi)
            
    message2print = "{(Step 33/33) returning" + "; kernel4xi-returning-by-release2kernel4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"  
    print4xi(class2print, method2print, message2print)                                                              
    # 

    return kernel4xi
            
#</function4xi>  

# -------------------------------------------------------------------------------------------------
#<function4xi function = "retain2kernel4xi" usage = "
#     
#   print('=' *33)          
#   print('(Step 2A/700) OF KERNEL4XI5TEST - TRYING TO RETAIN KERNEL OF XI ', time4xi())      
#   print('=' *33)        
#   # 
#   try:
#       response4retain2kernel = retain2kernel4xi()                                                                 
#       print('(Step 2B/700) OF KERNEL4XI5TEST - RETAIN XI ', time4xi())
#       keys2response = response4retain2kernel.keys()
#       for key2response in sorted(keys2response):
#           print(key2response, ' : ', response4retain2kernel[key2response])
#           # 
#   except:
#       print('(Step 2Z1/700) OF KERNEL4XI5TEST *** FAILED TO RETAIN KERNEL OF XI *** ', time4xi())
#
#">

# -------------------------------------------------------------------------------------------------   
def retain2kernel4xi(task4retain2kernel=None):

    '''
    retains kernel of xi
    '''
    global kernel4xi
    global platform2xi
    global device2xi
    global context2xi 
                                                                                            
    
    # -----------------------------------------------------------------------------------------
    # (Step 1/70) - START            
    # -----------------------------------------------------------------------------------------          
    debug = False
    response4retain2kernel = None
    keys2task4retain = task4retain2kernel.keys()     
    class2print = "retain2kernel4xi" 
    method2print = "retain2kernel4xi"

    message2print = "{(Step 1A/70) started" + "; retain2kernel4xi-started: " + str(retain2kernel4xi)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)
    # 
  
             
    message2print = "{(Step 1B/70) passed" + "; task4retain2kernel-to-retain2kernel4xi: " + str(task4retain2kernel) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                                                              
    # 

    code2ack  = ' '
    code2nack = ' '    
    
    ack2all = False             
    if task4retain2kernel is None:
        # -----------------------------------------------------------------------------------------
        # NO PARAMETERS GIVEN BY CALLER FOR INITIALIZATION - SYSTEM CREATES ALL
        # -----------------------------------------------------------------------------------------    
        ack2all = True                                                                                                
        code2ack  = code2ack + '1C-'
    else:
        # -----------------------------------------------------------------------------------------
        # SOME PARAMETERS GIVEN BY CALLER FOR INITIALIZATION - KERNEL4XI NEEDS INITIALIZATION
        # -----------------------------------------------------------------------------------------        
        try:
            if response4retain2kernel is None:                                                                                       
                response4retain2kernel = create2kernel4xi() 
                code2ack  = code2ack + '1D-'
        except:
            response4retain2kernel = create2kernel4xi()
            code2ack  = code2ack + '1D-'
                        
    # -----------------------------------------------------------------------------------------
    # (Step 2/33)
    # -----------------------------------------------------------------------------------------                  
    message2print = "{(Step 2A/3) try" + "; task4retain2kernel-try-by-retain2kernel4xi: " + str(task4retain2kernel)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print) 
    # None 
    
    if ack2all is True:
        try:
            # -----------------------------------------------------------------------------------------
            # (Step 3/33) - ALL DEVICES
            # ----------------------------------------------------------------------------------------- 
            response4retain2kernel = retain2kernel4apu()                                                                        
            response4retain2kernel = retain2kernel4bpu()   
            response4retain2kernel = retain2kernel4cpu()   
            response4retain2kernel = retain2kernel4dpu()   
            response4retain2kernel = retain2kernel4epu()   
            response4retain2kernel = retain2kernel4fpu()   
            response4retain2kernel = retain2kernel4gpu()   
            response4retain2kernel = retain2kernel4hpu()   
            response4retain2kernel = retain2kernel4ipu()   
            response4retain2kernel = retain2kernel4jpu()   
            response4retain2kernel = retain2kernel4kpu()   
            response4retain2kernel = retain2kernel4lpu()   
            response4retain2kernel = retain2kernel4mpu()   
            response4retain2kernel = retain2kernel4npu()   
            response4retain2kernel = retain2kernel4opu()   
            response4retain2kernel = retain2kernel4ppu()   
            response4retain2kernel = retain2kernel4qpu()   
            response4retain2kernel = retain2kernel4rpu()   
            response4retain2kernel = retain2kernel4spu()   
            response4retain2kernel = retain2kernel4tpu()   
            response4retain2kernel = retain2kernel4upu()   
            response4retain2kernel = retain2kernel4vpu()   
            response4retain2kernel = retain2kernel4xpu()   
            response4retain2kernel = retain2kernel4wpu()   
            response4retain2kernel = retain2kernel4ypu()   
            response4retain2kernel = retain2kernel4zpu()   
            
            message2print = "{(Step 3A/33) set" + "; response4retain2kernel-set-by-retain2kernel4xi to: " + str(response4retain2kernel)  + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print)                                                      
            # 
            
            code2ack  = code2ack + '3A-'
        except:
            message2print = "{(Step 3Z1/33) yielded" + "; response4retain2kernel-yielded-by-retain2kernel4xi: " + str(response4retain2kernel) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                               #   
            code2nack  = code2nack + '3Z1-'
    else:    
        if 'APU' in keys2task4retain:   
            try:
                # -----------------------------------------------------------------------------------------
                # (Step A/33) - APU
                # -----------------------------------------------------------------------------------------               
                response4retain2kernel  = retain2kernel4apu()
            
                message2print = "{(Step A/33) calculated" + "; apu-calculated-by-retain2kernel4xi to: " + str(response4retain2kernel)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'A-'
            except: 
                message2print = "{(Step AZ1/33) yielded" + "; apu-yielded-by-retain2kernel4xi: " + str(response4retain2kernel) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'AZ1-'          
        if 'BPU' in keys2task4retain:
            try:
                # -----------------------------------------------------------------------------------------
                # (Step B/33) - BPU
                # -----------------------------------------------------------------------------------------               
                response4retain2kernel   = retain2kernel4bpu()
            
                message2print = "{(Step B/33) calculated" + "; bpu-calculated-by-retain2kernel4xi to: " + str(response4retain2kernel)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'B-'
            except: 
                message2print = "{(Step BZ1/33) yielded" + "; bpu-yielded-by-retain2kernel4xi: " + str(response4retain2kernel) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'BZ1-'     
        if 'CPU' in keys2task4retain:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step C/33) - CPU
                # -----------------------------------------------------------------------------------------               
                response4retain2kernel   = retain2kernel4cpu()
            
                message2print = "{(Step C/33) calculated" + "; cpu-calculated-by-retain2kernel4xi to: " + str(response4retain2kernel)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'C-'
            except: 
                message2print = "{(Step CZ1/33) yielded" + "; cpu-yielded-by-retain2kernel4xi: " + str(response4retain2kernel) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'CZ1-'     
        if 'DPU' in keys2task4retain:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step D/33) - DPU
                # -----------------------------------------------------------------------------------------               
                response4retain2kernel   = retain2kernel4dpu()
            
                message2print = "{(Step D/33) calculated" + "; dpu-calculated-by-retain2kernel4xi to: " + str(response4retain2kernel)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'D-'
            except: 
                message2print = "{(Step DZ1/33) yielded" + "; dpu-yielded-by-retain2kernel4xi: " + str(response4retain2kernel) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'DZ1-'     
        if 'EPU' in keys2task4retain:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step E/33) - EPU
                # -----------------------------------------------------------------------------------------               
                response4retain2kernel   = retain2kernel4epu()
            
                message2print = "{(Step E/33) calculated" + "; epu-calculated-by-retain2kernel4xi to: " + str(response4retain2kernel)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'E-'
            except: 
                message2print = "{(Step EZ1/33) yielded" + "; epu-yielded-by-retain2kernel4xi: " + str(response4retain2kernel) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'EZ1-'     
        if 'FPU' in keys2task4retain:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step F/33) - FPU
                # -----------------------------------------------------------------------------------------               
                response4retain2kernel   = retain2kernel4fpu()
            
                message2print = "{(Step F/33) calculated" + "; fpu-calculated-by-retain2kernel4xi to: " + str(response4retain2kernel)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'F-'
            except: 
                message2print = "{(Step FZ1/33) yielded" + "; fpu-yielded-by-retain2kernel4xi: " + str(response4retain2kernel) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'FZ1-'     
        if 'GPU' in keys2task4retain:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step G/33) - GPU
                # -----------------------------------------------------------------------------------------               
                response4retain2kernel   = retain2kernel4gpu()
            
                message2print = "{(Step G/33) calculated" + "; gpu-calculated-by-retain2kernel4xi to: " + str(response4retain2kernel)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'G-'
            except: 
                message2print = "{(Step GZ1/33) yielded" + "; gpu-yielded-by-retain2kernel4xi: " + str(response4retain2kernel) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'GZ1-'     
        if 'HPU' in keys2task4retain:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step H/33) - HPU
                # -----------------------------------------------------------------------------------------               
                response4retain2kernel   = retain2kernel4hpu()
            
                message2print = "{(Step H/33) calculated" + "; hpu-calculated-by-retain2kernel4xi to: " + str(response4retain2kernel)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'H-'
            except: 
                message2print = "{(Step HZ1/33) yielded" + "; hpu-yielded-by-retain2kernel4xi: " + str(response4retain2kernel) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'HZ1-'     
        if 'IPU' in keys2task4retain:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step I/33) - IPU
                # -----------------------------------------------------------------------------------------               
                response4retain2kernel   = retain2kernel4ipu()
            
                message2print = "{(Step I/33) calculated" + "; ipu-calculated-by-retain2kernel4xi to: " + str(response4retain2kernel)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'I-'
            except: 
                message2print = "{(Step IZ1/33) yielded" + "; ipu-yielded-by-retain2kernel4xi: " + str(response4retain2kernel) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'IZ1-'     
        if 'JPU' in keys2task4retain:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step J/33) - JPU
                # -----------------------------------------------------------------------------------------               
                response4retain2kernel   = retain2kernel4jpu()
            
                message2print = "{(Step J/33) calculated" + "; jpu-calculated-by-retain2kernel4xi to: " + str(response4retain2kernel)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'J-'
            except: 
                message2print = "{(Step JZ1/33) yielded" + "; jpu-yielded-by-retain2kernel4xi: " + str(response4retain2kernel) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'JZ1-'     
        if 'KPU' in keys2task4retain:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step K/33) - KPU
                # -----------------------------------------------------------------------------------------               
                response4retain2kernel   = retain2kernel4kpu()
            
                message2print = "{(Step K/33) calculated" + "; kpu-calculated-by-retain2kernel4xi to: " + str(response4retain2kernel)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'K-'
            except: 
                message2print = "{(Step KZ1/33) yielded" + "; kpu-yielded-by-retain2kernel4xi: " + str(response4retain2kernel) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'KZ1-'     
        if 'LPU' in keys2task4retain:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step L/33) - LPU
                # -----------------------------------------------------------------------------------------               
                response4retain2kernel   = retain2kernel4lpu()
            
                message2print = "{(Step L/33) calculated" + "; lpu-calculated-by-retain2kernel4xi to: " + str(response4retain2kernel)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'L-'
            except: 
                message2print = "{(Step LZ1/33) yielded" + "; lpu-yielded-by-retain2kernel4xi: " + str(response4retain2kernel) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'LZ1-'     
        if 'MPU' in keys2task4retain:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step M/33) - MPU
                # -----------------------------------------------------------------------------------------               
                response4retain2kernel   = retain2kernel4mpu()
            
                message2print = "{(Step M/33) calculated" + "; mpu-calculated-by-retain2kernel4xi to: " + str(response4retain2kernel)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'M-'
            except: 
                message2print = "{(Step MZ1/33) yielded" + "; mpu-yielded-by-retain2kernel4xi: " + str(response4retain2kernel) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'MZ1-'     
        if 'NPU' in keys2task4retain:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step N/33) - NPU
                # -----------------------------------------------------------------------------------------               
                response4retain2kernel   = retain2kernel4npu()
            
                message2print = "{(Step N/33) calculated" + "; npu-calculated-by-retain2kernel4xi to: " + str(response4retain2kernel)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'N-'
            except: 
                message2print = "{(Step NZ1/33) yielded" + "; npu-yielded-by-retain2kernel4xi: " + str(response4retain2kernel) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'NZ1-'     
        if 'OPU' in keys2task4retain:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step O/33) - OPU
                # -----------------------------------------------------------------------------------------               
                response4retain2kernel   = retain2kernel4opu()
            
                message2print = "{(Step O/33) calculated" + "; opu-calculated-by-retain2kernel4xi to: " + str(response4retain2kernel)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'O-'
            except: 
                message2print = "{(Step OZ1/33) yielded" + "; opu-yielded-by-retain2kernel4xi: " + str(response4retain2kernel) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'OZ1-'     
        if 'PPU' in keys2task4retain:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step P/33) - PPU
                # -----------------------------------------------------------------------------------------               
                response4retain2kernel   = retain2kernel4ppu()
            
                message2print = "{(Step P/33) calculated" + "; ppu-calculated-by-retain2kernel4xi to: " + str(response4retain2kernel)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'P-'
            except: 
                message2print = "{(Step PZ1/33) yielded" + "; ppu-yielded-by-retain2kernel4xi: " + str(response4retain2kernel) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'PZ1-'     
        if 'QPU' in keys2task4retain:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step Q/33) - QPU
                # -----------------------------------------------------------------------------------------               
                response4retain2kernel   = retain2kernel4qpu()
            
                message2print = "{(Step Q/33) calculated" + "; qpu-calculated-by-retain2kernel4xi to: " + str(response4retain2kernel)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'Q-'
            except: 
                message2print = "{(Step QZ1/33) yielded" + "; qpu-yielded-by-retain2kernel4xi: " + str(response4retain2kernel) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'QZ1-'     
        if 'RPU' in keys2task4retain:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step R/33) - RPU
                # -----------------------------------------------------------------------------------------               
                response4retain2kernel   = retain2kernel4rpu()
            
                message2print = "{(Step R/33) calculated" + "; rpu-calculated-by-retain2kernel4xi to: " + str(response4retain2kernel)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'R-'
            except: 
                message2print = "{(Step RZ1/33) yielded" + "; rpu-yielded-by-retain2kernel4xi: " + str(response4retain2kernel) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'RZ1-'     
        if 'SPU' in keys2task4retain:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step S/33) - SPU
                # -----------------------------------------------------------------------------------------               
                response4retain2kernel   = retain2kernel4spu()
            
                message2print = "{(Step S/33) calculated" + "; spu-calculated-by-retain2kernel4xi to: " + str(response4retain2kernel)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'S-'
            except: 
                message2print = "{(Step SZ1/33) yielded" + "; spu-yielded-by-retain2kernel4xi: " + str(response4retain2kernel) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'SZ1-'     
        if 'TPU' in keys2task4retain:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step T/33) - TPU
                # -----------------------------------------------------------------------------------------               
                response4retain2kernel   = retain2kernel4tpu()
            
                message2print = "{(Step T/33) calculated" + "; tpu-calculated-by-retain2kernel4xi to: " + str(response4retain2kernel)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'T-'
            except: 
                message2print = "{(Step TZ1/33) yielded" + "; tpu-yielded-by-retain2kernel4xi: " + str(response4retain2kernel) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'TZ1-'     
        if 'UPU' in keys2task4retain:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step U/33) - UPU
                # -----------------------------------------------------------------------------------------               
                response4retain2kernel   = retain2kernel4upu()
            
                message2print = "{(Step U/33) calculated" + "; upu-calculated-by-retain2kernel4xi to: " + str(response4retain2kernel)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'U-'
            except: 
                message2print = "{(Step UZ1/33) yielded" + "; upu-yielded-by-retain2kernel4xi: " + str(response4retain2kernel) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'UZ1-'     
        if 'VPU' in keys2task4retain:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step V/33) - VPU
                # -----------------------------------------------------------------------------------------               
                response4retain2kernel   = retain2kernel4vpu()
            
                message2print = "{(Step V/33) calculated" + "; vpu-calculated-by-retain2kernel4xi to: " + str(response4retain2kernel)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'V-'
            except: 
                message2print = "{(Step VZ1/33) yielded" + "; vpu-yielded-by-retain2kernel4xi: " + str(response4retain2kernel) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'VZ1-'     
        if 'WPU' in keys2task4retain:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step W/33) - WPU
                # -----------------------------------------------------------------------------------------               
                response4retain2kernel   = retain2kernel4wpu()
            
                message2print = "{(Step W/33) calculated" + "; wpu-calculated-by-retain2kernel4xi to: " + str(response4retain2kernel)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'W-'
            except: 
                message2print = "{(Step WZ1/33) yielded" + "; wpu-yielded-by-retain2kernel4xi: " + str(response4retain2kernel) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'WZ1-'     
        if 'XPU' in keys2task4retain:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step X/33) - XPU
                # -----------------------------------------------------------------------------------------               
                response4retain2kernel   = retain2kernel4xpu()
            
                message2print = "{(Step X/33) calculated" + "; xpu-calculated-by-retain2kernel4xi to: " + str(response4retain2kernel)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'X-'
            except: 
                message2print = "{(Step XZ1/33) yielded" + "; xpu-yielded-by-retain2kernel4xi: " + str(response4retain2kernel) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'XZ1-'     
        if 'YPU' in keys2task4retain:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step Y/33) - YPU
                # -----------------------------------------------------------------------------------------               
                response4retain2kernel   = retain2kernel4ypu()
            
                message2print = "{(Step Y/33) calculated" + "; ypu-calculated-by-retain2kernel4xi to: " + str(response4retain2kernel)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'Y-'
            except: 
                message2print = "{(Step YZ1/33) yielded" + "; ypu-yielded-by-retain2kernel4xi: " + str(response4retain2kernel) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'YZ1-'     
        if 'ZPU' in keys2task4retain:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step Z/33) - ZPU
                # -----------------------------------------------------------------------------------------               
                response4retain2kernel   = retain2kernel4zpu()
            
                message2print = "{(Step Z/33) calculated" + "; zpu-calculated-by-retain2kernel4xi to: " + str(response4retain2kernel)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'Z-'
            except: 
                message2print = "{(Step ZZ1/33) yielded" + "; zpu-yielded-by-retain2kernel4xi: " + str(response4retain2kernel) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'ZZ1-'                 

            
          
    # -----------------------------------------------------------------------------------------
    # (Step 33/3)           
    # -----------------------------------------------------------------------------------------
    if debug is True:
        print("{(Step 33/33) of retain2kernel4xi - RETURNING KERNEL4XI: ", kernel4xi)
            
    message2print = "{(Step 33/33) returning" + "; kernel4xi-returning-by-retain2kernel4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"  
    print4xi(class2print, method2print, message2print)                                                              
    # 

    return kernel4xi
            
#</function4xi>  

# -------------------------------------------------------------------------------------------------
#<function4xi function = "add2kernel4xi" usage = "
#    
#   print('=' *33)          
#   print('(Step 2A/700) OF KERNEL4XI5TEST - TRYING TO ADD KERNEL OF XI ', time4xi())      
#   print('=' *33)        
#   # 
#   try:
#       response4add2kernel = add2kernel4xi()                                                                 
#       print('(Step 2B/700) OF KERNEL4XI5TEST - ADD KERNEL OF XI ', time4xi())
#       keys2response = response4add2kernel.keys()
#       for key2response in sorted(keys2response):
#           print(key2response, ' : ', response4add2kernel[key2response])
#           # 
#   except:
#       print('(Step 2Z1/700) OF KERNEL4XI5TEST *** FAILED TO ADD KERNEL OF XI *** ', time4xi())
#
#">

# -------------------------------------------------------------------------------------------------   
def add2kernel4xi(task4add2kernel=None):

    '''
    adds kernel of xi
    '''
    global platform2xi
    global device2xi
    global context2xi 
    global kernel4xi
    global info2kernel4xi                                                                                              
    
    # -----------------------------------------------------------------------------------------
    # (Step 1/70) - START           
    # -----------------------------------------------------------------------------------------          
    debug = False
    response2add4xi = {} 
        
    class2print = "add2kernel4xi"  
    method2print = "add2kernel4xi"

    message2print = "{(Step 1A/70) started" + "; add2kernel4xi-started: " + str(add2kernel4xi)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)
    # 
  
             
    message2print = "{(Step 1B/70) passed" + "; task4add2kernel-to-add2kernel4xi: " + str(task4add2kernel) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                                                              
    # 

    code2ack  = ' '
    code2nack = ' '    
    
    ack2all = False             
    if task4add2kernel is None:
        # -----------------------------------------------------------------------------------------
        # NO PARAMETERS GIVEN BY CALLER
        # -----------------------------------------------------------------------------------------    
        ack2all = True                                                                                                
        code2ack  = code2ack + '1C-'
    else:
        # -----------------------------------------------------------------------------------------
        # SOME PARAMETERS GIVEN BY CALLER
        # -----------------------------------------------------------------------------------------        
        try:
            if kernel4xi is None:                                                                                       
                kernel4xi = create2kernel4xi() 
                code2ack  = code2ack + '1D-'
        except:
            kernel4xi = create2kernel4xi()
            code2ack  = code2ack + '1D-'
                        
    # -----------------------------------------------------------------------------------------
    # (Step 2/33)
    # -----------------------------------------------------------------------------------------                  
    message2print = "{(Step 2A/3) try" + "; task4add2kernel-try-by-add2kernel4xi: " + str(task4add2kernel)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print) 
    # 
    
    if ack2all is True:
        try:
            # -----------------------------------------------------------------------------------------
            # (Step 3/33) - ALL DEVICES
            # ----------------------------------------------------------------------------------------- 
            
            response2add4xi['APU'] = add2kernel4apu()                                                                        
            response2add4xi['BPU'] = add2kernel4bpu()   
            response2add4xi['CPU'] = add2kernel4cpu()   
            response2add4xi['DPU'] = add2kernel4dpu()   
            response2add4xi['EPU'] = add2kernel4epu()   
            response2add4xi['FPU'] = add2kernel4fpu()   
            response2add4xi['GPU'] = add2kernel4gpu()   
            response2add4xi['HPU'] = add2kernel4hpu()   
            response2add4xi['IPU'] = add2kernel4ipu()   
            response2add4xi['JPU'] = add2kernel4jpu()   
            response2add4xi['KPU'] = add2kernel4kpu()   
            response2add4xi['LPU'] = add2kernel4lpu()   
            response2add4xi['MPU'] = add2kernel4mpu()   
            response2add4xi['NPU'] = add2kernel4npu()   
            response2add4xi['OPU'] = add2kernel4opu()   
            response2add4xi['PPU'] = add2kernel4ppu()   
            response2add4xi['QPU'] = add2kernel4qpu()   
            response2add4xi['RPU'] = add2kernel4rpu()   
            response2add4xi['SPU'] = add2kernel4spu()   
            response2add4xi['TPU'] = add2kernel4tpu()   
            response2add4xi['UPU'] = add2kernel4upu()   
            response2add4xi['VPU'] = add2kernel4vpu()   
            response2add4xi['XPU'] = add2kernel4xpu()   
            response2add4xi['WPU'] = add2kernel4wpu()   
            response2add4xi['YPU'] = add2kernel4ypu()   
            response2add4xi['ZPU'] = add2kernel4zpu()   
            
            message2print = "{(Step 3A/33) got" + "; response2add4xi-got-by-add2kernel4xi: " + str(response2add4xi)  + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print)                                                      
            # 
            
            code2ack  = code2ack + '3A-'
        except:
            message2print = "{(Step 3Z1/33) yielded" + "; kernel4xi-yielded-by-add2kernel4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                               #   
            code2nack  = code2nack + '3Z1-'
    else:    
        keys2add4task = task4add2kernel.keys()
        
        if 'APU' in keys2add4task:
            try:
                # -----------------------------------------------------------------------------------------
                # (Step A/33) - APU
                # -----------------------------------------------------------------------------------------               
                response2add4xi['APU'] = add2kernel4apu(task4add2kernel['APU'])
            
                message2print = "{(Step A/33) got" + "; apu-got-by-add2kernel4xi: " + str(kernel4xi['APU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'A-'
            except: 
                message2print = "{(Step AZ1/33) yielded" + "; apu-yielded-by-add2kernel4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'AZ1-'          
        
        if 'BPU' in keys2add4task:    
            try:
                # -----------------------------------------------------------------------------------------
                # (Step B/33) - BPU
                # -----------------------------------------------------------------------------------------               
                response2add4xi['BPU'] = add2kernel4bpu(task4add2kernel['BPU'])
            
                message2print = "{(Step B/33) got" + "; bpu-got-by-add2kernel4xi: " + str(kernel4xi['BPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'B-'
            except: 
                message2print = "{(Step BZ1/33) yielded" + "; bpu-yielded-by-add2kernel4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'BZ1-'     
        
        if 'CPU' in keys2add4task:                
            try:
                # -----------------------------------------------------------------------------------------
                # (Step C/33) - CPU
                # -----------------------------------------------------------------------------------------               
                response2add4xi['CPU'] = add2kernel4cpu(task4add2kernel['CPU'])
            
                message2print = "{(Step C/33) got" + "; cpu-got-by-add2kernel4xi: " + str(kernel4xi['CPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'C-'
            except: 
                message2print = "{(Step CZ1/33) yielded" + "; cpu-yielded-by-add2kernel4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'CZ1-'     
        
        if 'DPU' in keys2add4task:                
            try:
                # -----------------------------------------------------------------------------------------
                # (Step D/33) - DPU
                # -----------------------------------------------------------------------------------------               
                response2add4xi['DPU'] = add2kernel4dpu(task4add2kernel['DPU'])
            
                message2print = "{(Step D/33) got" + "; dpu-got-by-add2kernel4xi: " + str(kernel4xi['DPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'D-'
            except: 
                message2print = "{(Step DZ1/33) yielded" + "; dpu-yielded-by-add2kernel4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'DZ1-'     
        
        if 'EPU' in keys2add4task:                
            try:
                # -----------------------------------------------------------------------------------------
                # (Step E/33) - EPU
                # -----------------------------------------------------------------------------------------               
                response2add4xi['EPU'] = add2kernel4epu(task4add2kernel['EPU'])
            
                message2print = "{(Step E/33) got" + "; epu-got-by-add2kernel4xi: " + str(kernel4xi['EPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'E-'
            except: 
                message2print = "{(Step EZ1/33) yielded" + "; epu-yielded-by-add2kernel4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'EZ1-'     
        
        if 'FPU' in keys2add4task:                
            try:
                # -----------------------------------------------------------------------------------------
                # (Step F/33) - FPU
                # -----------------------------------------------------------------------------------------               
                response2add4xi['FPU'] = add2kernel4fpu(task4add2kernel['FPU'])
            
                message2print = "{(Step F/33) got" + "; fpu-got-by-add2kernel4xi: " + str(kernel4xi['FPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'F-'
            except: 
                message2print = "{(Step FZ1/33) yielded" + "; fpu-yielded-by-add2kernel4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'FZ1-'     
        
        if 'GPU' in keys2add4task:                
            try:
                # -----------------------------------------------------------------------------------------
                # (Step G/33) - GPU
                # -----------------------------------------------------------------------------------------               
                response2add4xi['GPU'] = add2kernel4gpu(task4add2kernel['GPU'])
            
                message2print = "{(Step G/33) got" + "; gpu-got-by-add2kernel4xi: " + str(kernel4xi['GPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'G-'
            except: 
                message2print = "{(Step GZ1/33) yielded" + "; gpu-yielded-by-add2kernel4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'GZ1-'     
        
        if 'HPU' in keys2add4task:                
            try:
                # -----------------------------------------------------------------------------------------
                # (Step H/33) - HPU
                # -----------------------------------------------------------------------------------------               
                response2add4xi['HPU'] = add2kernel4hpu(task4add2kernel['HPU'])
            
                message2print = "{(Step H/33) got" + "; hpu-got-by-add2kernel4xi: " + str(kernel4xi['HPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'H-'
            except: 
                message2print = "{(Step HZ1/33) yielded" + "; hpu-yielded-by-add2kernel4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'HZ1-'     
        
        if 'IPU' in keys2add4task:                
            try:
                # -----------------------------------------------------------------------------------------
                # (Step I/33) - IPU
                # -----------------------------------------------------------------------------------------               
                response2add4xi['IPU'] = add2kernel4ipu(task4add2kernel['IPU'])
            
                message2print = "{(Step I/33) got" + "; ipu-got-by-add2kernel4xi: " + str(kernel4xi['IPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'I-'
            except: 
                message2print = "{(Step IZ1/33) yielded" + "; ipu-yielded-by-add2kernel4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'IZ1-'     
        
        if 'JPU' in keys2add4task:                
            try:
                # -----------------------------------------------------------------------------------------
                # (Step J/33) - JPU
                # -----------------------------------------------------------------------------------------               
                response2add4xi['JPU'] = add2kernel4jpu(task4add2kernel['JPU'])
            
                message2print = "{(Step J/33) got" + "; jpu-got-by-add2kernel4xi: " + str(kernel4xi['JPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'J-'
            except: 
                message2print = "{(Step JZ1/33) yielded" + "; jpu-yielded-by-add2kernel4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'JZ1-'     
        
        if 'KPU' in keys2add4task:                
            try:
                # -----------------------------------------------------------------------------------------
                # (Step K/33) - KPU
                # -----------------------------------------------------------------------------------------               
                response2add4xi['KPU'] = add2kernel4kpu(task4add2kernel['KPU'])
            
                message2print = "{(Step K/33) got" + "; kpu-got-by-add2kernel4xi: " + str(kernel4xi['KPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'K-'
            except: 
                message2print = "{(Step KZ1/33) yielded" + "; kpu-yielded-by-add2kernel4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'KZ1-'     
        
        if 'LPU' in keys2add4task:                
            try:
                # -----------------------------------------------------------------------------------------
                # (Step L/33) - LPU
                # -----------------------------------------------------------------------------------------               
                response2add4xi['LPU'] = add2kernel4lpu(task4add2kernel['LPU'])
            
                message2print = "{(Step L/33) got" + "; lpu-got-by-add2kernel4xi: " + str(kernel4xi['LPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'L-'
            except: 
                message2print = "{(Step LZ1/33) yielded" + "; lpu-yielded-by-add2kernel4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'LZ1-'     
        
        if 'MPU' in keys2add4task:                
            try:
                # -----------------------------------------------------------------------------------------
                # (Step M/33) - MPU
                # -----------------------------------------------------------------------------------------               
                response2add4xi['MPU'] = add2kernel4mpu(task4add2kernel['MPU'])
            
                message2print = "{(Step M/33) got" + "; mpu-got-by-add2kernel4xi: " + str(kernel4xi['MPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'M-'
            except: 
                message2print = "{(Step MZ1/33) yielded" + "; mpu-yielded-by-add2kernel4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'MZ1-'     
        
        if 'NPU' in keys2add4task:                
            try:
                # -----------------------------------------------------------------------------------------
                # (Step N/33) - NPU
                # -----------------------------------------------------------------------------------------               
                response2add4xi['NPU'] = add2kernel4npu(task4add2kernel['NPU'])
            
                message2print = "{(Step N/33) got" + "; npu-got-by-add2kernel4xi: " + str(kernel4xi['NPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'N-'
            except: 
                message2print = "{(Step NZ1/33) yielded" + "; npu-yielded-by-add2kernel4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'NZ1-'     
        
        if 'OPU' in keys2add4task:                
            try:
                # -----------------------------------------------------------------------------------------
                # (Step O/33) - OPU
                # -----------------------------------------------------------------------------------------               
                response2add4xi['OPU'] = add2kernel4opu(task4add2kernel['OPU'])
            
                message2print = "{(Step O/33) got" + "; opu-got-by-add2kernel4xi: " + str(kernel4xi['OPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'O-'
            except: 
                message2print = "{(Step OZ1/33) yielded" + "; opu-yielded-by-add2kernel4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'OZ1-'     
        
        if 'PPU' in keys2add4task:                
            try:
                # -----------------------------------------------------------------------------------------
                # (Step P/33) - PPU
                # -----------------------------------------------------------------------------------------               
                response2add4xi['PPU'] = add2kernel4ppu(task4add2kernel['PPU'])
            
                message2print = "{(Step P/33) got" + "; ppu-got-by-add2kernel4xi: " + str(kernel4xi['PPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'P-'
            except: 
                message2print = "{(Step PZ1/33) yielded" + "; ppu-yielded-by-add2kernel4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'PZ1-'     
        
        if 'QPU' in keys2add4task:                
            try:
                # -----------------------------------------------------------------------------------------
                # (Step Q/33) - QPU
                # -----------------------------------------------------------------------------------------               
                response2add4xi['QPU'] = add2kernel4qpu(task4add2kernel['QPU'])
            
                message2print = "{(Step Q/33) got" + "; qpu-got-by-add2kernel4xi: " + str(kernel4xi['QPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'Q-'
            except: 
                message2print = "{(Step QZ1/33) yielded" + "; qpu-yielded-by-add2kernel4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'QZ1-'     
        
        if 'RPU' in keys2add4task:                
            try:
                # -----------------------------------------------------------------------------------------
                # (Step R/33) - RPU
                # -----------------------------------------------------------------------------------------               
                response2add4xi['RPU'] = add2kernel4rpu(task4add2kernel['RPU'])
            
                message2print = "{(Step R/33) got" + "; rpu-got-by-add2kernel4xi: " + str(kernel4xi['RPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'R-'
            except: 
                message2print = "{(Step RZ1/33) yielded" + "; rpu-yielded-by-add2kernel4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'RZ1-'     
        
        if 'SPU' in keys2add4task:                
            try:
                # -----------------------------------------------------------------------------------------
                # (Step S/33) - SPU
                # -----------------------------------------------------------------------------------------               
                response2add4xi['SPU'] = add2kernel4spu(task4add2kernel['SPU'])
            
                message2print = "{(Step S/33) got" + "; spu-got-by-add2kernel4xi: " + str(kernel4xi['SPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'S-'
            except: 
                message2print = "{(Step SZ1/33) yielded" + "; spu-yielded-by-add2kernel4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'SZ1-'     
        
        if 'TPU' in keys2add4task:                
            try:
                # -----------------------------------------------------------------------------------------
                # (Step T/33) - TPU
                # -----------------------------------------------------------------------------------------               
                response2add4xi['TPU'] = add2kernel4tpu(task4add2kernel['TPU'])
            
                message2print = "{(Step T/33) got" + "; tpu-got-by-add2kernel4xi: " + str(kernel4xi['TPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'T-'
            except: 
                message2print = "{(Step TZ1/33) yielded" + "; tpu-yielded-by-add2kernel4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'TZ1-'     
        
        if 'UPU' in keys2add4task:                
            try:
                # -----------------------------------------------------------------------------------------
                # (Step U/33) - UPU
                # -----------------------------------------------------------------------------------------               
                response2add4xi['UPU'] = add2kernel4upu(task4add2kernel['UPU'])
            
                message2print = "{(Step U/33) got" + "; upu-got-by-add2kernel4xi: " + str(kernel4xi['UPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'U-'
            except: 
                message2print = "{(Step UZ1/33) yielded" + "; upu-yielded-by-add2kernel4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'UZ1-'     
        
        if 'VPU' in keys2add4task:                
            try:
                # -----------------------------------------------------------------------------------------
                # (Step V/33) - VPU
                # -----------------------------------------------------------------------------------------               
                response2add4xi['VPU'] = add2kernel4vpu(task4add2kernel['VPU'])
            
                message2print = "{(Step V/33) got" + "; vpu-got-by-add2kernel4xi: " + str(kernel4xi['VPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'V-'
            except: 
                message2print = "{(Step VZ1/33) yielded" + "; vpu-yielded-by-add2kernel4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'VZ1-'     
        
        if 'WPU' in keys2add4task:                
            try:
                # -----------------------------------------------------------------------------------------
                # (Step W/33) - WPU
                # -----------------------------------------------------------------------------------------               
                response2add4xi['WPU'] = add2kernel4wpu(task4add2kernel['WPU'])
            
                message2print = "{(Step W/33) got" + "; wpu-got-by-add2kernel4xi: " + str(kernel4xi['WPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'W-'
            except: 
                message2print = "{(Step WZ1/33) yielded" + "; wpu-yielded-by-add2kernel4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'WZ1-'     
        
        if 'XPU' in keys2add4task:                
            try:
                # -----------------------------------------------------------------------------------------
                # (Step X/33) - XPU
                # -----------------------------------------------------------------------------------------               
                response2add4xi['XPU'] = add2kernel4xpu(task4add2kernel['XPU'])
            
                message2print = "{(Step X/33) got" + "; xpu-got-by-add2kernel4xi: " + str(kernel4xi['XPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'X-'
            except: 
                message2print = "{(Step XZ1/33) yielded" + "; xpu-yielded-by-add2kernel4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'XZ1-'     
        
        if 'YPU' in keys2add4task:                
            try:
                # -----------------------------------------------------------------------------------------
                # (Step Y/33) - YPU
                # -----------------------------------------------------------------------------------------               
                response2add4xi['YPU'] = add2kernel4ypu(task4add2kernel['YPU'])
            
                message2print = "{(Step Y/33) got" + "; ypu-got-by-add2kernel4xi: " + str(kernel4xi['YPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'Y-'
            except: 
                message2print = "{(Step YZ1/33) yielded" + "; ypu-yielded-by-add2kernel4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'YZ1-'     
        
        if 'ZPU' in keys2add4task:                
            try:
                # -----------------------------------------------------------------------------------------
                # (Step Z/33) - ZPU
                # -----------------------------------------------------------------------------------------               
                response2add4xi['ZPU'] = add2kernel4zpu(task4add2kernel['ZPU'])
            
                message2print = "{(Step Z/33) got" + "; zpu-got-by-add2kernel4xi: " + str(kernel4xi['ZPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'Z-'
            except: 
                message2print = "{(Step ZZ1/33) yielded" + "; zpu-yielded-by-add2kernel4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'ZZ1-'                 

            
          
    # -----------------------------------------------------------------------------------------
    # (Step 33/3)           
    # -----------------------------------------------------------------------------------------
    if debug is True:
        print("{(Step 33/33) of add2kernel4xi - RETURNING response2add4xi: ", response2add4xi)
            
    message2print = "{(Step 33/33) returning" + "; response2add4xi-returning-by-add2kernel4xi: " + str(response2add4xi) + "; time: " + time4xi() + "}"  
    print4xi(class2print, method2print, message2print)                                                              
    # 

    return response2add4xi
            
#</function4xi>  

# -------------------------------------------------------------------------------------------------
#<function4xi function = "delete2kernel4xi" usage = "
#    
#   print('=' *33)          
#   print('(Step 2A/700) OF KERNEL4XI5TEST - TRYING TO DELETE KERNEL OF XI ', time4xi())      
#   print('=' *33)        
#   # 
#   try:
#       response4delete2kernel = delete2kernel4xi()                                                                 
#       print('(Step 2B/700) OF KERNEL4XI5TEST - DELETED KERNEL OF XI ', time4xi())
#       keys2response = response4delete2kernel.keys()
#       for key2response in sorted(keys2response):
#           print(key2response, ' : ', response4delete2kernel[key2response])
#           # 
#   except:
#       print('(Step 2Z1/700) OF KERNEL4XI5TEST *** FAILED TO DELETE KERNEL OF XI *** ', time4xi())
#
#">

# -------------------------------------------------------------------------------------------------   
def delete2kernel4xi(task4delete2kernel=None):

    '''
    deletes kernel of xi
    '''
    global platform2xi
    global device2xi
    global context2xi 
    global kernel4xi
    global info2kernel4xi                                                                                              
    
    # -----------------------------------------------------------------------------------------
    # (Step 1/70) - START           
    # -----------------------------------------------------------------------------------------          
    debug = False
    response2delete4xi = {} 
        
    class2print = "delete2kernel4xi"  
    method2print = "delete2kernel4xi"

    message2print = "{(Step 1A/70) started" + "; delete2kernel4xi-started: " + str(delete2kernel4xi)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)
    # 
  
             
    message2print = "{(Step 1B/70) passed" + "; task4delete2kernel-to-delete2kernel4xi: " + str(task4delete2kernel) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                                                              
    # {'BPU': 'Yes'}

    code2ack  = ' '
    code2nack = ' '    
    
    ack2all = False             
    if task4delete2kernel is None:
        # -----------------------------------------------------------------------------------------
        # NO PARAMETERS GIVEN BY CALLER FOR INITIALIZATION - SYSTEM CREATES ALL
        # -----------------------------------------------------------------------------------------    
        ack2all = True                                                                                                
        code2ack  = code2ack + '1C-'
    else:
        # -----------------------------------------------------------------------------------------
        # SOME PARAMETERS GIVEN BY CALLER FOR INITIALIZATION - KERNEL4XI NEEDS INITIALIZATION
        # -----------------------------------------------------------------------------------------        
        try:
            if kernel4xi is None:                                                                                       
                kernel4xi = create2kernel4xi() 
                code2ack  = code2ack + '1D-'
        except:
            kernel4xi = create2kernel4xi()
            code2ack  = code2ack + '1D-'
                        
    # -----------------------------------------------------------------------------------------
    # (Step 2/33)
    # -----------------------------------------------------------------------------------------                  
    message2print = "{(Step 2A/3) try" + "; task4delete2kernel-try-by-delete2kernel4xi: " + str(task4delete2kernel)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print) 
    # {'BPU': 'Yes'}
    
    if ack2all is True:
        try:
            # -----------------------------------------------------------------------------------------
            # (Step 3/33) - ALL DEVICES
            # ----------------------------------------------------------------------------------------- 
            
            response2delete4xi['APU'] = delete2kernel4apu()                                                                        
            response2delete4xi['BPU'] = delete2kernel4bpu()   
            response2delete4xi['CPU'] = delete2kernel4cpu()   
            response2delete4xi['DPU'] = delete2kernel4dpu()   
            response2delete4xi['EPU'] = delete2kernel4epu()   
            response2delete4xi['FPU'] = delete2kernel4fpu()   
            response2delete4xi['GPU'] = delete2kernel4gpu()   
            response2delete4xi['HPU'] = delete2kernel4hpu()   
            response2delete4xi['IPU'] = delete2kernel4ipu()   
            response2delete4xi['JPU'] = delete2kernel4jpu()   
            response2delete4xi['KPU'] = delete2kernel4kpu()   
            response2delete4xi['LPU'] = delete2kernel4lpu()   
            response2delete4xi['MPU'] = delete2kernel4mpu()   
            response2delete4xi['NPU'] = delete2kernel4npu()   
            response2delete4xi['OPU'] = delete2kernel4opu()   
            response2delete4xi['PPU'] = delete2kernel4ppu()   
            response2delete4xi['QPU'] = delete2kernel4qpu()   
            response2delete4xi['RPU'] = delete2kernel4rpu()   
            response2delete4xi['SPU'] = delete2kernel4spu()   
            response2delete4xi['TPU'] = delete2kernel4tpu()   
            response2delete4xi['UPU'] = delete2kernel4upu()   
            response2delete4xi['VPU'] = delete2kernel4vpu()   
            response2delete4xi['XPU'] = delete2kernel4xpu()   
            response2delete4xi['WPU'] = delete2kernel4wpu()   
            response2delete4xi['YPU'] = delete2kernel4ypu()   
            response2delete4xi['ZPU'] = delete2kernel4zpu()   
            
            message2print = "{(Step 3A/33) got" + "; response2delete4xi-got-by-delete2kernel4xi: " + str(response2delete4xi)  + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print)                                                      
            # 
            
            code2ack  = code2ack + '3A-'
        except:
            message2print = "{(Step 3Z1/33) yielded" + "; kernel4xi-yielded-by-delete2kernel4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                               #   
            code2nack  = code2nack + '3Z1-'
    else:    
        keys2delete4kernel = task4delete2kernel.keys()
        if 'APU' in keys2delete4kernel:
            try:
                # -----------------------------------------------------------------------------------------
                # (Step A/33) - APU
                # -----------------------------------------------------------------------------------------               
                response2delete4xi['APU'] = delete2kernel4apu(task4delete2kernel['APU'])
            
                message2print = "{(Step A/33) got" + "; apu-got-by-delete2kernel4xi: " + str(kernel4xi['APU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'A-'
            except: 
                message2print = "{(Step AZ1/33) yielded" + "; apu-yielded-by-delete2kernel4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'AZ1-'          
        if 'BPU' in keys2delete4kernel:
            try:
                # -----------------------------------------------------------------------------------------
                # (Step B/33) - BPU
                # -----------------------------------------------------------------------------------------               
                response2delete4xi['BPU'] = delete2kernel4bpu(task4delete2kernel['BPU'])
            
                message2print = "{(Step B/33) got" + "; bpu-got-by-delete2kernel4xi: " + str(kernel4xi['BPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'B-'
            except: 
               message2print = "{(Step BZ1/33) yielded" + "; bpu-yielded-by-delete2kernel4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
               print4xi(class2print, method2print, message2print)  
               code2nack  = code2nack + 'BZ1-'     
        if 'CPU' in keys2delete4kernel:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step C/33) - CPU
                # -----------------------------------------------------------------------------------------               
                response2delete4xi['CPU'] = delete2kernel4cpu(task4delete2kernel['CPU'])
            
                message2print = "{(Step C/33) got" + "; cpu-got-by-delete2kernel4xi: " + str(kernel4xi['CPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'C-'
            except: 
               message2print = "{(Step CZ1/33) yielded" + "; cpu-yielded-by-delete2kernel4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
               print4xi(class2print, method2print, message2print)  
               code2nack  = code2nack + 'CZ1-'     
        if 'DPU' in keys2delete4kernel:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step D/33) - DPU
                # -----------------------------------------------------------------------------------------               
                response2delete4xi['DPU'] = delete2kernel4dpu(task4delete2kernel['DPU'])
            
                message2print = "{(Step D/33) got" + "; dpu-got-by-delete2kernel4xi: " + str(kernel4xi['DPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'D-'
            except: 
               message2print = "{(Step DZ1/33) yielded" + "; dpu-yielded-by-delete2kernel4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
               print4xi(class2print, method2print, message2print)  
               code2nack  = code2nack + 'DZ1-'     
        if 'EPU' in keys2delete4kernel:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step E/33) - EPU
                # -----------------------------------------------------------------------------------------               
                response2delete4xi['EPU'] = delete2kernel4epu(task4delete2kernel['EPU'])
            
                message2print = "{(Step E/33) got" + "; epu-got-by-delete2kernel4xi: " + str(kernel4xi['EPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'E-'
            except: 
               message2print = "{(Step EZ1/33) yielded" + "; epu-yielded-by-delete2kernel4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
               print4xi(class2print, method2print, message2print)  
               code2nack  = code2nack + 'EZ1-'     
        if 'FPU' in keys2delete4kernel:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step F/33) - FPU
                # -----------------------------------------------------------------------------------------               
                response2delete4xi['FPU'] = delete2kernel4fpu(task4delete2kernel['FPU'])
            
                message2print = "{(Step F/33) got" + "; fpu-got-by-delete2kernel4xi: " + str(kernel4xi['FPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'F-'
            except: 
               message2print = "{(Step FZ1/33) yielded" + "; fpu-yielded-by-delete2kernel4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
               print4xi(class2print, method2print, message2print)  
               code2nack  = code2nack + 'FZ1-'     
        if 'GPU' in keys2delete4kernel:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step G/33) - GPU
                # -----------------------------------------------------------------------------------------               
                response2delete4xi['GPU'] = delete2kernel4gpu(task4delete2kernel['GPU'])
            
                message2print = "{(Step G/33) got" + "; gpu-got-by-delete2kernel4xi: " + str(kernel4xi['GPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'G-'
            except: 
               message2print = "{(Step GZ1/33) yielded" + "; gpu-yielded-by-delete2kernel4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
               print4xi(class2print, method2print, message2print)  
               code2nack  = code2nack + 'GZ1-'     
        if 'HPU' in keys2delete4kernel:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step H/33) - HPU
                # -----------------------------------------------------------------------------------------               
                response2delete4xi['HPU'] = delete2kernel4hpu(task4delete2kernel['HPU'])
            
                message2print = "{(Step H/33) got" + "; hpu-got-by-delete2kernel4xi: " + str(kernel4xi['HPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
             
                code2ack  = code2ack + 'H-'
            except: 
               message2print = "{(Step HZ1/33) yielded" + "; hpu-yielded-by-delete2kernel4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
               print4xi(class2print, method2print, message2print)  
               code2nack  = code2nack + 'HZ1-'     
        if 'IPU' in keys2delete4kernel:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step I/33) - IPU
                # -----------------------------------------------------------------------------------------               
                response2delete4xi['IPU'] = delete2kernel4ipu(task4delete2kernel['IPU'])
            
                message2print = "{(Step I/33) got" + "; ipu-got-by-delete2kernel4xi: " + str(kernel4xi['IPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
             
                code2ack  = code2ack + 'I-'
            except: 
               message2print = "{(Step IZ1/33) yielded" + "; ipu-yielded-by-delete2kernel4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
               print4xi(class2print, method2print, message2print)  
               code2nack  = code2nack + 'IZ1-'     
        if 'JPU' in keys2delete4kernel:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step J/33) - JPU
                # -----------------------------------------------------------------------------------------               
                response2delete4xi['JPU'] = delete2kernel4jpu(task4delete2kernel['JPU'])
            
                message2print = "{(Step J/33) got" + "; jpu-got-by-delete2kernel4xi: " + str(kernel4xi['JPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'J-'
            except: 
               message2print = "{(Step JZ1/33) yielded" + "; jpu-yielded-by-delete2kernel4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
               print4xi(class2print, method2print, message2print)  
               code2nack  = code2nack + 'JZ1-'     
        if 'KPU' in keys2delete4kernel:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step K/33) - KPU
                # -----------------------------------------------------------------------------------------               
                response2delete4xi['KPU'] = delete2kernel4kpu(task4delete2kernel['KPU'])
            
                message2print = "{(Step K/33) got" + "; kpu-got-by-delete2kernel4xi: " + str(kernel4xi['KPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'K-'
            except: 
               message2print = "{(Step KZ1/33) yielded" + "; kpu-yielded-by-delete2kernel4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
               print4xi(class2print, method2print, message2print)  
               code2nack  = code2nack + 'KZ1-'     
        if 'LPU' in keys2delete4kernel:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step L/33) - LPU
                # -----------------------------------------------------------------------------------------               
                response2delete4xi['LPU'] = delete2kernel4lpu(task4delete2kernel['LPU'])
            
                message2print = "{(Step L/33) got" + "; lpu-got-by-delete2kernel4xi: " + str(kernel4xi['LPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'L-'
            except: 
               message2print = "{(Step LZ1/33) yielded" + "; lpu-yielded-by-delete2kernel4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
               print4xi(class2print, method2print, message2print)  
               code2nack  = code2nack + 'LZ1-'     
        if 'MPU' in keys2delete4kernel:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step M/33) - MPU
                # -----------------------------------------------------------------------------------------               
                response2delete4xi['MPU'] = delete2kernel4mpu(task4delete2kernel['MPU'])
            
                message2print = "{(Step M/33) got" + "; mpu-got-by-delete2kernel4xi: " + str(kernel4xi['MPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'M-'
            except: 
               message2print = "{(Step MZ1/33) yielded" + "; mpu-yielded-by-delete2kernel4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
               print4xi(class2print, method2print, message2print)  
               code2nack  = code2nack + 'MZ1-'     
        if 'NPU' in keys2delete4kernel:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step N/33) - NPU
                # -----------------------------------------------------------------------------------------               
                response2delete4xi['NPU'] = delete2kernel4npu(task4delete2kernel['NPU'])
            
                message2print = "{(Step N/33) got" + "; npu-got-by-delete2kernel4xi: " + str(kernel4xi['NPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'N-'
            except: 
               message2print = "{(Step NZ1/33) yielded" + "; npu-yielded-by-delete2kernel4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
               print4xi(class2print, method2print, message2print)  
               code2nack  = code2nack + 'NZ1-'     
        if 'OPU' in keys2delete4kernel:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step O/33) - OPU
                # -----------------------------------------------------------------------------------------               
                response2delete4xi['OPU'] = delete2kernel4opu(task4delete2kernel['OPU'])
            
                message2print = "{(Step O/33) got" + "; opu-got-by-delete2kernel4xi: " + str(kernel4xi['OPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'O-'
            except: 
               message2print = "{(Step OZ1/33) yielded" + "; opu-yielded-by-delete2kernel4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
               print4xi(class2print, method2print, message2print)  
               code2nack  = code2nack + 'OZ1-'     
        if 'PPU' in keys2delete4kernel:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step P/33) - PPU
                # -----------------------------------------------------------------------------------------               
                response2delete4xi['PPU'] = delete2kernel4ppu(task4delete2kernel['PPU'])
            
                message2print = "{(Step P/33) got" + "; ppu-got-by-delete2kernel4xi: " + str(kernel4xi['PPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'P-'
            except: 
               message2print = "{(Step PZ1/33) yielded" + "; ppu-yielded-by-delete2kernel4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
               print4xi(class2print, method2print, message2print)  
               code2nack  = code2nack + 'PZ1-'     
        if 'QPU' in keys2delete4kernel:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step Q/33) - QPU
                # -----------------------------------------------------------------------------------------               
                response2delete4xi['QPU'] = delete2kernel4qpu(task4delete2kernel['QPU'])
            
                message2print = "{(Step Q/33) got" + "; qpu-got-by-delete2kernel4xi: " + str(kernel4xi['QPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'Q-'
            except: 
               message2print = "{(Step QZ1/33) yielded" + "; qpu-yielded-by-delete2kernel4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
               print4xi(class2print, method2print, message2print)  
               code2nack  = code2nack + 'QZ1-'     
        if 'RPU' in keys2delete4kernel:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step R/33) - RPU
                # -----------------------------------------------------------------------------------------               
                response2delete4xi['RPU'] = delete2kernel4rpu(task4delete2kernel['RPU'])
            
                message2print = "{(Step R/33) got" + "; rpu-got-by-delete2kernel4xi: " + str(kernel4xi['RPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'R-'
            except: 
               message2print = "{(Step RZ1/33) yielded" + "; rpu-yielded-by-delete2kernel4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
               print4xi(class2print, method2print, message2print)  
               code2nack  = code2nack + 'RZ1-'     
        if 'SPU' in keys2delete4kernel:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step S/33) - SPU
                # -----------------------------------------------------------------------------------------               
                response2delete4xi['SPU'] = delete2kernel4spu(task4delete2kernel['SPU'])
            
                message2print = "{(Step S/33) got" + "; spu-got-by-delete2kernel4xi: " + str(kernel4xi['SPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'S-'
            except: 
               message2print = "{(Step SZ1/33) yielded" + "; spu-yielded-by-delete2kernel4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
               print4xi(class2print, method2print, message2print)  
               code2nack  = code2nack + 'SZ1-'     
        if 'TPU' in keys2delete4kernel:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step T/33) - TPU
                # -----------------------------------------------------------------------------------------               
                response2delete4xi['TPU'] = delete2kernel4tpu(task4delete2kernel['TPU'])
            
                message2print = "{(Step T/33) got" + "; tpu-got-by-delete2kernel4xi: " + str(kernel4xi['TPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'T-'
            except: 
               message2print = "{(Step TZ1/33) yielded" + "; tpu-yielded-by-delete2kernel4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
               print4xi(class2print, method2print, message2print)  
               code2nack  = code2nack + 'TZ1-'     
        if 'UPU' in keys2delete4kernel:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step U/33) - UPU
                # -----------------------------------------------------------------------------------------               
                response2delete4xi['UPU'] = delete2kernel4upu(task4delete2kernel['UPU'])
            
                message2print = "{(Step U/33) got" + "; upu-got-by-delete2kernel4xi: " + str(kernel4xi['UPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'U-'
            except: 
               message2print = "{(Step UZ1/33) yielded" + "; upu-yielded-by-delete2kernel4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
               print4xi(class2print, method2print, message2print)  
               code2nack  = code2nack + 'UZ1-'     
        if 'VPU' in keys2delete4kernel:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step V/33) - VPU
                # -----------------------------------------------------------------------------------------               
                response2delete4xi['VPU'] = delete2kernel4vpu(task4delete2kernel['VPU'])
            
                message2print = "{(Step V/33) got" + "; vpu-got-by-delete2kernel4xi: " + str(kernel4xi['VPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'V-'
            except: 
               message2print = "{(Step VZ1/33) yielded" + "; vpu-yielded-by-delete2kernel4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
               print4xi(class2print, method2print, message2print)  
               code2nack  = code2nack + 'VZ1-'     
        if 'WPU' in keys2delete4kernel:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step W/33) - WPU
                # -----------------------------------------------------------------------------------------               
                response2delete4xi['WPU'] = delete2kernel4wpu(task4delete2kernel['WPU'])
            
                message2print = "{(Step W/33) got" + "; wpu-got-by-delete2kernel4xi: " + str(kernel4xi['WPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'W-'
            except: 
               message2print = "{(Step WZ1/33) yielded" + "; wpu-yielded-by-delete2kernel4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
               print4xi(class2print, method2print, message2print)  
               code2nack  = code2nack + 'WZ1-'     
        if 'XPU' in keys2delete4kernel:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step X/33) - XPU
                # -----------------------------------------------------------------------------------------               
                response2delete4xi['XPU'] = delete2kernel4xpu(task4delete2kernel['XPU'])
            
                message2print = "{(Step X/33) got" + "; xpu-got-by-delete2kernel4xi: " + str(kernel4xi['XPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'X-'
            except: 
               message2print = "{(Step XZ1/33) yielded" + "; xpu-yielded-by-delete2kernel4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
               print4xi(class2print, method2print, message2print)  
               code2nack  = code2nack + 'XZ1-'     
        if 'YPU' in keys2delete4kernel:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step Y/33) - YPU
                # -----------------------------------------------------------------------------------------               
                response2delete4xi['YPU'] = delete2kernel4ypu(task4delete2kernel['YPU'])
            
                message2print = "{(Step Y/33) got" + "; ypu-got-by-delete2kernel4xi: " + str(kernel4xi['YPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'Y-'
            except: 
               message2print = "{(Step YZ1/33) yielded" + "; ypu-yielded-by-delete2kernel4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
               print4xi(class2print, method2print, message2print)  
               code2nack  = code2nack + 'YZ1-'     
        if 'ZPU' in keys2delete4kernel:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step Z/33) - ZPU
                # -----------------------------------------------------------------------------------------               
                response2delete4xi['ZPU'] = delete2kernel4zpu(task4delete2kernel['ZPU'])
            
                message2print = "{(Step Z/33) got" + "; zpu-got-by-delete2kernel4xi: " + str(kernel4xi['ZPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'Z-'
            except: 
               message2print = "{(Step ZZ1/33) yielded" + "; zpu-yielded-by-delete2kernel4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
               print4xi(class2print, method2print, message2print)  
               code2nack  = code2nack + 'ZZ1-'                 

            
          
    # -----------------------------------------------------------------------------------------
    # (Step 33/3)           
    # -----------------------------------------------------------------------------------------
    if debug is True:
        print("{(Step 33/33) of delete2kernel4xi - RETURNING response2delete4xi: ", response2delete4xi)
            
    message2print = "{(Step 33/33) returning" + "; response2delete4xi-returning-by-delete2kernel4xi: " + str(response2delete4xi) + "; time: " + time4xi() + "}"  
    print4xi(class2print, method2print, message2print)                                                              
    # 

    return response2delete4xi
            
#</function4xi>  


# -------------------------------------------------------------------------------------------------
#<function4xi function = "execute2kernel4xi" usage = "
#    
#   print('=' *33)          
#   print('(Step 2A/700) OF KERNEL4XI5TEST - TRYING TO EXECUTE KERNEL OF XI ', time4xi())      
#   print('=' *33)        
#   # 
#   try:
#       response4execute2kernel = execute2kernel4xi()                                                                 
#       print('(Step 2B/700) OF KERNEL4XI5TEST - EXECUTED KERNEL OF XI ', time4xi())
#       keys2response = response4execute2kernel.keys()
#       for key2response in sorted(keys2response):
#           print(key2response, ' : ', response4execute2kernel[key2response])
#           # 
#   except:
#       print('(Step 2Z1/700) OF KERNEL4XI5TEST *** FAILED TO EXECUTE KERNEL OF XI *** ', time4xi())
#
#">

# -------------------------------------------------------------------------------------------------   
def execute2kernel4xi(task4execute2kernel=None):

    '''
    executes kernel of xi
    '''
    global platform2xi
    global device2xi
    global context2xi 
    global kernel4xi
    global info2kernel4xi                                                                                              
    
    # -----------------------------------------------------------------------------------------
    # (Step 1/70) - START           
    # -----------------------------------------------------------------------------------------          
    debug = False
    response2execute4xi = {} 
        
    class2print = "execute2kernel4xi"  
    method2print = "execute2kernel4xi"

    message2print = "{(Step 1A/70) started" + "; execute2kernel4xi-started: " + str(execute2kernel4xi)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)
    # 
  
             
    message2print = "{(Step 1B/70) passed" + "; task4execute2kernel-to-execute2kernel4xi: " + str(task4execute2kernel) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                                                              
    # {'BPU': 'Yes'}

    code2ack  = ' '
    code2nack = ' '    
    
    ack2all = False             
    if task4execute2kernel is None:
        # -----------------------------------------------------------------------------------------
        # NO PARAMETERS GIVEN BY CALLER FOR INITIALIZATION - SYSTEM CREATES ALL
        # -----------------------------------------------------------------------------------------    
        ack2all = True                                                                                                
        code2ack  = code2ack + '1C-'
    else:
        # -----------------------------------------------------------------------------------------
        # SOME PARAMETERS GIVEN BY CALLER FOR INITIALIZATION - KERNEL4XI NEEDS INITIALIZATION
        # -----------------------------------------------------------------------------------------        
        try:
            if kernel4xi is None:                                                                                       
                kernel4xi = create2kernel4xi() 
                code2ack  = code2ack + '1D-'
        except:
            kernel4xi = create2kernel4xi()
            code2ack  = code2ack + '1D-'
                        
    # -----------------------------------------------------------------------------------------
    # (Step 2/33)
    # -----------------------------------------------------------------------------------------                  
    message2print = "{(Step 2A/3) try" + "; task4execute2kernel-try-by-execute2kernel4xi: " + str(task4execute2kernel)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print) 
    # {'BPU': 'Yes'}
    
    if ack2all is True:
        try:
            # -----------------------------------------------------------------------------------------
            # (Step 3/33) - ALL DEVICES
            # ----------------------------------------------------------------------------------------- 
            
            response2execute4xi['APU'] = execute2kernel4apu()                                                                        
            response2execute4xi['BPU'] = execute2kernel4bpu()   
            response2execute4xi['CPU'] = execute2kernel4cpu()   
            response2execute4xi['DPU'] = execute2kernel4dpu()   
            response2execute4xi['EPU'] = execute2kernel4epu()   
            response2execute4xi['FPU'] = execute2kernel4fpu()   
            response2execute4xi['GPU'] = execute2kernel4gpu()   
            response2execute4xi['HPU'] = execute2kernel4hpu()   
            response2execute4xi['IPU'] = execute2kernel4ipu()   
            response2execute4xi['JPU'] = execute2kernel4jpu()   
            response2execute4xi['KPU'] = execute2kernel4kpu()   
            response2execute4xi['LPU'] = execute2kernel4lpu()   
            response2execute4xi['MPU'] = execute2kernel4mpu()   
            response2execute4xi['NPU'] = execute2kernel4npu()   
            response2execute4xi['OPU'] = execute2kernel4opu()   
            response2execute4xi['PPU'] = execute2kernel4ppu()   
            response2execute4xi['QPU'] = execute2kernel4qpu()   
            response2execute4xi['RPU'] = execute2kernel4rpu()   
            response2execute4xi['SPU'] = execute2kernel4spu()   
            response2execute4xi['TPU'] = execute2kernel4tpu()   
            response2execute4xi['UPU'] = execute2kernel4upu()   
            response2execute4xi['VPU'] = execute2kernel4vpu()   
            response2execute4xi['XPU'] = execute2kernel4xpu()   
            response2execute4xi['WPU'] = execute2kernel4wpu()   
            response2execute4xi['YPU'] = execute2kernel4ypu()   
            response2execute4xi['ZPU'] = execute2kernel4zpu()   
            
            message2print = "{(Step 3A/33) got" + "; response2execute4xi-got-by-execute2kernel4xi: " + str(response2execute4xi)  + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print)                                                      
            # 
            
            code2ack  = code2ack + '3A-'
        except:
            message2print = "{(Step 3Z1/33) yielded" + "; kernel4xi-yielded-by-execute2kernel4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                               #   
            code2nack  = code2nack + '3Z1-'
    else:    
        keys2execute4kernel = task4execute2kernel.keys()
        if 'APU' in keys2execute4kernel:
            try:
                # -----------------------------------------------------------------------------------------
                # (Step A/33) - APU
                # -----------------------------------------------------------------------------------------               
                response2execute4xi['APU'] = execute2kernel4apu()
            
                message2print = "{(Step A/33) got" + "; apu-got-by-execute2kernel4xi: " + str(kernel4xi['APU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'A-'
            except: 
                message2print = "{(Step AZ1/33) yielded" + "; apu-yielded-by-execute2kernel4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'AZ1-'          
        if 'BPU' in keys2execute4kernel:
            try:
                # -----------------------------------------------------------------------------------------
                # (Step B/33) - BPU
                # -----------------------------------------------------------------------------------------               
                response2execute4xi['BPU'] = execute2kernel4bpu()
            
                message2print = "{(Step B/33) got" + "; bpu-got-by-execute2kernel4xi: " + str(kernel4xi['BPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'B-'
            except: 
                message2print = "{(Step BZ1/33) yielded" + "; bpu-yielded-by-execute2kernel4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'BZ1-'     
        if 'CPU' in keys2execute4kernel:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step C/33) - CPU
                # -----------------------------------------------------------------------------------------               
                response2execute4xi['CPU'] = execute2kernel4cpu()
            
                message2print = "{(Step C/33) got" + "; cpu-got-by-execute2kernel4xi: " + str(kernel4xi['CPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'C-'
            except: 
                message2print = "{(Step CZ1/33) yielded" + "; cpu-yielded-by-execute2kernel4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'CZ1-'     
        if 'DPU' in keys2execute4kernel:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step D/33) - DPU
                # -----------------------------------------------------------------------------------------               
                response2execute4xi['DPU'] = execute2kernel4dpu()
            
                message2print = "{(Step D/33) got" + "; dpu-got-by-execute2kernel4xi: " + str(kernel4xi['DPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'D-'
            except: 
                message2print = "{(Step DZ1/33) yielded" + "; dpu-yielded-by-execute2kernel4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'DZ1-'     
        if 'EPU' in keys2execute4kernel:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step E/33) - EPU
                # -----------------------------------------------------------------------------------------               
                response2execute4xi['EPU'] = execute2kernel4epu()
            
                message2print = "{(Step E/33) got" + "; epu-got-by-execute2kernel4xi: " + str(kernel4xi['EPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'E-'
            except: 
                message2print = "{(Step EZ1/33) yielded" + "; epu-yielded-by-execute2kernel4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'EZ1-'     
        if 'FPU' in keys2execute4kernel:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step F/33) - FPU
                # -----------------------------------------------------------------------------------------               
                response2execute4xi['FPU'] = execute2kernel4fpu()
            
                message2print = "{(Step F/33) got" + "; fpu-got-by-execute2kernel4xi: " + str(kernel4xi['FPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'F-'
            except: 
                message2print = "{(Step FZ1/33) yielded" + "; fpu-yielded-by-execute2kernel4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'FZ1-'     
        if 'GPU' in keys2execute4kernel:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step G/33) - GPU
                # -----------------------------------------------------------------------------------------               
                response2execute4xi['GPU'] = execute2kernel4gpu()
            
                message2print = "{(Step G/33) got" + "; gpu-got-by-execute2kernel4xi: " + str(kernel4xi['GPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'G-'
            except: 
                message2print = "{(Step GZ1/33) yielded" + "; gpu-yielded-by-execute2kernel4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'GZ1-'     
        if 'HPU' in keys2execute4kernel:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step H/33) - HPU
                # -----------------------------------------------------------------------------------------               
                response2execute4xi['HPU'] = execute2kernel4hpu()
            
                message2print = "{(Step H/33) got" + "; hpu-got-by-execute2kernel4xi: " + str(kernel4xi['HPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'H-'
            except: 
                message2print = "{(Step HZ1/33) yielded" + "; hpu-yielded-by-execute2kernel4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'HZ1-'     
        if 'IPU' in keys2execute4kernel:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step I/33) - IPU
                # -----------------------------------------------------------------------------------------               
                response2execute4xi['IPU'] = execute2kernel4ipu()
            
                message2print = "{(Step I/33) got" + "; ipu-got-by-execute2kernel4xi: " + str(kernel4xi['IPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'I-'
            except: 
                message2print = "{(Step IZ1/33) yielded" + "; ipu-yielded-by-execute2kernel4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'IZ1-'     
        if 'JPU' in keys2execute4kernel:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step J/33) - JPU
                # -----------------------------------------------------------------------------------------               
                response2execute4xi['JPU'] = execute2kernel4jpu()
            
                message2print = "{(Step J/33) got" + "; jpu-got-by-execute2kernel4xi: " + str(kernel4xi['JPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'J-'
            except: 
                message2print = "{(Step JZ1/33) yielded" + "; jpu-yielded-by-execute2kernel4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'JZ1-'     
        if 'KPU' in keys2execute4kernel:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step K/33) - KPU
                # -----------------------------------------------------------------------------------------               
                response2execute4xi['KPU'] = execute2kernel4kpu()
            
                message2print = "{(Step K/33) got" + "; kpu-got-by-execute2kernel4xi: " + str(kernel4xi['KPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'K-'
            except: 
                message2print = "{(Step KZ1/33) yielded" + "; kpu-yielded-by-execute2kernel4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'KZ1-'     
        if 'LPU' in keys2execute4kernel:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step L/33) - LPU
                # -----------------------------------------------------------------------------------------               
                response2execute4xi['LPU'] = execute2kernel4lpu()
            
                message2print = "{(Step L/33) got" + "; lpu-got-by-execute2kernel4xi: " + str(kernel4xi['LPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'L-'
            except: 
                message2print = "{(Step LZ1/33) yielded" + "; lpu-yielded-by-execute2kernel4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'LZ1-'     
        if 'MPU' in keys2execute4kernel:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step M/33) - MPU
                # -----------------------------------------------------------------------------------------               
                response2execute4xi['MPU'] = execute2kernel4mpu()
            
                message2print = "{(Step M/33) got" + "; mpu-got-by-execute2kernel4xi: " + str(kernel4xi['MPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'M-'
            except: 
                message2print = "{(Step MZ1/33) yielded" + "; mpu-yielded-by-execute2kernel4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'MZ1-'     
        if 'NPU' in keys2execute4kernel:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step N/33) - NPU
                # -----------------------------------------------------------------------------------------               
                response2execute4xi['NPU'] = execute2kernel4npu()
            
                message2print = "{(Step N/33) got" + "; npu-got-by-execute2kernel4xi: " + str(kernel4xi['NPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'N-'
            except: 
                message2print = "{(Step NZ1/33) yielded" + "; npu-yielded-by-execute2kernel4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'NZ1-'     
        if 'OPU' in keys2execute4kernel:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step O/33) - OPU
                # -----------------------------------------------------------------------------------------               
                response2execute4xi['OPU'] = execute2kernel4opu()
            
                message2print = "{(Step O/33) got" + "; opu-got-by-execute2kernel4xi: " + str(kernel4xi['OPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'O-'
            except: 
                message2print = "{(Step OZ1/33) yielded" + "; opu-yielded-by-execute2kernel4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'OZ1-'     
        if 'PPU' in keys2execute4kernel:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step P/33) - PPU
                # -----------------------------------------------------------------------------------------               
                response2execute4xi['PPU'] = execute2kernel4ppu()
            
                message2print = "{(Step P/33) got" + "; ppu-got-by-execute2kernel4xi: " + str(kernel4xi['PPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'P-'
            except: 
                message2print = "{(Step PZ1/33) yielded" + "; ppu-yielded-by-execute2kernel4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'PZ1-'     
        if 'QPU' in keys2execute4kernel:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step Q/33) - QPU
                # -----------------------------------------------------------------------------------------               
                response2execute4xi['QPU'] = execute2kernel4qpu()
            
                message2print = "{(Step Q/33) got" + "; qpu-got-by-execute2kernel4xi: " + str(kernel4xi['QPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'Q-'
            except: 
                message2print = "{(Step QZ1/33) yielded" + "; qpu-yielded-by-execute2kernel4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'QZ1-'     
        if 'RPU' in keys2execute4kernel:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step R/33) - RPU
                # -----------------------------------------------------------------------------------------               
                response2execute4xi['RPU'] = execute2kernel4rpu()
            
                message2print = "{(Step R/33) got" + "; rpu-got-by-execute2kernel4xi: " + str(kernel4xi['RPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'R-'
            except: 
                message2print = "{(Step RZ1/33) yielded" + "; rpu-yielded-by-execute2kernel4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'RZ1-'     
        if 'SPU' in keys2execute4kernel:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step S/33) - SPU
                # -----------------------------------------------------------------------------------------               
                response2execute4xi['SPU'] = execute2kernel4spu()
            
                message2print = "{(Step S/33) got" + "; spu-got-by-execute2kernel4xi: " + str(kernel4xi['SPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'S-'
            except: 
                message2print = "{(Step SZ1/33) yielded" + "; spu-yielded-by-execute2kernel4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'SZ1-'     
        if 'TPU' in keys2execute4kernel:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step T/33) - TPU
                # -----------------------------------------------------------------------------------------               
                response2execute4xi['TPU'] = execute2kernel4tpu()
            
                message2print = "{(Step T/33) got" + "; tpu-got-by-execute2kernel4xi: " + str(kernel4xi['TPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'T-'
            except: 
                message2print = "{(Step TZ1/33) yielded" + "; tpu-yielded-by-execute2kernel4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'TZ1-'     
        if 'UPU' in keys2execute4kernel:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step U/33) - UPU
                # -----------------------------------------------------------------------------------------               
                response2execute4xi['UPU'] = execute2kernel4upu()
            
                message2print = "{(Step U/33) got" + "; upu-got-by-execute2kernel4xi: " + str(kernel4xi['UPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'U-'
            except: 
                message2print = "{(Step UZ1/33) yielded" + "; upu-yielded-by-execute2kernel4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'UZ1-'     
        if 'VPU' in keys2execute4kernel:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step V/33) - VPU
                # -----------------------------------------------------------------------------------------               
                response2execute4xi['VPU'] = execute2kernel4vpu()
            
                message2print = "{(Step V/33) got" + "; vpu-got-by-execute2kernel4xi: " + str(kernel4xi['VPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'V-'
            except: 
                message2print = "{(Step VZ1/33) yielded" + "; vpu-yielded-by-execute2kernel4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'VZ1-'     
        if 'WPU' in keys2execute4kernel:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step W/33) - WPU
                # -----------------------------------------------------------------------------------------               
                response2execute4xi['WPU'] = execute2kernel4wpu()
            
                message2print = "{(Step W/33) got" + "; wpu-got-by-execute2kernel4xi: " + str(kernel4xi['WPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'W-'
            except: 
                message2print = "{(Step WZ1/33) yielded" + "; wpu-yielded-by-execute2kernel4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'WZ1-'     
        if 'XPU' in keys2execute4kernel:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step X/33) - XPU
                # -----------------------------------------------------------------------------------------               
                response2execute4xi['XPU'] = execute2kernel4xpu()
            
                message2print = "{(Step X/33) got" + "; xpu-got-by-execute2kernel4xi: " + str(kernel4xi['XPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'X-'
            except: 
                message2print = "{(Step XZ1/33) yielded" + "; xpu-yielded-by-execute2kernel4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'XZ1-'     
        if 'YPU' in keys2execute4kernel:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step Y/33) - YPU
                # -----------------------------------------------------------------------------------------               
                response2execute4xi['YPU'] = execute2kernel4ypu()
            
                message2print = "{(Step Y/33) got" + "; ypu-got-by-execute2kernel4xi: " + str(kernel4xi['YPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'Y-'
            except: 
                message2print = "{(Step YZ1/33) yielded" + "; ypu-yielded-by-execute2kernel4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'YZ1-'     
        if 'ZPU' in keys2execute4kernel:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step Z/33) - ZPU
                # -----------------------------------------------------------------------------------------               
                response2execute4xi['ZPU'] = execute2kernel4zpu()
            
                message2print = "{(Step Z/33) got" + "; zpu-got-by-execute2kernel4xi: " + str(kernel4xi['ZPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'Z-'
            except: 
                message2print = "{(Step ZZ1/33) yielded" + "; zpu-yielded-by-execute2kernel4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'ZZ1-'                 

            
          
    # -----------------------------------------------------------------------------------------
    # (Step 33/3)           
    # -----------------------------------------------------------------------------------------
    if debug is True:
        print("{(Step 33/33) of execute2kernel4xi - RETURNING response2execute4xi: ", response2execute4xi)
            
    message2print = "{(Step 33/33) returning" + "; response2execute4xi-returning-by-execute2kernel4xi: " + str(response2execute4xi) + "; time: " + time4xi() + "}"  
    print4xi(class2print, method2print, message2print)                                                              
    # 

    return response2execute4xi
            
#</function4xi>  

# -------------------------------------------------------------------------------------------------
#<function4xi function = "execute2nativekernel4xi" usage = "
#    
#   print('=' *33)          
#   print('(Step 2A/700) OF NATIVE KERNEL4XI5TEST - TRYING TO EXECUTE NATIVE KERNEL OF XI ', time4xi())      
#   print('=' *33)        
#   
#   try:
#       response4execute2nativekernel = execute2nativekernel4xi()                                                                 
#       print('(Step 2B/700) OF NATIVE KERNEL4XI5TEST - EXECUTED NATIVE KERNEL OF XI ', time4xi())
#       keys2response = response4execute2nativekernel.keys()
#       for key2response in sorted(keys2response):
#           print(key2response, ' : ', response4execute2nativekernel[key2response])
#           # 
#   except:
#       print('(Step 2Z1/700) OF NATIVE KERNEL4XI5TEST *** FAILED TO EXECUTE NATIVE KERNEL OF XI *** ', time4xi())
#
#">

# -------------------------------------------------------------------------------------------------   
def execute2nativekernel4xi(task4execute2nativekernel=None):

    '''
    executes kernel of xi
    '''
    global platform2xi
    global device2xi
    global context2xi 
    global kernel4xi
    global info2kernel4xi                                                                                              
    
    # -----------------------------------------------------------------------------------------
    # (Step 1/70) - START           
    # -----------------------------------------------------------------------------------------          
    debug = False
    response2execute4xi = {} 
        
    class2print = "execute2nativekernel4xi"  
    method2print = "execute2nativekernel4xi"

    message2print = "{(Step 1A/70) started" + "; execute2nativekernel4xi-started: " + str(execute2nativekernel4xi)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)
    # 
  
             
    message2print = "{(Step 1B/70) passed" + "; task4execute2nativekernel-to-execute2nativekernel4xi: " + str(task4execute2nativekernel) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                                                              
    # {'BPU': 'Yes'}

    code2ack  = ' '
    code2nack = ' '    
    
    ack2all = False             
    if task4execute2nativekernel is None:
        # -----------------------------------------------------------------------------------------
        # NO PARAMETERS GIVEN BY CALLER FOR INITIALIZATION - SYSTEM CREATES ALL
        # -----------------------------------------------------------------------------------------    
        ack2all = True                                                                                                
        code2ack  = code2ack + '1C-'
    else:
        # -----------------------------------------------------------------------------------------
        # SOME PARAMETERS GIVEN BY CALLER FOR INITIALIZATION - NATIVE KERNEL4XI NEEDS INITIALIZATION
        # -----------------------------------------------------------------------------------------        
        try:
            if kernel4xi is None:                                                                                       
                kernel4xi = create2kernel4xi() 
                code2ack  = code2ack + '1D-'
        except:
            kernel4xi = create2kernel4xi()
            code2ack  = code2ack + '1D-'
                        
    # -----------------------------------------------------------------------------------------
    # (Step 2/33)
    # -----------------------------------------------------------------------------------------                  
    message2print = "{(Step 2A/3) try" + "; task4execute2nativekernel-try-by-execute2nativekernel4xi: " + str(task4execute2nativekernel)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print) 
    # {'BPU': 'Yes'}
    
    if ack2all is True:
        try:
            # -----------------------------------------------------------------------------------------
            # (Step 3/33) - ALL DEVICES
            # ----------------------------------------------------------------------------------------- 
            
            response2execute4xi['APU'] = execute2nativekernel4apu()                                                                        
            response2execute4xi['BPU'] = execute2nativekernel4bpu()   
            response2execute4xi['CPU'] = execute2nativekernel4cpu()   
            response2execute4xi['DPU'] = execute2nativekernel4dpu()   
            response2execute4xi['EPU'] = execute2nativekernel4epu()   
            response2execute4xi['FPU'] = execute2nativekernel4fpu()   
            response2execute4xi['GPU'] = execute2nativekernel4gpu()   
            response2execute4xi['HPU'] = execute2nativekernel4hpu()   
            response2execute4xi['IPU'] = execute2nativekernel4ipu()   
            response2execute4xi['JPU'] = execute2nativekernel4jpu()   
            response2execute4xi['KPU'] = execute2nativekernel4kpu()   
            response2execute4xi['LPU'] = execute2nativekernel4lpu()   
            response2execute4xi['MPU'] = execute2nativekernel4mpu()   
            response2execute4xi['NPU'] = execute2nativekernel4npu()   
            response2execute4xi['OPU'] = execute2nativekernel4opu()   
            response2execute4xi['PPU'] = execute2nativekernel4ppu()   
            response2execute4xi['QPU'] = execute2nativekernel4qpu()   
            response2execute4xi['RPU'] = execute2nativekernel4rpu()   
            response2execute4xi['SPU'] = execute2nativekernel4spu()   
            response2execute4xi['TPU'] = execute2nativekernel4tpu()   
            response2execute4xi['UPU'] = execute2nativekernel4upu()   
            response2execute4xi['VPU'] = execute2nativekernel4vpu()   
            response2execute4xi['XPU'] = execute2nativekernel4xpu()   
            response2execute4xi['WPU'] = execute2nativekernel4wpu()   
            response2execute4xi['YPU'] = execute2nativekernel4ypu()   
            response2execute4xi['ZPU'] = execute2nativekernel4zpu()   
            
            message2print = "{(Step 3A/33) got" + "; response2execute4xi-got-by-execute2nativekernel4xi: " + str(response2execute4xi)  + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print)                                                      
            # 
            
            code2ack  = code2ack + '3A-'
        except:
            message2print = "{(Step 3Z1/33) yielded" + "; kernel4xi-yielded-by-execute2nativekernel4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                               #   
            code2nack  = code2nack + '3Z1-'
    else:    
        keys2execute4nativekernel = task4execute2nativekernel.keys()
        if 'APU' in  keys2execute4nativekernel:   
            try:
                # -----------------------------------------------------------------------------------------
                # (Step A/33) - APU
                # -----------------------------------------------------------------------------------------               
                response2execute4xi['APU'] = execute2nativekernel4apu()
            
                message2print = "{(Step A/33) got" + "; apu-got-by-execute2nativekernel4xi: " + str(kernel4xi['APU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'A-'
            except: 
                message2print = "{(Step AZ1/33) yielded" + "; apu-yielded-by-execute2nativekernel4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'AZ1-'          
        if 'BPU' in  keys2execute4nativekernel:
            try:
                # -----------------------------------------------------------------------------------------
                # (Step B/33) - BPU
                # -----------------------------------------------------------------------------------------               
                response2execute4xi['BPU'] = execute2nativekernel4bpu()
            
                message2print = "{(Step B/33) got" + "; bpu-got-by-execute2nativekernel4xi: " + str(kernel4xi['BPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'B-'
            except: 
                message2print = "{(Step BZ1/33) yielded" + "; bpu-yielded-by-execute2nativekernel4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'BZ1-'     
        if 'CPU' in  keys2execute4nativekernel:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step C/33) - CPU
                # -----------------------------------------------------------------------------------------               
                response2execute4xi['CPU'] = execute2nativekernel4cpu()
            
                message2print = "{(Step C/33) got" + "; cpu-got-by-execute2nativekernel4xi: " + str(kernel4xi['CPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'C-'
            except: 
                message2print = "{(Step CZ1/33) yielded" + "; cpu-yielded-by-execute2nativekernel4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'CZ1-'     
        if 'DPU' in  keys2execute4nativekernel:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step D/33) - DPU
                # -----------------------------------------------------------------------------------------               
                response2execute4xi['DPU'] = execute2nativekernel4dpu()
            
                message2print = "{(Step D/33) got" + "; dpu-got-by-execute2nativekernel4xi: " + str(kernel4xi['DPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'D-'
            except: 
                message2print = "{(Step DZ1/33) yielded" + "; dpu-yielded-by-execute2nativekernel4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'DZ1-'     
        if 'EPU' in  keys2execute4nativekernel:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step E/33) - EPU
                # -----------------------------------------------------------------------------------------               
                response2execute4xi['EPU'] = execute2nativekernel4epu()
            
                message2print = "{(Step E/33) got" + "; epu-got-by-execute2nativekernel4xi: " + str(kernel4xi['EPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'E-'
            except: 
                message2print = "{(Step EZ1/33) yielded" + "; epu-yielded-by-execute2nativekernel4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'EZ1-'     
        if 'FPU' in  keys2execute4nativekernel:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step F/33) - FPU
                # -----------------------------------------------------------------------------------------               
                response2execute4xi['FPU'] = execute2nativekernel4fpu()
            
                message2print = "{(Step F/33) got" + "; fpu-got-by-execute2nativekernel4xi: " + str(kernel4xi['FPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'F-'
            except: 
                message2print = "{(Step FZ1/33) yielded" + "; fpu-yielded-by-execute2nativekernel4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'FZ1-'     
        if 'GPU' in  keys2execute4nativekernel:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step G/33) - GPU
                # -----------------------------------------------------------------------------------------               
                response2execute4xi['GPU'] = execute2nativekernel4gpu()
            
                message2print = "{(Step G/33) got" + "; gpu-got-by-execute2nativekernel4xi: " + str(kernel4xi['GPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'G-'
            except: 
                message2print = "{(Step GZ1/33) yielded" + "; gpu-yielded-by-execute2nativekernel4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'GZ1-'     
        if 'HPU' in  keys2execute4nativekernel:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step H/33) - HPU
                # -----------------------------------------------------------------------------------------               
                response2execute4xi['HPU'] = execute2nativekernel4hpu()
            
                message2print = "{(Step H/33) got" + "; hpu-got-by-execute2nativekernel4xi: " + str(kernel4xi['HPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'H-'
            except: 
                message2print = "{(Step HZ1/33) yielded" + "; hpu-yielded-by-execute2nativekernel4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'HZ1-'     
        if 'IPU' in  keys2execute4nativekernel:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step I/33) - IPU
                # -----------------------------------------------------------------------------------------               
                response2execute4xi['IPU'] = execute2nativekernel4ipu()
            
                message2print = "{(Step I/33) got" + "; ipu-got-by-execute2nativekernel4xi: " + str(kernel4xi['IPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'I-'
            except: 
                message2print = "{(Step IZ1/33) yielded" + "; ipu-yielded-by-execute2nativekernel4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'IZ1-'     
        if 'JPU' in  keys2execute4nativekernel:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step J/33) - JPU
                # -----------------------------------------------------------------------------------------               
                response2execute4xi['JPU'] = execute2nativekernel4jpu()
            
                message2print = "{(Step J/33) got" + "; jpu-got-by-execute2nativekernel4xi: " + str(kernel4xi['JPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'J-'
            except: 
                message2print = "{(Step JZ1/33) yielded" + "; jpu-yielded-by-execute2nativekernel4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'JZ1-'     
        if 'KPU' in  keys2execute4nativekernel:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step K/33) - KPU
                # -----------------------------------------------------------------------------------------               
                response2execute4xi['KPU'] = execute2nativekernel4kpu()
            
                message2print = "{(Step K/33) got" + "; kpu-got-by-execute2nativekernel4xi: " + str(kernel4xi['KPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'K-'
            except: 
                message2print = "{(Step KZ1/33) yielded" + "; kpu-yielded-by-execute2nativekernel4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'KZ1-'     
        if 'LPU' in  keys2execute4nativekernel:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step L/33) - LPU
                # -----------------------------------------------------------------------------------------               
                response2execute4xi['LPU'] = execute2nativekernel4lpu()
            
                message2print = "{(Step L/33) got" + "; lpu-got-by-execute2nativekernel4xi: " + str(kernel4xi['LPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'L-'
            except: 
                message2print = "{(Step LZ1/33) yielded" + "; lpu-yielded-by-execute2nativekernel4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'LZ1-'     
        if 'MPU' in  keys2execute4nativekernel:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step M/33) - MPU
                # -----------------------------------------------------------------------------------------               
                response2execute4xi['MPU'] = execute2nativekernel4mpu()
            
                message2print = "{(Step M/33) got" + "; mpu-got-by-execute2nativekernel4xi: " + str(kernel4xi['MPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'M-'
            except: 
                message2print = "{(Step MZ1/33) yielded" + "; mpu-yielded-by-execute2nativekernel4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'MZ1-'     
        if 'NPU' in  keys2execute4nativekernel:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step N/33) - NPU
                # -----------------------------------------------------------------------------------------               
                response2execute4xi['NPU'] = execute2nativekernel4npu()
            
                message2print = "{(Step N/33) got" + "; npu-got-by-execute2nativekernel4xi: " + str(kernel4xi['NPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'N-'
            except: 
                message2print = "{(Step NZ1/33) yielded" + "; npu-yielded-by-execute2nativekernel4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'NZ1-'     
        if 'OPU' in  keys2execute4nativekernel:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step O/33) - OPU
                # -----------------------------------------------------------------------------------------               
                response2execute4xi['OPU'] = execute2nativekernel4opu()
            
                message2print = "{(Step O/33) got" + "; opu-got-by-execute2nativekernel4xi: " + str(kernel4xi['OPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'O-'
            except: 
                message2print = "{(Step OZ1/33) yielded" + "; opu-yielded-by-execute2nativekernel4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'OZ1-'     
        if 'PPU' in  keys2execute4nativekernel:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step P/33) - PPU
                # -----------------------------------------------------------------------------------------               
                response2execute4xi['PPU'] = execute2nativekernel4ppu()
            
                message2print = "{(Step P/33) got" + "; ppu-got-by-execute2nativekernel4xi: " + str(kernel4xi['PPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'P-'
            except: 
                message2print = "{(Step PZ1/33) yielded" + "; ppu-yielded-by-execute2nativekernel4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'PZ1-'     
        if 'QPU' in  keys2execute4nativekernel:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step Q/33) - QPU
                # -----------------------------------------------------------------------------------------               
                response2execute4xi['QPU'] = execute2nativekernel4qpu()
            
                message2print = "{(Step Q/33) got" + "; qpu-got-by-execute2nativekernel4xi: " + str(kernel4xi['QPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'Q-'
            except: 
                message2print = "{(Step QZ1/33) yielded" + "; qpu-yielded-by-execute2nativekernel4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'QZ1-'     
        if 'RPU' in  keys2execute4nativekernel:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step R/33) - RPU
                # -----------------------------------------------------------------------------------------               
                response2execute4xi['RPU'] = execute2nativekernel4rpu()
            
                message2print = "{(Step R/33) got" + "; rpu-got-by-execute2nativekernel4xi: " + str(kernel4xi['RPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'R-'
            except: 
                message2print = "{(Step RZ1/33) yielded" + "; rpu-yielded-by-execute2nativekernel4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'RZ1-'     
        if 'SPU' in  keys2execute4nativekernel:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step S/33) - SPU
                # -----------------------------------------------------------------------------------------               
                response2execute4xi['SPU'] = execute2nativekernel4spu()
            
                message2print = "{(Step S/33) got" + "; spu-got-by-execute2nativekernel4xi: " + str(kernel4xi['SPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'S-'
            except: 
                message2print = "{(Step SZ1/33) yielded" + "; spu-yielded-by-execute2nativekernel4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'SZ1-'     
        if 'TPU' in  keys2execute4nativekernel:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step T/33) - TPU
                # -----------------------------------------------------------------------------------------               
                response2execute4xi['TPU'] = execute2nativekernel4tpu()
            
                message2print = "{(Step T/33) got" + "; tpu-got-by-execute2nativekernel4xi: " + str(kernel4xi['TPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'T-'
            except: 
                message2print = "{(Step TZ1/33) yielded" + "; tpu-yielded-by-execute2nativekernel4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'TZ1-'     
        if 'UPU' in  keys2execute4nativekernel:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step U/33) - UPU
                # -----------------------------------------------------------------------------------------               
                response2execute4xi['UPU'] = execute2nativekernel4upu()
            
                message2print = "{(Step U/33) got" + "; upu-got-by-execute2nativekernel4xi: " + str(kernel4xi['UPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'U-'
            except: 
                message2print = "{(Step UZ1/33) yielded" + "; upu-yielded-by-execute2nativekernel4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'UZ1-'     
        if 'VPU' in  keys2execute4nativekernel:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step V/33) - VPU
                # -----------------------------------------------------------------------------------------               
                response2execute4xi['VPU'] = execute2nativekernel4vpu()
            
                message2print = "{(Step V/33) got" + "; vpu-got-by-execute2nativekernel4xi: " + str(kernel4xi['VPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'V-'
            except: 
                message2print = "{(Step VZ1/33) yielded" + "; vpu-yielded-by-execute2nativekernel4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'VZ1-'     
        if 'WPU' in  keys2execute4nativekernel:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step W/33) - WPU
                # -----------------------------------------------------------------------------------------               
                response2execute4xi['WPU'] = execute2nativekernel4wpu()
            
                message2print = "{(Step W/33) got" + "; wpu-got-by-execute2nativekernel4xi: " + str(kernel4xi['WPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'W-'
            except: 
                message2print = "{(Step WZ1/33) yielded" + "; wpu-yielded-by-execute2nativekernel4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'WZ1-'     
        if 'XPU' in  keys2execute4nativekernel:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step X/33) - XPU
                # -----------------------------------------------------------------------------------------               
                response2execute4xi['XPU'] = execute2nativekernel4xpu()
            
                message2print = "{(Step X/33) got" + "; xpu-got-by-execute2nativekernel4xi: " + str(kernel4xi['XPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'X-'
            except: 
                message2print = "{(Step XZ1/33) yielded" + "; xpu-yielded-by-execute2nativekernel4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'XZ1-'     
        if 'YPU' in  keys2execute4nativekernel:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step Y/33) - YPU
                # -----------------------------------------------------------------------------------------               
                response2execute4xi['YPU'] = execute2nativekernel4ypu()
            
                message2print = "{(Step Y/33) got" + "; ypu-got-by-execute2nativekernel4xi: " + str(kernel4xi['YPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'Y-'
            except: 
                message2print = "{(Step YZ1/33) yielded" + "; ypu-yielded-by-execute2nativekernel4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'YZ1-'     
        if 'ZPU' in  keys2execute4nativekernel:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step Z/33) - ZPU
                # -----------------------------------------------------------------------------------------               
                response2execute4xi['ZPU'] = execute2nativekernel4zpu()
            
                message2print = "{(Step Z/33) got" + "; zpu-got-by-execute2nativekernel4xi: " + str(kernel4xi['ZPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'Z-'
            except: 
                message2print = "{(Step ZZ1/33) yielded" + "; zpu-yielded-by-execute2nativekernel4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'ZZ1-'                 

            
          
    # -----------------------------------------------------------------------------------------
    # (Step 33/3)           
    # -----------------------------------------------------------------------------------------
    if debug is True:
        print("{(Step 33/33) of execute2nativekernel4xi - RETURNING response2execute4xi: ", response2execute4xi)
            
    message2print = "{(Step 33/33) returning" + "; response2execute4xi-returning-by-execute2nativekernel4xi: " + str(response2execute4xi) + "; time: " + time4xi() + "}"  
    print4xi(class2print, method2print, message2print)                                                              
    # 

    return response2execute4xi
            
#</function4xi>  


# -------------------------------------------------------------------------------------------------
#<function4xi function = "execute2task4xi" usage = "
#    
#   print('=' *33)          
#   print('(Step 2A/700) OF TASK4XI5TEST - TRYING TO EXECUTE TASK OF XI ', time4xi())      
#   print('=' *33)        
#   
#   try:
#       response4execute2task = execute2task4xi()                                                                 
#       print('(Step 2B/700) OF TASK4XI5TEST - EXECUTED TASK OF XI ', time4xi())
#       keys2response = response4execute2task.keys()
#       for key2response in sorted(keys2response):
#           print(key2response, ' : ', response4execute2task[key2response])
#           # 
#   except:
#       print('(Step 2Z1/700) OF TASK4XI5TEST *** FAILED TO EXECUTE TASK OF XI *** ', time4xi())
#
#">

# -------------------------------------------------------------------------------------------------   
def execute2task4xi(task4execute2task=None):

    '''
    executes kernel of xi
    '''
    global platform2xi
    global device2xi
    global context2xi 
    global kernel4xi
    global info2kernel4xi                                                                                              
    
    # -----------------------------------------------------------------------------------------
    # (Step 1/70) - START           
    # -----------------------------------------------------------------------------------------          
    debug = False
    response2execute4xi = {} 
        
    class2print = "execute2task4xi"  
    method2print = "execute2task4xi"

    message2print = "{(Step 1A/70) started" + "; execute2task4xi-started: " + str(execute2task4xi)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)
    # 
  
             
    message2print = "{(Step 1B/70) passed" + "; task4execute2task-to-execute2task4xi: " + str(task4execute2task) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                                                              
    # {'BPU': 'Yes'}

    code2ack  = ' '
    code2nack = ' '    
    
    ack2all = False             
    if task4execute2task is None:
        # -----------------------------------------------------------------------------------------
        # NO PARAMETERS GIVEN BY CALLER FOR INITIALIZATION - SYSTEM CREATES ALL
        # -----------------------------------------------------------------------------------------    
        ack2all = True                                                                                                
        code2ack  = code2ack + '1C-'
    else:
        # -----------------------------------------------------------------------------------------
        # SOME PARAMETERS GIVEN BY CALLER FOR INITIALIZATION - TASK4XI NEEDS INITIALIZATION
        # -----------------------------------------------------------------------------------------        
        try:
            if kernel4xi is None:                                                                                       
                kernel4xi = create2kernel4xi() 
                code2ack  = code2ack + '1D-'
        except:
            kernel4xi = create2kernel4xi()
            code2ack  = code2ack + '1D-'
                        
    # -----------------------------------------------------------------------------------------
    # (Step 2/33)
    # -----------------------------------------------------------------------------------------                  
    message2print = "{(Step 2A/3) try" + "; task4execute2task-try-by-execute2task4xi: " + str(task4execute2task)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print) 
    # {'BPU': 'Yes'}
    
    if ack2all is True:
        try:
            # -----------------------------------------------------------------------------------------
            # (Step 3/33) - ALL DEVICES
            # ----------------------------------------------------------------------------------------- 
            
            response2execute4xi['APU'] = execute2task4apu()                                                                        
            response2execute4xi['BPU'] = execute2task4bpu()   
            response2execute4xi['CPU'] = execute2task4cpu()   
            response2execute4xi['DPU'] = execute2task4dpu()   
            response2execute4xi['EPU'] = execute2task4epu()   
            response2execute4xi['FPU'] = execute2task4fpu()   
            response2execute4xi['GPU'] = execute2task4gpu()   
            response2execute4xi['HPU'] = execute2task4hpu()   
            response2execute4xi['IPU'] = execute2task4ipu()   
            response2execute4xi['JPU'] = execute2task4jpu()   
            response2execute4xi['KPU'] = execute2task4kpu()   
            response2execute4xi['LPU'] = execute2task4lpu()   
            response2execute4xi['MPU'] = execute2task4mpu()   
            response2execute4xi['NPU'] = execute2task4npu()   
            response2execute4xi['OPU'] = execute2task4opu()   
            response2execute4xi['PPU'] = execute2task4ppu()   
            response2execute4xi['QPU'] = execute2task4qpu()   
            response2execute4xi['RPU'] = execute2task4rpu()   
            response2execute4xi['SPU'] = execute2task4spu()   
            response2execute4xi['TPU'] = execute2task4tpu()   
            response2execute4xi['UPU'] = execute2task4upu()   
            response2execute4xi['VPU'] = execute2task4vpu()   
            response2execute4xi['XPU'] = execute2task4xpu()   
            response2execute4xi['WPU'] = execute2task4wpu()   
            response2execute4xi['YPU'] = execute2task4ypu()   
            response2execute4xi['ZPU'] = execute2task4zpu()   
            
            message2print = "{(Step 3A/33) got" + "; response2execute4xi-got-by-execute2task4xi: " + str(response2execute4xi)  + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print)                                                      
            # 
            
            code2ack  = code2ack + '3A-'
        except:
            message2print = "{(Step 3Z1/33) yielded" + "; kernel4xi-yielded-by-execute2task4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                               #   
            code2nack  = code2nack + '3Z1-'
    else:    
        keys2execute4task = task4execute2task.keys()
        if 'APU' in keys2execute4task:
            try:
                # -----------------------------------------------------------------------------------------
                # (Step A/33) - APU
                # -----------------------------------------------------------------------------------------               
                response2execute4xi['APU'] = execute2task4apu()
            
                message2print = "{(Step A/33) got" + "; apu-got-by-execute2task4xi: " + str(kernel4xi['APU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'A-'
            except: 
                message2print = "{(Step AZ1/33) yielded" + "; apu-yielded-by-execute2task4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'AZ1-'          
        if 'BPU' in keys2execute4task:
            try:
                # -----------------------------------------------------------------------------------------
                # (Step B/33) - BPU
                # -----------------------------------------------------------------------------------------               
                response2execute4xi['BPU'] = execute2task4bpu()
            
                message2print = "{(Step B/33) got" + "; bpu-got-by-execute2task4xi: " + str(kernel4xi['BPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'B-'
            except: 
                message2print = "{(Step BZ1/33) yielded" + "; bpu-yielded-by-execute2task4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'BZ1-'     
        if 'CPU' in keys2execute4task:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step C/33) - CPU
                # -----------------------------------------------------------------------------------------               
                response2execute4xi['CPU'] = execute2task4cpu()
            
                message2print = "{(Step C/33) got" + "; cpu-got-by-execute2task4xi: " + str(kernel4xi['CPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'C-'
            except: 
                message2print = "{(Step CZ1/33) yielded" + "; cpu-yielded-by-execute2task4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'CZ1-'     
        if 'DPU' in keys2execute4task:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step D/33) - DPU
                # -----------------------------------------------------------------------------------------               
                response2execute4xi['DPU'] = execute2task4dpu()
            
                message2print = "{(Step D/33) got" + "; dpu-got-by-execute2task4xi: " + str(kernel4xi['DPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'D-'
            except: 
                message2print = "{(Step DZ1/33) yielded" + "; dpu-yielded-by-execute2task4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'DZ1-'     
        if 'EPU' in keys2execute4task:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step E/33) - EPU
                # -----------------------------------------------------------------------------------------               
                response2execute4xi['EPU'] = execute2task4epu()
            
                message2print = "{(Step E/33) got" + "; epu-got-by-execute2task4xi: " + str(kernel4xi['EPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'E-'
            except: 
                message2print = "{(Step EZ1/33) yielded" + "; epu-yielded-by-execute2task4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'EZ1-'     
        if 'FPU' in keys2execute4task:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step F/33) - FPU
                # -----------------------------------------------------------------------------------------               
                response2execute4xi['FPU'] = execute2task4fpu()
            
                message2print = "{(Step F/33) got" + "; fpu-got-by-execute2task4xi: " + str(kernel4xi['FPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'F-'
            except: 
                message2print = "{(Step FZ1/33) yielded" + "; fpu-yielded-by-execute2task4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'FZ1-'     
        if 'GPU' in keys2execute4task:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step G/33) - GPU
                # -----------------------------------------------------------------------------------------               
                response2execute4xi['GPU'] = execute2task4gpu()
            
                message2print = "{(Step G/33) got" + "; gpu-got-by-execute2task4xi: " + str(kernel4xi['GPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'G-'
            except: 
                message2print = "{(Step GZ1/33) yielded" + "; gpu-yielded-by-execute2task4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'GZ1-'     
        if 'HPU' in keys2execute4task:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step H/33) - HPU
                # -----------------------------------------------------------------------------------------               
                response2execute4xi['HPU'] = execute2task4hpu()
            
                message2print = "{(Step H/33) got" + "; hpu-got-by-execute2task4xi: " + str(kernel4xi['HPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'H-'
            except: 
                message2print = "{(Step HZ1/33) yielded" + "; hpu-yielded-by-execute2task4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'HZ1-'     
        if 'IPU' in keys2execute4task:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step I/33) - IPU
                # -----------------------------------------------------------------------------------------               
                response2execute4xi['IPU'] = execute2task4ipu()
            
                message2print = "{(Step I/33) got" + "; ipu-got-by-execute2task4xi: " + str(kernel4xi['IPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'I-'
            except: 
                message2print = "{(Step IZ1/33) yielded" + "; ipu-yielded-by-execute2task4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'IZ1-'     
        if 'JPU' in keys2execute4task:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step J/33) - JPU
                # -----------------------------------------------------------------------------------------               
                response2execute4xi['JPU'] = execute2task4jpu()
            
                message2print = "{(Step J/33) got" + "; jpu-got-by-execute2task4xi: " + str(kernel4xi['JPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'J-'
            except: 
                message2print = "{(Step JZ1/33) yielded" + "; jpu-yielded-by-execute2task4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'JZ1-'     
        if 'KPU' in keys2execute4task:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step K/33) - KPU
                # -----------------------------------------------------------------------------------------               
                response2execute4xi['KPU'] = execute2task4kpu()
            
                message2print = "{(Step K/33) got" + "; kpu-got-by-execute2task4xi: " + str(kernel4xi['KPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'K-'
            except: 
                message2print = "{(Step KZ1/33) yielded" + "; kpu-yielded-by-execute2task4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'KZ1-'     
        if 'LPU' in keys2execute4task:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step L/33) - LPU
                # -----------------------------------------------------------------------------------------               
                response2execute4xi['LPU'] = execute2task4lpu()
            
                message2print = "{(Step L/33) got" + "; lpu-got-by-execute2task4xi: " + str(kernel4xi['LPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'L-'
            except: 
                message2print = "{(Step LZ1/33) yielded" + "; lpu-yielded-by-execute2task4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'LZ1-'     
        if 'MPU' in keys2execute4task:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step M/33) - MPU
                # -----------------------------------------------------------------------------------------               
                response2execute4xi['MPU'] = execute2task4mpu()
            
                message2print = "{(Step M/33) got" + "; mpu-got-by-execute2task4xi: " + str(kernel4xi['MPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'M-'
            except: 
                message2print = "{(Step MZ1/33) yielded" + "; mpu-yielded-by-execute2task4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'MZ1-'     
        if 'NPU' in keys2execute4task:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step N/33) - NPU
                # -----------------------------------------------------------------------------------------               
                response2execute4xi['NPU'] = execute2task4npu()
            
                message2print = "{(Step N/33) got" + "; npu-got-by-execute2task4xi: " + str(kernel4xi['NPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'N-'
            except: 
                message2print = "{(Step NZ1/33) yielded" + "; npu-yielded-by-execute2task4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'NZ1-'     
        if 'OPU' in keys2execute4task:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step O/33) - OPU
                # -----------------------------------------------------------------------------------------               
                response2execute4xi['OPU'] = execute2task4opu()
            
                message2print = "{(Step O/33) got" + "; opu-got-by-execute2task4xi: " + str(kernel4xi['OPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'O-'
            except: 
                message2print = "{(Step OZ1/33) yielded" + "; opu-yielded-by-execute2task4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'OZ1-'     
        if 'PPU' in keys2execute4task:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step P/33) - PPU
                # -----------------------------------------------------------------------------------------               
                response2execute4xi['PPU'] = execute2task4ppu()
            
                message2print = "{(Step P/33) got" + "; ppu-got-by-execute2task4xi: " + str(kernel4xi['PPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'P-'
            except: 
                message2print = "{(Step PZ1/33) yielded" + "; ppu-yielded-by-execute2task4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'PZ1-'     
        if 'QPU' in keys2execute4task:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step Q/33) - QPU
                # -----------------------------------------------------------------------------------------               
                response2execute4xi['QPU'] = execute2task4qpu()
            
                message2print = "{(Step Q/33) got" + "; qpu-got-by-execute2task4xi: " + str(kernel4xi['QPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'Q-'
            except: 
                message2print = "{(Step QZ1/33) yielded" + "; qpu-yielded-by-execute2task4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'QZ1-'     
        if 'RPU' in keys2execute4task:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step R/33) - RPU
                # -----------------------------------------------------------------------------------------               
                response2execute4xi['RPU'] = execute2task4rpu()
            
                message2print = "{(Step R/33) got" + "; rpu-got-by-execute2task4xi: " + str(kernel4xi['RPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'R-'
            except: 
                message2print = "{(Step RZ1/33) yielded" + "; rpu-yielded-by-execute2task4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'RZ1-'     
        if 'SPU' in keys2execute4task:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step S/33) - SPU
                # -----------------------------------------------------------------------------------------               
                response2execute4xi['SPU'] = execute2task4spu()
            
                message2print = "{(Step S/33) got" + "; spu-got-by-execute2task4xi: " + str(kernel4xi['SPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'S-'
            except: 
                message2print = "{(Step SZ1/33) yielded" + "; spu-yielded-by-execute2task4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'SZ1-'     
        if 'TPU' in keys2execute4task:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step T/33) - TPU
                # -----------------------------------------------------------------------------------------               
                response2execute4xi['TPU'] = execute2task4tpu()
            
                message2print = "{(Step T/33) got" + "; tpu-got-by-execute2task4xi: " + str(kernel4xi['TPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'T-'
            except: 
                message2print = "{(Step TZ1/33) yielded" + "; tpu-yielded-by-execute2task4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'TZ1-'     
        if 'UPU' in keys2execute4task:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step U/33) - UPU
                # -----------------------------------------------------------------------------------------               
                response2execute4xi['UPU'] = execute2task4upu()
            
                message2print = "{(Step U/33) got" + "; upu-got-by-execute2task4xi: " + str(kernel4xi['UPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'U-'
            except: 
                message2print = "{(Step UZ1/33) yielded" + "; upu-yielded-by-execute2task4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'UZ1-'     
        if 'VPU' in keys2execute4task:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step V/33) - VPU
                # -----------------------------------------------------------------------------------------               
                response2execute4xi['VPU'] = execute2task4vpu()
            
                message2print = "{(Step V/33) got" + "; vpu-got-by-execute2task4xi: " + str(kernel4xi['VPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'V-'
            except: 
                message2print = "{(Step VZ1/33) yielded" + "; vpu-yielded-by-execute2task4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'VZ1-'     
        if 'WPU' in keys2execute4task:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step W/33) - WPU
                # -----------------------------------------------------------------------------------------               
                response2execute4xi['WPU'] = execute2task4wpu()
            
                message2print = "{(Step W/33) got" + "; wpu-got-by-execute2task4xi: " + str(kernel4xi['WPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'W-'
            except: 
                message2print = "{(Step WZ1/33) yielded" + "; wpu-yielded-by-execute2task4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'WZ1-'     
        if 'XPU' in keys2execute4task:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step X/33) - XPU
                # -----------------------------------------------------------------------------------------               
                response2execute4xi['XPU'] = execute2task4xpu()
            
                message2print = "{(Step X/33) got" + "; xpu-got-by-execute2task4xi: " + str(kernel4xi['XPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'X-'
            except: 
                message2print = "{(Step XZ1/33) yielded" + "; xpu-yielded-by-execute2task4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'XZ1-'     
        if 'YPU' in keys2execute4task:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step Y/33) - YPU
                # -----------------------------------------------------------------------------------------               
                response2execute4xi['YPU'] = execute2task4ypu()
            
                message2print = "{(Step Y/33) got" + "; ypu-got-by-execute2task4xi: " + str(kernel4xi['YPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'Y-'
            except: 
                message2print = "{(Step YZ1/33) yielded" + "; ypu-yielded-by-execute2task4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'YZ1-'     
        if 'ZPU' in keys2execute4task:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step Z/33) - ZPU
                # -----------------------------------------------------------------------------------------               
                response2execute4xi['ZPU'] = execute2task4zpu()
            
                message2print = "{(Step Z/33) got" + "; zpu-got-by-execute2task4xi: " + str(kernel4xi['ZPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'Z-'
            except: 
                message2print = "{(Step ZZ1/33) yielded" + "; zpu-yielded-by-execute2task4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'ZZ1-'                 

            
          
    # -----------------------------------------------------------------------------------------
    # (Step 33/3)           
    # -----------------------------------------------------------------------------------------
    if debug is True:
        print("{(Step 33/33) of execute2task4xi - RETURNING response2execute4xi: ", response2execute4xi)
            
    message2print = "{(Step 33/33) returning" + "; response2execute4xi-returning-by-execute2task4xi: " + str(response2execute4xi) + "; time: " + time4xi() + "}"  
    print4xi(class2print, method2print, message2print)                                                              
    # 

    return response2execute4xi
            
#</function4xi>  

# -------------------------------------------------------------------------------------------------
#<function4xi function = "get2kernelinfo4xi" usage = "
#     
#   print('=' *33)          
#   print('(Step 2A/700) OF KERNEL4XI5TEST - TRYING TO GET KERNEL INFO KERNEL OF XI ', time4xi())      
#   print('=' *33)        
#   
#   try:
#       response4get2kernelinfo = get2kernelinfo4xi()                                                                 
#       print('(Step 2B/700) OF KERNEL4XI5TEST - GET KERNEL INFO XI ', time4xi())
#       keys2response = response4get2kernelinfo.keys()
#       for key2response in sorted(keys2response):
#           print(key2response, ' : ', response4get2kernelinfo[key2response])
#           # 
#   except:
#       print('(Step 2Z1/700) OF KERNEL4XI5TEST *** FAILED TO GET KERNEL INFO KERNEL OF XI *** ', time4xi())
#
#">

# -------------------------------------------------------------------------------------------------   
def get2kernelinfo4xi(task4get2kernelinfo=None):

    '''
    gets kernel info of xi
    '''
    global platform2xi
    global device2xi
    global context2xi 
    global kernel4xi
    global info2kernel4xi                                                                                              
    
    # -----------------------------------------------------------------------------------------
    # (Step 1/70) - START           
    # -----------------------------------------------------------------------------------------          
    response4kernelinfo = {} 
    debug = False
        
    class2print = "get2kernelinfo4xi" 
    method2print = "get2kernelinfo4xi"

    message2print = "{(Step 1A/70) started" + "; get2kernelinfo4xi-started: " + str(get2kernelinfo4xi)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)
    # 
  
             
    message2print = "{(Step 1B/70) passed" + "; task4get2kernelinfo-to-get2kernelinfo4xi: " + str(task4get2kernelinfo) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                                                              
    # 

    code2ack  = ' '
    code2nack = ' '    
    
    ack2all = False             
    if task4get2kernelinfo is None:
        # -----------------------------------------------------------------------------------------
        # NO PARAMETERS GIVEN BY CALLER FOR INITIALIZATION - SYSTEM CREATES ALL
        # -----------------------------------------------------------------------------------------    
        ack2all = True                                                                                                
        code2ack  = code2ack + '1C-'
    else:
        # -----------------------------------------------------------------------------------------
        # SOME PARAMETERS GIVEN BY CALLER FOR INITIALIZATION - KERNEL4XI NEEDS INITIALIZATION
        # -----------------------------------------------------------------------------------------        
        keys2task4kernelinfo = task4get2kernelinfo.keys()
        try:
            if kernel4xi is None:                                                                                       
                kernel4xi = create2kernel4xi() 
                code2ack  = code2ack + '1D-'
        except:
            kernel4xi = create2kernel4xi() 
            code2ack  = code2ack + '1D-'
                        
    # -----------------------------------------------------------------------------------------
    # (Step 2/33)
    # -----------------------------------------------------------------------------------------                  
    message2print = "{(Step 2A/3) try" + "; task4get2kernelinfo-try-by-get2kernelinfo4xi: " + str(task4get2kernelinfo)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print) 
    # None 
    
    if ack2all is True:
        try:
            # -----------------------------------------------------------------------------------------
            # (Step 3/33) - ALL DEVICES
            # ----------------------------------------------------------------------------------------- 
            response4kernelinfo['APU'] = get2kernelinfo4apu()                                                                        
            response4kernelinfo['BPU'] = get2kernelinfo4bpu()   
            response4kernelinfo['CPU'] = get2kernelinfo4cpu()   
            response4kernelinfo['DPU'] = get2kernelinfo4dpu()   
            response4kernelinfo['EPU'] = get2kernelinfo4epu()   
            response4kernelinfo['FPU'] = get2kernelinfo4fpu()   
            response4kernelinfo['GPU'] = get2kernelinfo4gpu()   
            response4kernelinfo['HPU'] = get2kernelinfo4hpu()   
            response4kernelinfo['IPU'] = get2kernelinfo4ipu()   
            response4kernelinfo['JPU'] = get2kernelinfo4jpu()   
            response4kernelinfo['KPU'] = get2kernelinfo4kpu()   
            response4kernelinfo['LPU'] = get2kernelinfo4lpu()   
            response4kernelinfo['MPU'] = get2kernelinfo4mpu()   
            response4kernelinfo['NPU'] = get2kernelinfo4npu()   
            response4kernelinfo['OPU'] = get2kernelinfo4opu()   
            response4kernelinfo['PPU'] = get2kernelinfo4ppu()   
            response4kernelinfo['QPU'] = get2kernelinfo4qpu()   
            response4kernelinfo['RPU'] = get2kernelinfo4rpu()   
            response4kernelinfo['SPU'] = get2kernelinfo4spu()   
            response4kernelinfo['TPU'] = get2kernelinfo4tpu()   
            response4kernelinfo['UPU'] = get2kernelinfo4upu()   
            response4kernelinfo['VPU'] = get2kernelinfo4vpu()   
            response4kernelinfo['XPU'] = get2kernelinfo4xpu()   
            response4kernelinfo['WPU'] = get2kernelinfo4wpu()   
            response4kernelinfo['YPU'] = get2kernelinfo4ypu()   
            response4kernelinfo['ZPU'] = get2kernelinfo4zpu()   
            
            message2print = "{(Step 3A/33) got" + "; kernel4xi-got-by-get2kernelinfo4xi to: " + str(kernel4xi)  + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print)                                                      
            # 
            
            code2ack  = code2ack + '3A-'
        except:
            message2print = "{(Step 3Z1/33) yielded" + "; kernel4xi-yielded-by-get2kernelinfo4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                               #   
            code2nack  = code2nack + '3Z1-'
    else:    
        if 'APU' in keys2task4kernelinfo:
            try:
                # -----------------------------------------------------------------------------------------
                # (Step A/33) - APU
                # -----------------------------------------------------------------------------------------               
                response4kernelinfo['APU'] = get2kernelinfo4apu()
                
                message2print = "{(Step A/33) got" + "; apu-got-by-get2kernelinfo4xi: " + str(response4kernelinfo['APU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
                
                code2ack  = code2ack + 'A-'
            except: 
                message2print = "{(Step AZ1/33) yielded" + "; apu-yielded-by-get2kernelinfo4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'AZ1-' 
                         
        if 'BPU' in keys2task4kernelinfo:
            try:
                # -----------------------------------------------------------------------------------------
                # (Step B/33) - BPU
                # -----------------------------------------------------------------------------------------               
                response4kernelinfo['BPU'] = get2kernelinfo4bpu()
                
                message2print = "{(Step B/33) got" + "; bpu-got-by-get2kernelinfo4xi: " + str(response4kernelinfo['BPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
                
                code2ack  = code2ack + 'B-'
            except: 
                message2print = "{(Step BZ1/33) yielded" + "; bpu-yielded-by-get2kernelinfo4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'BZ1-'     
            
        if 'CPU' in keys2task4kernelinfo:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step C/33) - CPU
                # -----------------------------------------------------------------------------------------               
                response4kernelinfo['CPU'] = get2kernelinfo4cpu()
                
                message2print = "{(Step C/33) got" + "; cpu-got-by-get2kernelinfo4xi: " + str(response4kernelinfo['CPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
                
                code2ack  = code2ack + 'C-'
            except: 
                message2print = "{(Step CZ1/33) yielded" + "; cpu-yielded-by-get2kernelinfo4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'CZ1-'     
            
        if 'DPU' in keys2task4kernelinfo:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step D/33) - DPU
                # -----------------------------------------------------------------------------------------               
                response4kernelinfo['DPU'] = get2kernelinfo4dpu()
                
                message2print = "{(Step D/33) got" + "; dpu-got-by-get2kernelinfo4xi: " + str(response4kernelinfo['DPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
                
                code2ack  = code2ack + 'D-'
            except: 
                message2print = "{(Step DZ1/33) yielded" + "; dpu-yielded-by-get2kernelinfo4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'DZ1-'     
            
        if 'EPU' in keys2task4kernelinfo:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step E/33) - EPU
                # -----------------------------------------------------------------------------------------               
                response4kernelinfo['EPU'] = get2kernelinfo4epu()
                
                message2print = "{(Step E/33) got" + "; epu-got-by-get2kernelinfo4xi: " + str(response4kernelinfo['EPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
                
                code2ack  = code2ack + 'E-'
            except: 
                message2print = "{(Step EZ1/33) yielded" + "; epu-yielded-by-get2kernelinfo4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'EZ1-'     
            
        if 'FPU' in keys2task4kernelinfo:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step F/33) - FPU
                # -----------------------------------------------------------------------------------------               
                response4kernelinfo['FPU'] = get2kernelinfo4fpu()
                
                message2print = "{(Step F/33) got" + "; fpu-got-by-get2kernelinfo4xi: " + str(response4kernelinfo['FPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
                
                code2ack  = code2ack + 'F-'
            except: 
                message2print = "{(Step FZ1/33) yielded" + "; fpu-yielded-by-get2kernelinfo4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'FZ1-'     
                
        if 'GPU' in keys2task4kernelinfo:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step G/33) - GPU
                # -----------------------------------------------------------------------------------------               
                response4kernelinfo['GPU'] = get2kernelinfo4gpu()
                
                message2print = "{(Step G/33) got" + "; gpu-got-by-get2kernelinfo4xi: " + str(response4kernelinfo['GPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
                
                code2ack  = code2ack + 'G-'
            except: 
                message2print = "{(Step GZ1/33) yielded" + "; gpu-yielded-by-get2kernelinfo4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'GZ1-'     
                
        if 'HPU' in keys2task4kernelinfo:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step H/33) - HPU
                # -----------------------------------------------------------------------------------------               
                response4kernelinfo['HPU'] = get2kernelinfo4hpu()
                
                message2print = "{(Step H/33) got" + "; hpu-got-by-get2kernelinfo4xi: " + str(response4kernelinfo['HPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
                
                code2ack  = code2ack + 'H-'
            except: 
                message2print = "{(Step HZ1/33) yielded" + "; hpu-yielded-by-get2kernelinfo4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'HZ1-'     
            
        if 'IPU' in keys2task4kernelinfo:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step I/33) - IPU
                # -----------------------------------------------------------------------------------------               
                response4kernelinfo['IPU'] = get2kernelinfo4ipu()
                
                message2print = "{(Step I/33) got" + "; ipu-got-by-get2kernelinfo4xi: " + str(response4kernelinfo['IPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
                
                code2ack  = code2ack + 'I-'
            except: 
                message2print = "{(Step IZ1/33) yielded" + "; ipu-yielded-by-get2kernelinfo4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'IZ1-'     
            
        if 'JPU' in keys2task4kernelinfo:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step J/33) - JPU
                # -----------------------------------------------------------------------------------------               
                response4kernelinfo['JPU'] = get2kernelinfo4jpu()
                
                message2print = "{(Step J/33) got" + "; jpu-got-by-get2kernelinfo4xi: " + str(response4kernelinfo['JPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
                
                code2ack  = code2ack + 'J-'
            except: 
                message2print = "{(Step JZ1/33) yielded" + "; jpu-yielded-by-get2kernelinfo4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'JZ1-'     
                
        if 'KPU' in keys2task4kernelinfo:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step K/33) - KPU
                # -----------------------------------------------------------------------------------------               
                response4kernelinfo['KPU'] = get2kernelinfo4kpu()
                
                message2print = "{(Step K/33) got" + "; kpu-got-by-get2kernelinfo4xi: " + str(response4kernelinfo['KPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
                
                code2ack  = code2ack + 'K-'
            except: 
                message2print = "{(Step KZ1/33) yielded" + "; kpu-yielded-by-get2kernelinfo4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'KZ1-'     
            
        if 'LPU' in keys2task4kernelinfo:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step L/33) - LPU
                # -----------------------------------------------------------------------------------------               
                response4kernelinfo['LPU'] = get2kernelinfo4lpu()
                
                message2print = "{(Step L/33) got" + "; lpu-got-by-get2kernelinfo4xi: " + str(response4kernelinfo['LPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
                
                code2ack  = code2ack + 'L-'
            except: 
                message2print = "{(Step LZ1/33) yielded" + "; lpu-yielded-by-get2kernelinfo4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'LZ1-'     
            
        if 'MPU' in keys2task4kernelinfo:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step M/33) - MPU
                # -----------------------------------------------------------------------------------------               
                response4kernelinfo['MPU'] = get2kernelinfo4mpu()
                
                message2print = "{(Step M/33) got" + "; mpu-got-by-get2kernelinfo4xi: " + str(response4kernelinfo['MPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
                
                code2ack  = code2ack + 'M-'
            except: 
                message2print = "{(Step MZ1/33) yielded" + "; mpu-yielded-by-get2kernelinfo4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'MZ1-'     
            
        if 'NPU' in keys2task4kernelinfo:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step N/33) - NPU
                # -----------------------------------------------------------------------------------------               
                response4kernelinfo['NPU'] = get2kernelinfo4npu()
                
                message2print = "{(Step N/33) got" + "; npu-got-by-get2kernelinfo4xi: " + str(response4kernelinfo['NPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
                
                code2ack  = code2ack + 'N-'
            except: 
                message2print = "{(Step NZ1/33) yielded" + "; npu-yielded-by-get2kernelinfo4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'NZ1-'     
            
        if 'OPU' in keys2task4kernelinfo:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step O/33) - OPU
                # -----------------------------------------------------------------------------------------               
                response4kernelinfo['OPU'] = get2kernelinfo4opu()
                
                message2print = "{(Step O/33) got" + "; opu-got-by-get2kernelinfo4xi: " + str(response4kernelinfo['OPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
                
                code2ack  = code2ack + 'O-'
            except: 
                message2print = "{(Step OZ1/33) yielded" + "; opu-yielded-by-get2kernelinfo4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'OZ1-'     
                
        if 'PPU' in keys2task4kernelinfo:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step P/33) - PPU
                # -----------------------------------------------------------------------------------------               
                response4kernelinfo['PPU'] = get2kernelinfo4ppu()
                
                message2print = "{(Step P/33) got" + "; ppu-got-by-get2kernelinfo4xi: " + str(response4kernelinfo['PPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
                
                code2ack  = code2ack + 'P-'
            except: 
                message2print = "{(Step PZ1/33) yielded" + "; ppu-yielded-by-get2kernelinfo4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'PZ1-'     
            
        if 'QPU' in keys2task4kernelinfo:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step Q/33) - QPU
                # -----------------------------------------------------------------------------------------               
                response4kernelinfo['QPU'] = get2kernelinfo4qpu()
                
                message2print = "{(Step Q/33) got" + "; qpu-got-by-get2kernelinfo4xi: " + str(response4kernelinfo['QPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
                
                code2ack  = code2ack + 'Q-'
            except: 
                message2print = "{(Step QZ1/33) yielded" + "; qpu-yielded-by-get2kernelinfo4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'QZ1-'     
            
        if 'RPU' in keys2task4kernelinfo:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step R/33) - RPU
                # -----------------------------------------------------------------------------------------               
                response4kernelinfo['RPU'] = get2kernelinfo4rpu()
                
                message2print = "{(Step R/33) got" + "; rpu-got-by-get2kernelinfo4xi: " + str(response4kernelinfo['RPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
                
                code2ack  = code2ack + 'R-'
            except: 
                message2print = "{(Step RZ1/33) yielded" + "; rpu-yielded-by-get2kernelinfo4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'RZ1-'     
            
        if 'SPU' in keys2task4kernelinfo:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step S/33) - SPU
                # -----------------------------------------------------------------------------------------               
                response4kernelinfo['SPU'] = get2kernelinfo4spu()
                
                message2print = "{(Step S/33) got" + "; spu-got-by-get2kernelinfo4xi: " + str(response4kernelinfo['SPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
                
                code2ack  = code2ack + 'S-'
            except: 
                message2print = "{(Step SZ1/33) yielded" + "; spu-yielded-by-get2kernelinfo4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'SZ1-'     
            
        if 'TPU' in keys2task4kernelinfo:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step T/33) - TPU
                # -----------------------------------------------------------------------------------------               
                response4kernelinfo['TPU'] = get2kernelinfo4tpu()
                
                message2print = "{(Step T/33) got" + "; tpu-got-by-get2kernelinfo4xi: " + str(response4kernelinfo['TPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
                
                code2ack  = code2ack + 'T-'
            except: 
                message2print = "{(Step TZ1/33) yielded" + "; tpu-yielded-by-get2kernelinfo4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'TZ1-'     
            
        if 'UPU' in keys2task4kernelinfo:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step U/33) - UPU
                # -----------------------------------------------------------------------------------------               
                response4kernelinfo['UPU'] = get2kernelinfo4upu()
                
                message2print = "{(Step U/33) got" + "; upu-got-by-get2kernelinfo4xi: " + str(response4kernelinfo['UPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
                
                code2ack  = code2ack + 'U-'
            except: 
                message2print = "{(Step UZ1/33) yielded" + "; upu-yielded-by-get2kernelinfo4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'UZ1-'     
            
        if 'VPU' in keys2task4kernelinfo:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step V/33) - VPU
                # -----------------------------------------------------------------------------------------               
                response4kernelinfo['VPU'] = get2kernelinfo4vpu()
                
                message2print = "{(Step V/33) got" + "; vpu-got-by-get2kernelinfo4xi: " + str(response4kernelinfo['VPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
                
                code2ack  = code2ack + 'V-'
            except: 
                message2print = "{(Step VZ1/33) yielded" + "; vpu-yielded-by-get2kernelinfo4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'VZ1-'     
            
        if 'WPU' in keys2task4kernelinfo:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step W/33) - WPU
                # -----------------------------------------------------------------------------------------               
                response4kernelinfo['WPU'] = get2kernelinfo4wpu()
                
                message2print = "{(Step W/33) got" + "; wpu-got-by-get2kernelinfo4xi: " + str(response4kernelinfo['WPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
                
                code2ack  = code2ack + 'W-'
            except: 
                message2print = "{(Step WZ1/33) yielded" + "; wpu-yielded-by-get2kernelinfo4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'WZ1-'     
            
        if 'XPU' in keys2task4kernelinfo:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step X/33) - XPU
                # -----------------------------------------------------------------------------------------               
                response4kernelinfo['XPU'] = get2kernelinfo4xpu()
                
                message2print = "{(Step X/33) got" + "; xpu-got-by-get2kernelinfo4xi: " + str(response4kernelinfo['XPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
                
                code2ack  = code2ack + 'X-'
            except: 
                message2print = "{(Step XZ1/33) yielded" + "; xpu-yielded-by-get2kernelinfo4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'XZ1-'     
            
        if 'YPU' in keys2task4kernelinfo:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step Y/33) - YPU
                # -----------------------------------------------------------------------------------------               
                response4kernelinfo['YPU'] = get2kernelinfo4ypu()
                
                message2print = "{(Step Y/33) got" + "; ypu-got-by-get2kernelinfo4xi: " + str(response4kernelinfo['YPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
                
                code2ack  = code2ack + 'Y-'
            except: 
                message2print = "{(Step YZ1/33) yielded" + "; ypu-yielded-by-get2kernelinfo4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'YZ1-'     
            
        if 'ZPU' in keys2task4kernelinfo:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step Z/33) - ZPU
                # -----------------------------------------------------------------------------------------               
                response4kernelinfo['ZPU'] = get2kernelinfo4zpu()
                
                message2print = "{(Step Z/33) got" + "; zpu-got-by-get2kernelinfo4xi: " + str(response4kernelinfo['ZPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
                
                code2ack  = code2ack + 'Z-'
            except: 
                message2print = "{(Step ZZ1/33) yielded" + "; zpu-yielded-by-get2kernelinfo4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'ZZ1-'                 

            
          
    # -----------------------------------------------------------------------------------------
    # (Step 33/3)           
    # -----------------------------------------------------------------------------------------
    if debug is True:
        print("{(Step 33/33) of get2kernelinfo4xi - RETURNING response4kernelinfo: ", response4kernelinfo)
            
    message2print = "{(Step 33/33) returning" + "; response4kernelinfo-returning-by-get2kernelinfo4xi: " + str(response4kernelinfo) + "; time: " + time4xi() + "}"  
    print4xi(class2print, method2print, message2print)                                                              
    # 

    return response4kernelinfo
            
#</function4xi>  


# -------------------------------------------------------------------------------------------------
#<function4xi function = "get2kernelworkgroupinfo4xi" usage = "
#     
#   print('=' *33)          
#   print('(Step 2A/700) OF KERNEL4XI5TEST - TRYING TO GET KERNEL WORKGROUP INFO KERNEL OF XI ', time4xi())      
#   print('=' *33)        
#   # 
#   try:
#       response4get2kernelworkgroupinfo = get2kernelworkgroupinfo4xi()                                                                 
#       print('(Step 2B/700) OF KERNEL4XI5TEST - GOT KERNEL WORKGROUP INFO XI ', time4xi())
#       keys2response = response4get2kernelworkgroupinfo.keys()
#       for key2response in sorted(keys2response):
#           print(key2response, ' : ', response4get2kernelworkgroupinfo[key2response])
#           # 
#   except:
#       print('(Step 2Z1/700) OF KERNEL4XI5TEST *** FAILED TO GET KERNEL WORKGROUP INFO KERNEL OF XI *** ', time4xi())
#
#">

# -------------------------------------------------------------------------------------------------   
def get2kernelworkgroupinfo4xi(task4get2kernelworkgroupinfo=None):

    '''
    gets kernel workgroup info of xi
    '''
    global platform2xi
    global device2xi
    global context2xi 
    global kernel4xi
    global info2kernel4xi                                                                                              
    
    # -----------------------------------------------------------------------------------------
    # (Step 1/70) - START           
    # -----------------------------------------------------------------------------------------          
    response4kernelworkgroupinfo = {} 
    debug = False
        
    class2print = "get2kernelworkgroupinfo4xi" 
    method2print = "get2kernelworkgroupinfo4xi"

    message2print = "{(Step 1A/70) started" + "; get2kernelworkgroupinfo4xi-started: " + str(get2kernelworkgroupinfo4xi)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)
    # 
  
             
    message2print = "{(Step 1B/70) passed" + "; task4get2kernelworkgroupinfo-to-get2kernelworkgroupinfo4xi: " + str(task4get2kernelworkgroupinfo) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                                                              
    # 

    code2ack  = ' '
    code2nack = ' '    
    
    ack2all = False             
    if task4get2kernelworkgroupinfo is None:
        # -----------------------------------------------------------------------------------------
        # NO PARAMETERS GIVEN BY CALLER FOR INITIALIZATION - SYSTEM CREATES ALL
        # -----------------------------------------------------------------------------------------    
        ack2all = True                                                                                                
        code2ack  = code2ack + '1C-'
    else:
        # -----------------------------------------------------------------------------------------
        # SOME PARAMETERS GIVEN BY CALLER FOR INITIALIZATION - KERNEL4XI NEEDS INITIALIZATION
        # -----------------------------------------------------------------------------------------        
        try:
            if kernel4xi is None:                                                                                       
                kernel4xi = create2kernel4xi() 
                code2ack  = code2ack + '1D-'
        except:
            kernel4xi = create2kernel4xi() 
            code2ack  = code2ack + '1D-'
                        
    # -----------------------------------------------------------------------------------------
    # (Step 2/33)
    # -----------------------------------------------------------------------------------------                  
    message2print = "{(Step 2A/3) try" + "; task4get2kernelworkgroupinfo-try-by-get2kernelworkgroupinfo4xi: " + str(task4get2kernelworkgroupinfo)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print) 
    # None 
    
    if ack2all is True:
        try:
            # -----------------------------------------------------------------------------------------
            # (Step 3/33) - ALL DEVICES
            # ----------------------------------------------------------------------------------------- 
            response4kernelworkgroupinfo['APU'] = get2kernelworkgroupinfo4apu()                                                                        
            response4kernelworkgroupinfo['BPU'] = get2kernelworkgroupinfo4bpu()   
            response4kernelworkgroupinfo['CPU'] = get2kernelworkgroupinfo4cpu()   
            response4kernelworkgroupinfo['DPU'] = get2kernelworkgroupinfo4dpu()   
            response4kernelworkgroupinfo['EPU'] = get2kernelworkgroupinfo4epu()   
            response4kernelworkgroupinfo['FPU'] = get2kernelworkgroupinfo4fpu()   
            response4kernelworkgroupinfo['GPU'] = get2kernelworkgroupinfo4gpu()   
            response4kernelworkgroupinfo['HPU'] = get2kernelworkgroupinfo4hpu()   
            response4kernelworkgroupinfo['IPU'] = get2kernelworkgroupinfo4ipu()   
            response4kernelworkgroupinfo['JPU'] = get2kernelworkgroupinfo4jpu()   
            response4kernelworkgroupinfo['KPU'] = get2kernelworkgroupinfo4kpu()   
            response4kernelworkgroupinfo['LPU'] = get2kernelworkgroupinfo4lpu()   
            response4kernelworkgroupinfo['MPU'] = get2kernelworkgroupinfo4mpu()   
            response4kernelworkgroupinfo['NPU'] = get2kernelworkgroupinfo4npu()   
            response4kernelworkgroupinfo['OPU'] = get2kernelworkgroupinfo4opu()   
            response4kernelworkgroupinfo['PPU'] = get2kernelworkgroupinfo4ppu()   
            response4kernelworkgroupinfo['QPU'] = get2kernelworkgroupinfo4qpu()   
            response4kernelworkgroupinfo['RPU'] = get2kernelworkgroupinfo4rpu()   
            response4kernelworkgroupinfo['SPU'] = get2kernelworkgroupinfo4spu()   
            response4kernelworkgroupinfo['TPU'] = get2kernelworkgroupinfo4tpu()   
            response4kernelworkgroupinfo['UPU'] = get2kernelworkgroupinfo4upu()   
            response4kernelworkgroupinfo['VPU'] = get2kernelworkgroupinfo4vpu()   
            response4kernelworkgroupinfo['XPU'] = get2kernelworkgroupinfo4xpu()   
            response4kernelworkgroupinfo['WPU'] = get2kernelworkgroupinfo4wpu()   
            response4kernelworkgroupinfo['YPU'] = get2kernelworkgroupinfo4ypu()   
            response4kernelworkgroupinfo['ZPU'] = get2kernelworkgroupinfo4zpu()   
            
            message2print = "{(Step 3A/33) got" + "; kernel4xi-got-by-get2kernelworkgroupinfo4xi to: " + str(kernel4xi)  + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print)                                                      
            # 
            
            code2ack  = code2ack + '3A-'
        except:
            message2print = "{(Step 3Z1/33) yielded" + "; kernel4xi-yielded-by-get2kernelworkgroupinfo4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                               #   
            code2nack  = code2nack + '3Z1-'
    else:    
        keys2workgroupinfo4task = task4get2kernelworkgroupinfo.keys()
        if 'APU' in keys2workgroupinfo4task:
            try:
                # -----------------------------------------------------------------------------------------
                # (Step A/33) - APU
                # -----------------------------------------------------------------------------------------               
                response4kernelworkgroupinfo['APU'] = get2kernelworkgroupinfo4apu(task4get2kernelworkgroupinfo['APU'])
            
                message2print = "{(Step A/33) got" + "; apu-got-by-get2kernelworkgroupinfo4xi: " + str(response4kernelworkgroupinfo['APU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'A-'
            except: 
                message2print = "{(Step AZ1/33) yielded" + "; apu-yielded-by-get2kernelworkgroupinfo4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'AZ1-'          
        if 'BPU' in keys2workgroupinfo4task:
            try:
                # -----------------------------------------------------------------------------------------
                # (Step B/33) - BPU
                # -----------------------------------------------------------------------------------------               
                response4kernelworkgroupinfo['BPU'] = get2kernelworkgroupinfo4bpu(task4get2kernelworkgroupinfo['BPU'])
            
                message2print = "{(Step B/33) got" + "; bpu-got-by-get2kernelworkgroupinfo4xi: " + str(response4kernelworkgroupinfo['BPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'B-'
            except: 
                message2print = "{(Step BZ1/33) yielded" + "; bpu-yielded-by-get2kernelworkgroupinfo4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'BZ1-'     
        if 'CPU' in keys2workgroupinfo4task:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step C/33) - CPU
                # -----------------------------------------------------------------------------------------               
                response4kernelworkgroupinfo['CPU'] = get2kernelworkgroupinfo4cpu(task4get2kernelworkgroupinfo['CPU'])
            
                message2print = "{(Step C/33) got" + "; cpu-got-by-get2kernelworkgroupinfo4xi: " + str(response4kernelworkgroupinfo['CPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'C-'
            except: 
                message2print = "{(Step CZ1/33) yielded" + "; cpu-yielded-by-get2kernelworkgroupinfo4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'CZ1-'     
        if 'DPU' in keys2workgroupinfo4task:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step D/33) - DPU
                # -----------------------------------------------------------------------------------------               
                response4kernelworkgroupinfo['DPU'] = get2kernelworkgroupinfo4dpu(task4get2kernelworkgroupinfo['DPU'])
            
                message2print = "{(Step D/33) got" + "; dpu-got-by-get2kernelworkgroupinfo4xi: " + str(response4kernelworkgroupinfo['DPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'D-'
            except: 
                message2print = "{(Step DZ1/33) yielded" + "; dpu-yielded-by-get2kernelworkgroupinfo4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'DZ1-'     
        if 'EPU' in keys2workgroupinfo4task:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step E/33) - EPU
                # -----------------------------------------------------------------------------------------               
                response4kernelworkgroupinfo['EPU'] = get2kernelworkgroupinfo4epu(task4get2kernelworkgroupinfo['EPU'])
            
                message2print = "{(Step E/33) got" + "; epu-got-by-get2kernelworkgroupinfo4xi: " + str(response4kernelworkgroupinfo['EPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'E-'
            except: 
                message2print = "{(Step EZ1/33) yielded" + "; epu-yielded-by-get2kernelworkgroupinfo4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'EZ1-'     
        if 'FPU' in keys2workgroupinfo4task:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step F/33) - FPU
                # -----------------------------------------------------------------------------------------               
                response4kernelworkgroupinfo['FPU'] = get2kernelworkgroupinfo4fpu(task4get2kernelworkgroupinfo['FPU'])
            
                message2print = "{(Step F/33) got" + "; fpu-got-by-get2kernelworkgroupinfo4xi: " + str(response4kernelworkgroupinfo['FPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'F-'
            except: 
                message2print = "{(Step FZ1/33) yielded" + "; fpu-yielded-by-get2kernelworkgroupinfo4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'FZ1-'     
        if 'GPU' in keys2workgroupinfo4task:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step G/33) - GPU
                # -----------------------------------------------------------------------------------------               
                response4kernelworkgroupinfo['GPU'] = get2kernelworkgroupinfo4gpu(task4get2kernelworkgroupinfo['GPU'])
            
                message2print = "{(Step G/33) got" + "; gpu-got-by-get2kernelworkgroupinfo4xi: " + str(response4kernelworkgroupinfo['GPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'G-'
            except: 
                message2print = "{(Step GZ1/33) yielded" + "; gpu-yielded-by-get2kernelworkgroupinfo4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'GZ1-'     
        if 'HPU' in keys2workgroupinfo4task:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step H/33) - HPU
                # -----------------------------------------------------------------------------------------               
                response4kernelworkgroupinfo['HPU'] = get2kernelworkgroupinfo4hpu(task4get2kernelworkgroupinfo['HPU'])
            
                message2print = "{(Step H/33) got" + "; hpu-got-by-get2kernelworkgroupinfo4xi: " + str(response4kernelworkgroupinfo['HPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'H-'
            except: 
                message2print = "{(Step HZ1/33) yielded" + "; hpu-yielded-by-get2kernelworkgroupinfo4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'HZ1-'     
        if 'IPU' in keys2workgroupinfo4task:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step I/33) - IPU
                # -----------------------------------------------------------------------------------------               
                response4kernelworkgroupinfo['IPU'] = get2kernelworkgroupinfo4ipu(task4get2kernelworkgroupinfo['IPU'])
            
                message2print = "{(Step I/33) got" + "; ipu-got-by-get2kernelworkgroupinfo4xi: " + str(response4kernelworkgroupinfo['IPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'I-'
            except: 
                message2print = "{(Step IZ1/33) yielded" + "; ipu-yielded-by-get2kernelworkgroupinfo4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'IZ1-'     
        if 'JPU' in keys2workgroupinfo4task:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step J/33) - JPU
                # -----------------------------------------------------------------------------------------               
                response4kernelworkgroupinfo['JPU'] = get2kernelworkgroupinfo4jpu(task4get2kernelworkgroupinfo['JPU'])
            
                message2print = "{(Step J/33) got" + "; jpu-got-by-get2kernelworkgroupinfo4xi: " + str(response4kernelworkgroupinfo['JPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'J-'
            except: 
                message2print = "{(Step JZ1/33) yielded" + "; jpu-yielded-by-get2kernelworkgroupinfo4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'JZ1-'     
        if 'KPU' in keys2workgroupinfo4task:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step K/33) - KPU
                # -----------------------------------------------------------------------------------------               
                response4kernelworkgroupinfo['KPU'] = get2kernelworkgroupinfo4kpu(task4get2kernelworkgroupinfo['KPU'])
            
                message2print = "{(Step K/33) got" + "; kpu-got-by-get2kernelworkgroupinfo4xi: " + str(response4kernelworkgroupinfo['KPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'K-'
            except: 
                message2print = "{(Step KZ1/33) yielded" + "; kpu-yielded-by-get2kernelworkgroupinfo4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'KZ1-'     
        if 'LPU' in keys2workgroupinfo4task:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step L/33) - LPU
                # -----------------------------------------------------------------------------------------               
                response4kernelworkgroupinfo['LPU'] = get2kernelworkgroupinfo4lpu(task4get2kernelworkgroupinfo['LPU'])
            
                message2print = "{(Step L/33) got" + "; lpu-got-by-get2kernelworkgroupinfo4xi: " + str(response4kernelworkgroupinfo['LPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'L-'
            except: 
                message2print = "{(Step LZ1/33) yielded" + "; lpu-yielded-by-get2kernelworkgroupinfo4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'LZ1-'     
        if 'MPU' in keys2workgroupinfo4task:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step M/33) - MPU
                # -----------------------------------------------------------------------------------------               
                response4kernelworkgroupinfo['MPU'] = get2kernelworkgroupinfo4mpu(task4get2kernelworkgroupinfo['MPU'])
            
                message2print = "{(Step M/33) got" + "; mpu-got-by-get2kernelworkgroupinfo4xi: " + str(response4kernelworkgroupinfo['MPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'M-'
            except: 
                message2print = "{(Step MZ1/33) yielded" + "; mpu-yielded-by-get2kernelworkgroupinfo4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'MZ1-'     
        if 'NPU' in keys2workgroupinfo4task:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step N/33) - NPU
                # -----------------------------------------------------------------------------------------               
                response4kernelworkgroupinfo['NPU'] = get2kernelworkgroupinfo4npu(task4get2kernelworkgroupinfo['NPU'])
            
                message2print = "{(Step N/33) got" + "; npu-got-by-get2kernelworkgroupinfo4xi: " + str(response4kernelworkgroupinfo['NPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'N-'
            except: 
                message2print = "{(Step NZ1/33) yielded" + "; npu-yielded-by-get2kernelworkgroupinfo4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'NZ1-'     
        if 'OPU' in keys2workgroupinfo4task:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step O/33) - OPU
                # -----------------------------------------------------------------------------------------               
                response4kernelworkgroupinfo['OPU'] = get2kernelworkgroupinfo4opu(task4get2kernelworkgroupinfo['OPU'])
            
                message2print = "{(Step O/33) got" + "; opu-got-by-get2kernelworkgroupinfo4xi: " + str(response4kernelworkgroupinfo['OPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'O-'
            except: 
                message2print = "{(Step OZ1/33) yielded" + "; opu-yielded-by-get2kernelworkgroupinfo4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'OZ1-'     
        if 'PPU' in keys2workgroupinfo4task:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step P/33) - PPU
                # -----------------------------------------------------------------------------------------               
                response4kernelworkgroupinfo['PPU'] = get2kernelworkgroupinfo4ppu(task4get2kernelworkgroupinfo['PPU'])
            
                message2print = "{(Step P/33) got" + "; ppu-got-by-get2kernelworkgroupinfo4xi: " + str(response4kernelworkgroupinfo['PPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'P-'
            except: 
                message2print = "{(Step PZ1/33) yielded" + "; ppu-yielded-by-get2kernelworkgroupinfo4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'PZ1-'     
        if 'QPU' in keys2workgroupinfo4task:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step Q/33) - QPU
                # -----------------------------------------------------------------------------------------               
                response4kernelworkgroupinfo['QPU'] = get2kernelworkgroupinfo4qpu(task4get2kernelworkgroupinfo['QPU'])
            
                message2print = "{(Step Q/33) got" + "; qpu-got-by-get2kernelworkgroupinfo4xi: " + str(response4kernelworkgroupinfo['QPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'Q-'
            except: 
                message2print = "{(Step QZ1/33) yielded" + "; qpu-yielded-by-get2kernelworkgroupinfo4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'QZ1-'     
        if 'RPU' in keys2workgroupinfo4task:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step R/33) - RPU
                # -----------------------------------------------------------------------------------------               
                response4kernelworkgroupinfo['RPU'] = get2kernelworkgroupinfo4rpu(task4get2kernelworkgroupinfo['RPU'])
            
                message2print = "{(Step R/33) got" + "; rpu-got-by-get2kernelworkgroupinfo4xi: " + str(response4kernelworkgroupinfo['RPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'R-'
            except: 
                message2print = "{(Step RZ1/33) yielded" + "; rpu-yielded-by-get2kernelworkgroupinfo4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'RZ1-'     
        if 'SPU' in keys2workgroupinfo4task:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step S/33) - SPU
                # -----------------------------------------------------------------------------------------               
                response4kernelworkgroupinfo['SPU'] = get2kernelworkgroupinfo4spu(task4get2kernelworkgroupinfo['SPU'])
            
                message2print = "{(Step S/33) got" + "; spu-got-by-get2kernelworkgroupinfo4xi: " + str(response4kernelworkgroupinfo['SPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'S-'
            except: 
                message2print = "{(Step SZ1/33) yielded" + "; spu-yielded-by-get2kernelworkgroupinfo4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'SZ1-'     
        if 'TPU' in keys2workgroupinfo4task:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step T/33) - TPU
                # -----------------------------------------------------------------------------------------               
                response4kernelworkgroupinfo['TPU'] = get2kernelworkgroupinfo4tpu(task4get2kernelworkgroupinfo['TPU'])
            
                message2print = "{(Step T/33) got" + "; tpu-got-by-get2kernelworkgroupinfo4xi: " + str(response4kernelworkgroupinfo['TPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'T-'
            except: 
                message2print = "{(Step TZ1/33) yielded" + "; tpu-yielded-by-get2kernelworkgroupinfo4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'TZ1-'     
        if 'UPU' in keys2workgroupinfo4task:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step U/33) - UPU
                # -----------------------------------------------------------------------------------------               
                response4kernelworkgroupinfo['UPU'] = get2kernelworkgroupinfo4upu(task4get2kernelworkgroupinfo['UPU'])
            
                message2print = "{(Step U/33) got" + "; upu-got-by-get2kernelworkgroupinfo4xi: " + str(response4kernelworkgroupinfo['UPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'U-'
            except: 
                message2print = "{(Step UZ1/33) yielded" + "; upu-yielded-by-get2kernelworkgroupinfo4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'UZ1-'     
        if 'VPU' in keys2workgroupinfo4task:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step V/33) - VPU
                # -----------------------------------------------------------------------------------------               
                response4kernelworkgroupinfo['VPU'] = get2kernelworkgroupinfo4vpu(task4get2kernelworkgroupinfo['VPU'])
            
                message2print = "{(Step V/33) got" + "; vpu-got-by-get2kernelworkgroupinfo4xi: " + str(response4kernelworkgroupinfo['VPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'V-'
            except: 
                message2print = "{(Step VZ1/33) yielded" + "; vpu-yielded-by-get2kernelworkgroupinfo4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'VZ1-'     
        if 'WPU' in keys2workgroupinfo4task:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step W/33) - WPU
                # -----------------------------------------------------------------------------------------               
                response4kernelworkgroupinfo['WPU'] = get2kernelworkgroupinfo4wpu(task4get2kernelworkgroupinfo['WPU'])
            
                message2print = "{(Step W/33) got" + "; wpu-got-by-get2kernelworkgroupinfo4xi: " + str(response4kernelworkgroupinfo['WPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'W-'
            except: 
                message2print = "{(Step WZ1/33) yielded" + "; wpu-yielded-by-get2kernelworkgroupinfo4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'WZ1-'     
        if 'XPU' in keys2workgroupinfo4task:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step X/33) - XPU
                # -----------------------------------------------------------------------------------------               
                response4kernelworkgroupinfo['XPU'] = get2kernelworkgroupinfo4xpu(task4get2kernelworkgroupinfo['XPU'])
            
                message2print = "{(Step X/33) got" + "; xpu-got-by-get2kernelworkgroupinfo4xi: " + str(response4kernelworkgroupinfo['XPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'X-'
            except: 
                message2print = "{(Step XZ1/33) yielded" + "; xpu-yielded-by-get2kernelworkgroupinfo4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'XZ1-'     
        if 'YPU' in keys2workgroupinfo4task:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step Y/33) - YPU
                # -----------------------------------------------------------------------------------------               
                response4kernelworkgroupinfo['YPU'] = get2kernelworkgroupinfo4ypu(task4get2kernelworkgroupinfo['YPU'])
            
                message2print = "{(Step Y/33) got" + "; ypu-got-by-get2kernelworkgroupinfo4xi: " + str(response4kernelworkgroupinfo['YPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'Y-'
            except: 
                message2print = "{(Step YZ1/33) yielded" + "; ypu-yielded-by-get2kernelworkgroupinfo4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'YZ1-'     
        if 'ZPU' in keys2workgroupinfo4task:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step Z/33) - ZPU
                # -----------------------------------------------------------------------------------------               
                response4kernelworkgroupinfo['ZPU'] = get2kernelworkgroupinfo4zpu(task4get2kernelworkgroupinfo['ZPU'])
            
                message2print = "{(Step Z/33) got" + "; zpu-got-by-get2kernelworkgroupinfo4xi: " + str(response4kernelworkgroupinfo['ZPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'Z-'
            except: 
                message2print = "{(Step ZZ1/33) yielded" + "; zpu-yielded-by-get2kernelworkgroupinfo4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'ZZ1-'                 

            
          
    # -----------------------------------------------------------------------------------------
    # (Step 33/3)           
    # -----------------------------------------------------------------------------------------
    if debug is True:
        print("{(Step 33/33) of get2kernelworkgroupinfo4xi - RETURNING response4kernelworkgroupinfo: ", response4kernelworkgroupinfo)
            
    message2print = "{(Step 33/33) returning" + "; response4kernelworkgroupinfo-returning-by-get2kernelworkgroupinfo4xi: " + str(response4kernelworkgroupinfo) + "; time: " + time4xi() + "}"  
    print4xi(class2print, method2print, message2print)                                                              
    # 

    return response4kernelworkgroupinfo
            
#</function4xi>  

# -------------------------------------------------------------------------------------------------
#<function4xi function = "get2kernelarginfo4xi" usage = "
#     
#   print('=' *33)          
#   print('(Step 2A/700) OF KERNEL4XI5TEST - TRYING TO GET KERNEL ARG INFO KERNEL OF XI ', time4xi())      
#   print('=' *33)        
#   
#   try:
#       response4get2kernelarginfo = get2kernelarginfo4xi()                                                                 
#       print('(Step 2B/700) OF KERNEL4XI5TEST - GOT KERNEL ARG INFO XI ', time4xi())
#       keys2response = response4get2kernelarginfo.keys()
#       for key2response in sorted(keys2response):
#           print(key2response, ' : ', response4get2kernelarginfo[key2response])
#           # 
#   except:
#       print('(Step 2Z1/700) OF KERNEL4XI5TEST *** FAILED TO GET KERNEL ARG INFO KERNEL OF XI *** ', time4xi())
#
#">

# -------------------------------------------------------------------------------------------------   
def get2kernelarginfo4xi(task4get2kernelarginfo=None):

    '''
    geta kernel arg info of xi
    '''
    global platform2xi
    global device2xi
    global context2xi 
    global kernel4xi
    global info2kernel4xi                                                                                              
    
    # -----------------------------------------------------------------------------------------
    # (Step 1/70) - START           
    # -----------------------------------------------------------------------------------------          
    response4kernelarginfo = {} 
    debug = False
        
    class2print = "get2kernelarginfo4xi" 
    method2print = "get2kernelarginfo4xi"

    message2print = "{(Step 1A/70) started" + "; get2kernelarginfo4xi-started: " + str(get2kernelarginfo4xi)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)
    # 
  
             
    message2print = "{(Step 1B/70) passed" + "; task4get2kernelarginfo-to-get2kernelarginfo4xi: " + str(task4get2kernelarginfo) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                                                              
    # 

    code2ack  = ' '
    code2nack = ' '    
    
    ack2all = False             
    if task4get2kernelarginfo is None:
        # -----------------------------------------------------------------------------------------
        # NO PARAMETERS GIVEN BY CALLER FOR INITIALIZATION - SYSTEM CREATES ALL
        # -----------------------------------------------------------------------------------------    
        ack2all = True                                                                                                
        code2ack  = code2ack + '1C-'
    else:
        # -----------------------------------------------------------------------------------------
        # SOME PARAMETERS GIVEN BY CALLER FOR INITIALIZATION - KERNEL4XI NEEDS INITIALIZATION
        # -----------------------------------------------------------------------------------------        
        try:
            if kernel4xi is None:                                                                                       
                kernel4xi = create2kernel4xi() 
                code2ack  = code2ack + '1D-'
        except:
            kernel4xi = create2kernel4xi() 
            code2ack  = code2ack + '1D-'
                        
    # -----------------------------------------------------------------------------------------
    # (Step 2/33)
    # -----------------------------------------------------------------------------------------                  
    message2print = "{(Step 2A/3) try" + "; task4get2kernelarginfo-try-by-get2kernelarginfo4xi: " + str(task4get2kernelarginfo)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print) 
    # None 
    
    if ack2all is True:
        try:
            # -----------------------------------------------------------------------------------------
            # (Step 3/33) - ALL DEVICES
            # ----------------------------------------------------------------------------------------- 
            response4kernelarginfo['APU'] = get2kernelarginfo4apu()                                                                        
            response4kernelarginfo['BPU'] = get2kernelarginfo4bpu()   
            response4kernelarginfo['CPU'] = get2kernelarginfo4cpu()   
            response4kernelarginfo['DPU'] = get2kernelarginfo4dpu()   
            response4kernelarginfo['EPU'] = get2kernelarginfo4epu()   
            response4kernelarginfo['FPU'] = get2kernelarginfo4fpu()   
            response4kernelarginfo['GPU'] = get2kernelarginfo4gpu()   
            response4kernelarginfo['HPU'] = get2kernelarginfo4hpu()   
            response4kernelarginfo['IPU'] = get2kernelarginfo4ipu()   
            response4kernelarginfo['JPU'] = get2kernelarginfo4jpu()   
            response4kernelarginfo['KPU'] = get2kernelarginfo4kpu()   
            response4kernelarginfo['LPU'] = get2kernelarginfo4lpu()   
            response4kernelarginfo['MPU'] = get2kernelarginfo4mpu()   
            response4kernelarginfo['NPU'] = get2kernelarginfo4npu()   
            response4kernelarginfo['OPU'] = get2kernelarginfo4opu()   
            response4kernelarginfo['PPU'] = get2kernelarginfo4ppu()   
            response4kernelarginfo['QPU'] = get2kernelarginfo4qpu()   
            response4kernelarginfo['RPU'] = get2kernelarginfo4rpu()   
            response4kernelarginfo['SPU'] = get2kernelarginfo4spu()   
            response4kernelarginfo['TPU'] = get2kernelarginfo4tpu()   
            response4kernelarginfo['UPU'] = get2kernelarginfo4upu()   
            response4kernelarginfo['VPU'] = get2kernelarginfo4vpu()   
            response4kernelarginfo['XPU'] = get2kernelarginfo4xpu()   
            response4kernelarginfo['WPU'] = get2kernelarginfo4wpu()   
            response4kernelarginfo['YPU'] = get2kernelarginfo4ypu()   
            response4kernelarginfo['ZPU'] = get2kernelarginfo4zpu()   
            
            message2print = "{(Step 3A/33) got" + "; kernel4xi-got-by-get2kernelarginfo4xi to: " + str(kernel4xi)  + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print)                                                      
            # 
            
            code2ack  = code2ack + '3A-'
        except:
            message2print = "{(Step 3Z1/33) yielded" + "; kernel4xi-yielded-by-get2kernelarginfo4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                               #   
            code2nack  = code2nack + '3Z1-'
    else:    
        keys2kernelarginfo4task = task4get2kernelarginfo.keys()
        if 'APU' in keys2kernelarginfo4task:
            try:
                # -----------------------------------------------------------------------------------------
                # (Step A/33) - APU
                # -----------------------------------------------------------------------------------------               
                response4kernelarginfo['APU'] = get2kernelarginfo4apu(task4get2kernelarginfo['APU'])
            
                message2print = "{(Step A/33) got" + "; apu-got-by-get2kernelarginfo4xi: " + str(response4kernelarginfo['APU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'A-'
            except: 
                message2print = "{(Step AZ1/33) yielded" + "; apu-yielded-by-get2kernelarginfo4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'AZ1-'          
        if 'BPU' in keys2kernelarginfo4task:
            try:
                # -----------------------------------------------------------------------------------------
                # (Step B/33) - BPU
                # -----------------------------------------------------------------------------------------               
                response4kernelarginfo['BPU'] = get2kernelarginfo4bpu(task4get2kernelarginfo['BPU'])
            
                message2print = "{(Step B/33) got" + "; bpu-got-by-get2kernelarginfo4xi: " + str(response4kernelarginfo['BPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'B-'
            except: 
                message2print = "{(Step BZ1/33) yielded" + "; bpu-yielded-by-get2kernelarginfo4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'BZ1-'     
        if 'CPU' in keys2kernelarginfo4task:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step C/33) - CPU
                # -----------------------------------------------------------------------------------------               
                response4kernelarginfo['CPU'] = get2kernelarginfo4cpu(task4get2kernelarginfo['CPU'])
            
                message2print = "{(Step C/33) got" + "; cpu-got-by-get2kernelarginfo4xi: " + str(response4kernelarginfo['CPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'C-'
            except: 
                message2print = "{(Step CZ1/33) yielded" + "; cpu-yielded-by-get2kernelarginfo4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'CZ1-'     
        if 'DPU' in keys2kernelarginfo4task:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step D/33) - DPU
                # -----------------------------------------------------------------------------------------               
                response4kernelarginfo['DPU'] = get2kernelarginfo4dpu(task4get2kernelarginfo['DPU'])
            
                message2print = "{(Step D/33) got" + "; dpu-got-by-get2kernelarginfo4xi: " + str(response4kernelarginfo['DPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'D-'
            except: 
                message2print = "{(Step DZ1/33) yielded" + "; dpu-yielded-by-get2kernelarginfo4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'DZ1-'     
        if 'EPU' in keys2kernelarginfo4task:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step E/33) - EPU
                # -----------------------------------------------------------------------------------------               
                response4kernelarginfo['EPU'] = get2kernelarginfo4epu(task4get2kernelarginfo['EPU'])
            
                message2print = "{(Step E/33) got" + "; epu-got-by-get2kernelarginfo4xi: " + str(response4kernelarginfo['EPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'E-'
            except: 
                message2print = "{(Step EZ1/33) yielded" + "; epu-yielded-by-get2kernelarginfo4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'EZ1-'     
        if 'FPU' in keys2kernelarginfo4task:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step F/33) - FPU
                # -----------------------------------------------------------------------------------------               
                response4kernelarginfo['FPU'] = get2kernelarginfo4fpu(task4get2kernelarginfo['FPU'])
            
                message2print = "{(Step F/33) got" + "; fpu-got-by-get2kernelarginfo4xi: " + str(response4kernelarginfo['FPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'F-'
            except: 
                message2print = "{(Step FZ1/33) yielded" + "; fpu-yielded-by-get2kernelarginfo4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'FZ1-'     
        if 'GPU' in keys2kernelarginfo4task:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step G/33) - GPU
                # -----------------------------------------------------------------------------------------               
                response4kernelarginfo['GPU'] = get2kernelarginfo4gpu(task4get2kernelarginfo['GPU'])
            
                message2print = "{(Step G/33) got" + "; gpu-got-by-get2kernelarginfo4xi: " + str(response4kernelarginfo['GPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'G-'
            except: 
                message2print = "{(Step GZ1/33) yielded" + "; gpu-yielded-by-get2kernelarginfo4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'GZ1-'     
        if 'HPU' in keys2kernelarginfo4task:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step H/33) - HPU
                # -----------------------------------------------------------------------------------------               
                response4kernelarginfo['HPU'] = get2kernelarginfo4hpu(task4get2kernelarginfo['HPU'])
            
                message2print = "{(Step H/33) got" + "; hpu-got-by-get2kernelarginfo4xi: " + str(response4kernelarginfo['HPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'H-'
            except: 
                message2print = "{(Step HZ1/33) yielded" + "; hpu-yielded-by-get2kernelarginfo4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'HZ1-'     
        if 'IPU' in keys2kernelarginfo4task:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step I/33) - IPU
                # -----------------------------------------------------------------------------------------               
                response4kernelarginfo['IPU'] = get2kernelarginfo4ipu(task4get2kernelarginfo['IPU'])
            
                message2print = "{(Step I/33) got" + "; ipu-got-by-get2kernelarginfo4xi: " + str(response4kernelarginfo['IPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'I-'
            except: 
                message2print = "{(Step IZ1/33) yielded" + "; ipu-yielded-by-get2kernelarginfo4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'IZ1-'     
        if 'JPU' in keys2kernelarginfo4task:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step J/33) - JPU
                # -----------------------------------------------------------------------------------------               
                response4kernelarginfo['JPU'] = get2kernelarginfo4jpu(task4get2kernelarginfo['JPU'])
            
                message2print = "{(Step J/33) got" + "; jpu-got-by-get2kernelarginfo4xi: " + str(response4kernelarginfo['JPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'J-'
            except: 
                message2print = "{(Step JZ1/33) yielded" + "; jpu-yielded-by-get2kernelarginfo4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'JZ1-'     
        if 'KPU' in keys2kernelarginfo4task:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step K/33) - KPU
                # -----------------------------------------------------------------------------------------               
                response4kernelarginfo['KPU'] = get2kernelarginfo4kpu(task4get2kernelarginfo['KPU'])
            
                message2print = "{(Step K/33) got" + "; kpu-got-by-get2kernelarginfo4xi: " + str(response4kernelarginfo['KPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'K-'
            except: 
                message2print = "{(Step KZ1/33) yielded" + "; kpu-yielded-by-get2kernelarginfo4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'KZ1-'     
        if 'LPU' in keys2kernelarginfo4task:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step L/33) - LPU
                # -----------------------------------------------------------------------------------------               
                response4kernelarginfo['LPU'] = get2kernelarginfo4lpu(task4get2kernelarginfo['LPU'])
            
                message2print = "{(Step L/33) got" + "; lpu-got-by-get2kernelarginfo4xi: " + str(response4kernelarginfo['LPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'L-'
            except: 
                message2print = "{(Step LZ1/33) yielded" + "; lpu-yielded-by-get2kernelarginfo4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'LZ1-'     
        if 'MPU' in keys2kernelarginfo4task:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step M/33) - MPU
                # -----------------------------------------------------------------------------------------               
                response4kernelarginfo['MPU'] = get2kernelarginfo4mpu(task4get2kernelarginfo['MPU'])
            
                message2print = "{(Step M/33) got" + "; mpu-got-by-get2kernelarginfo4xi: " + str(response4kernelarginfo['MPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'M-'
            except: 
                message2print = "{(Step MZ1/33) yielded" + "; mpu-yielded-by-get2kernelarginfo4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'MZ1-'     
        if 'NPU' in keys2kernelarginfo4task:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step N/33) - NPU
                # -----------------------------------------------------------------------------------------               
                response4kernelarginfo['NPU'] = get2kernelarginfo4npu(task4get2kernelarginfo['NPU'])
            
                message2print = "{(Step N/33) got" + "; npu-got-by-get2kernelarginfo4xi: " + str(response4kernelarginfo['NPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'N-'
            except: 
                message2print = "{(Step NZ1/33) yielded" + "; npu-yielded-by-get2kernelarginfo4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'NZ1-'     
        if 'OPU' in keys2kernelarginfo4task:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step O/33) - OPU
                # -----------------------------------------------------------------------------------------               
                response4kernelarginfo['OPU'] = get2kernelarginfo4opu(task4get2kernelarginfo['OPU'])
            
                message2print = "{(Step O/33) got" + "; opu-got-by-get2kernelarginfo4xi: " + str(response4kernelarginfo['OPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'O-'
            except: 
                message2print = "{(Step OZ1/33) yielded" + "; opu-yielded-by-get2kernelarginfo4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'OZ1-'     
        if 'PPU' in keys2kernelarginfo4task:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step P/33) - PPU
                # -----------------------------------------------------------------------------------------               
                response4kernelarginfo['PPU'] = get2kernelarginfo4ppu(task4get2kernelarginfo['PPU'])
            
                message2print = "{(Step P/33) got" + "; ppu-got-by-get2kernelarginfo4xi: " + str(response4kernelarginfo['PPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'P-'
            except: 
                message2print = "{(Step PZ1/33) yielded" + "; ppu-yielded-by-get2kernelarginfo4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'PZ1-'     
        if 'QPU' in keys2kernelarginfo4task:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step Q/33) - QPU
                # -----------------------------------------------------------------------------------------               
                response4kernelarginfo['QPU'] = get2kernelarginfo4qpu(task4get2kernelarginfo['QPU'])
            
                message2print = "{(Step Q/33) got" + "; qpu-got-by-get2kernelarginfo4xi: " + str(response4kernelarginfo['QPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'Q-'
            except: 
                message2print = "{(Step QZ1/33) yielded" + "; qpu-yielded-by-get2kernelarginfo4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'QZ1-'     
        if 'RPU' in keys2kernelarginfo4task:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step R/33) - RPU
                # -----------------------------------------------------------------------------------------               
                response4kernelarginfo['RPU'] = get2kernelarginfo4rpu(task4get2kernelarginfo['RPU'])
            
                message2print = "{(Step R/33) got" + "; rpu-got-by-get2kernelarginfo4xi: " + str(response4kernelarginfo['RPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'R-'
            except: 
                message2print = "{(Step RZ1/33) yielded" + "; rpu-yielded-by-get2kernelarginfo4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'RZ1-'     
        if 'SPU' in keys2kernelarginfo4task:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step S/33) - SPU
                # -----------------------------------------------------------------------------------------               
                response4kernelarginfo['SPU'] = get2kernelarginfo4spu(task4get2kernelarginfo['SPU'])
            
                message2print = "{(Step S/33) got" + "; spu-got-by-get2kernelarginfo4xi: " + str(response4kernelarginfo['SPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'S-'
            except: 
                message2print = "{(Step SZ1/33) yielded" + "; spu-yielded-by-get2kernelarginfo4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'SZ1-'     
        if 'TPU' in keys2kernelarginfo4task:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step T/33) - TPU
                # -----------------------------------------------------------------------------------------               
                response4kernelarginfo['TPU'] = get2kernelarginfo4tpu(task4get2kernelarginfo['TPU'])
            
                message2print = "{(Step T/33) got" + "; tpu-got-by-get2kernelarginfo4xi: " + str(response4kernelarginfo['TPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'T-'
            except: 
                message2print = "{(Step TZ1/33) yielded" + "; tpu-yielded-by-get2kernelarginfo4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'TZ1-'     
        if 'UPU' in keys2kernelarginfo4task:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step U/33) - UPU
                # -----------------------------------------------------------------------------------------               
                response4kernelarginfo['UPU'] = get2kernelarginfo4upu(task4get2kernelarginfo['UPU'])
            
                message2print = "{(Step U/33) got" + "; upu-got-by-get2kernelarginfo4xi: " + str(response4kernelarginfo['UPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'U-'
            except: 
                message2print = "{(Step UZ1/33) yielded" + "; upu-yielded-by-get2kernelarginfo4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'UZ1-'     
        if 'VPU' in keys2kernelarginfo4task:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step V/33) - VPU
                # -----------------------------------------------------------------------------------------               
                response4kernelarginfo['VPU'] = get2kernelarginfo4vpu(task4get2kernelarginfo['VPU'])
            
                message2print = "{(Step V/33) got" + "; vpu-got-by-get2kernelarginfo4xi: " + str(response4kernelarginfo['VPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'V-'
            except: 
                message2print = "{(Step VZ1/33) yielded" + "; vpu-yielded-by-get2kernelarginfo4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'VZ1-'     
        if 'WPU' in keys2kernelarginfo4task:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step W/33) - WPU
                # -----------------------------------------------------------------------------------------               
                response4kernelarginfo['WPU'] = get2kernelarginfo4wpu(task4get2kernelarginfo['WPU'])
            
                message2print = "{(Step W/33) got" + "; wpu-got-by-get2kernelarginfo4xi: " + str(response4kernelarginfo['WPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'W-'
            except: 
                message2print = "{(Step WZ1/33) yielded" + "; wpu-yielded-by-get2kernelarginfo4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'WZ1-'     
        if 'XPU' in keys2kernelarginfo4task:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step X/33) - XPU
                # -----------------------------------------------------------------------------------------               
                response4kernelarginfo['XPU'] = get2kernelarginfo4xpu(task4get2kernelarginfo['XPU'])
            
                message2print = "{(Step X/33) got" + "; xpu-got-by-get2kernelarginfo4xi: " + str(response4kernelarginfo['XPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'X-'
            except: 
                message2print = "{(Step XZ1/33) yielded" + "; xpu-yielded-by-get2kernelarginfo4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'XZ1-'     
        if 'YPU' in keys2kernelarginfo4task:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step Y/33) - YPU
                # -----------------------------------------------------------------------------------------               
                response4kernelarginfo['YPU'] = get2kernelarginfo4ypu(task4get2kernelarginfo['YPU'])
            
                message2print = "{(Step Y/33) got" + "; ypu-got-by-get2kernelarginfo4xi: " + str(response4kernelarginfo['YPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'Y-'
            except: 
                message2print = "{(Step YZ1/33) yielded" + "; ypu-yielded-by-get2kernelarginfo4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'YZ1-'     
        if 'ZPU' in keys2kernelarginfo4task:            
            try:
                # -----------------------------------------------------------------------------------------
                # (Step Z/33) - ZPU
                # -----------------------------------------------------------------------------------------               
                response4kernelarginfo['ZPU'] = get2kernelarginfo4zpu(task4get2kernelarginfo['ZPU'])
            
                message2print = "{(Step Z/33) got" + "; zpu-got-by-get2kernelarginfo4xi: " + str(response4kernelarginfo['ZPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
                code2ack  = code2ack + 'Z-'
            except: 
                message2print = "{(Step ZZ1/33) yielded" + "; zpu-yielded-by-get2kernelarginfo4xi: " + str(kernel4xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + 'ZZ1-'                 

            
          
    # -----------------------------------------------------------------------------------------
    # (Step 33/3)           
    # -----------------------------------------------------------------------------------------
    if debug is True:
        print("{(Step 33/33) of get2kernelarginfo4xi - RETURNING response4kernelarginfo: ", response4kernelarginfo)
            
    message2print = "{(Step 33/33) returning" + "; response4kernelarginfo-returning-by-get2kernelarginfo4xi: " + str(response4kernelarginfo) + "; time: " + time4xi() + "}"  
    print4xi(class2print, method2print, message2print)                                                              
    # 

    return response4kernelarginfo
            
#</function4xi>  


                                               
# =================================================================================================
#<class4xi class = "Kernel4Xi" base = "object" child = "None"
#   synopsis = "offers  methods for XI kernel" usage = "OpenCL XI kernel"
#>

# =================================================================================================
class Kernel4Xi(object): 
    ''' 
    Kernel4Xi offers  methods for XI kernel
    '''            

    #                                        
    # ---------------------------------------------------------------------------------------------
    # sharable class variables
    # ---------------------------------------------------------------------------------------------      
    #<share4xi share = " 
    classvariable2xi = cpu_corecount4xi()
    #"
    #/>
        
    # ---------------------------------------------------------------------------------------------
    # Public API of this class
    # ---------------------------------------------------------------------------------------------    
    #<expose4xi expose = "
    _exposed_ = (
            'add2kernel',                      # NACK               

            'execute2kernel',                  # NACK 5.8    p169                                             
            'execute2task',                    # NACK 5.8    p172   
            'execute2nativekernel',            # NACK 5.8    p174     
            
            'create2kernel',                   # NACK 5.7.1  p157   
            'create2kernelsinprogram',         # NACK 5.7.1  p158  
                       
            'delete2kernel',                   # NACK

           
            'get2kernelinfo',                  # NACK 5.7.3  p162  
            'get2kernelworkgroupinfo',         # NACK 5.7.3  p164  
            'get2kernelarginfo',               # NACK 5.7.3  p166                                  
            
            'release2kernel',                  # NACK 5.7.1  p159                                         
            'retain2kernel',                   # NACK 5.7.1  p159   
 
            'set2kernel',                      # NACK 
            'set2kernelcallback',              # NACK 
            'set2kernelarg',                   # NACK 5.7.2  p160 
                                          
            'trace2kernel4xi'                  # NACK 

            'sense',                           # NACK 
            'reason',                          # NACK 
            'ace')                             # NACK         
    #"
    #/>
 
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "init-of-Kernel4Xi" usage = "
    #   if 'XXX' in keys2kernelarginfo4task:print('(Step 105A/700) OF KERNEL4XI5TEST - CREATING KERNEL4XI OBJECT ', time4xi())     
    #   try:
    #       # ---------------------------------------------------------------------------------------------
    #       # CREATE WITH OBJECT                        
    #       # ---------------------------------------------------------------------------------------------        
    #       kernelobject2xi = Kernel4Xi()
    #       print('(Step 105B/700) OF KERNEL4XI5TEST - CREATED KERNEL4XI OBJECT: ', kernelobject2xi)                                  
    #       # 
    #   except:
    #       print('(Step 105Z/700) OF KERNEL4XI5TEST *** FAILED TO CREATE KERNEL4XI OBJECT')
    #">
    
    # ---------------------------------------------------------------------------------------------   
    def __init__(self, task4kernelcreate2xi = None):
        '''
        _init__ method initializes Kernel4Xi
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------
                    
        class2print = "Kernel4Xi"
        method2print = "__init__"
                     
        message2print = "{(Step 1A/33) started" + "; init-of-Kernel4Xi-started: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)                                                          
        # 

        message2print = "{(Step 1B/33) borning" + "; kernel4xi-of-Kernel4Xi-borning: None" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
                
        message2print = "{(Step 1C/33) inheriting" + "; object-inheriting-by-kernel4xi-of-Kernel4Xi: " + str(object)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
        message2print = "{(Step 1D/33) sharing" + "; classvariable2xi-sharing-by-kernel4xi-of-Kernel4Xi: " + str(Kernel4Xi.classvariable2xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        #            
                                
        message2print = "{(Step 1E/33) passed" + "; task4kernelcreate2xi-passed-to-init-of-Kernel4Xi: " + str(task4kernelcreate2xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        #                         
        
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)             
        # -----------------------------------------------------------------------------------------
        apu2kernel2xi = create2kernel4xi(task4kernelcreate2xi)
        
                
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)             
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 3A/33) activated" + "; kernel4xi-of-Kernel4Xi-activated: " + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
                
        message2print = "{(Step 3B/33) inherited" + "; object-inherited-by-kernel4xi-of-Kernel4Xi: " + str(object)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
        message2print = "{(Step 3C/33) shared" + "; classvariable2xi-shared-by-kernel4xi-of-Kernel4Xi: " + str(Kernel4Xi.classvariable2xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        #           
       
        message2print = "{(Step 3D/33) returning" + "; init-of-Kernel4Xi-returning: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)                                                          
        # 
        

    #</methodize4xi>
    
        
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "create2kernel-of-Kernel4Xi" usage = "
    #    print('(Step 123A/700) OF KERNEL4XI5TEST - TRYING TO CREATE KERNEL FOR XI ', time4xi()) 
    # 
    #    try:
    #        p2xi = Kernel4Xi()                            
    #        
    #        task4create2kernel = {} 
    #        for key2pu in keys2pu:
    #            task4create2kernel [key2pu]  = {}
    #                        
    #        response4create2kernel = p2xi.create2kernel(task4create2kernel)                                  
    #        
    #        keys2response = response4create2kernel.keys()
    #        
    #        for key2response in sorted(keys2response):
    #            print(key2response, ' : ', response4create2kernel[key2response])
    #            #
    #            
    #    except:
    #        print('(Step 123Z/700) OF KERNEL4XI5TEST *** FAILED TO CREATE KERNEL FOR XI ', time4xi())               
    #">   
    
    # ---------------------------------------------------------------------------------------------   
    def create2kernel(self, task4create2kernel = None):
        '''
        creates kernel  for xi
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "Kernel4Xi"
        method2print = "create2kernel"
                     
        message2print = "{(Step 1A/33) started" + "; create2kernel-of-Kernel4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 
            
        message2print = "{(Step 1B/33) passed" + "; task4create2kernel-passed-to-create-of-Kernel4Xi: " + str(task4create2kernel) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                      
        # 
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2A/33) passing" + "; task4create2kernel-passing-to-create2kernel4xi-by-create2kernel-of-Kernel4Xi: " + str(task4create2kernel) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)            
        #    
  
        kernel2xi = create2kernel4xi(task4create2kernel)

        message2print = "{(Step 2B/33) performed" + "; create2kernel4xi-performed-by-create2kernel-of-Kernel4Xi: " + str(create2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
        # 
                                
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)           
        # ----------------------------------------------------------------------------------------- 
        message2print = "{(Step 3/33) returning" + "; kernel2xi-returning-by-create2kernel-of-Kernel4Xi: " + str(kernel2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)                                                          # 
        # 

        return kernel2xi
                                
    #                        
    #</methodize4xi>
        
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "create2kernelsinprogram-of-Kernel4Xi" usage = "
    #    print('(Step 123A/700) OF KERNELS IN PROGRAM4XI5TEST - TRYING TO CREATE KERNELS IN PROGRAM FOR XI ', time4xi()) 
    # 
    #    try:
    #        p2xi = Kernel4Xi()                            
    #        
    #        task4create2kernelsinprogram = {} 
    #        for key2pu in keys2pu:
    #            task4create2kernelsinprogram [key2pu]  = {}
    #                        
    #        response4create2kernelsinprogram = p2xi.create2kernelsinprogram(task4create2kernelsinprogram)                                  
    #        
    #        keys2response = response4create2kernelsinprogram.keys()
    #        
    #        for key2response in sorted(keys2response):
    #            print(key2response, ' : ', response4create2kernelsinprogram[key2response])
    #            #
    #            
    #    except:
    #        print('(Step 123Z/700) OF KERNELS IN PROGRAM4XI5TEST *** FAILED TO CREATE KERNELS IN PROGRAM FOR XI ', time4xi())               
    #">   
    
    # ---------------------------------------------------------------------------------------------   
    def create2kernelsinprogram(self, task4create2kernelsinprogram = None):
        '''
        creates kernels in program for xi
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "Kernel4Xi"
        method2print = "create2kernelsinprogram"
                     
        message2print = "{(Step 1A/33) started" + "; create2kernelsinprogram-of-Kernel4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 
            
        message2print = "{(Step 1B/33) passed" + "; task4create2kernelsinprogram-passed-to-create-of-Kernel4Xi: " + str(task4create2kernelsinprogram) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                      
        # 
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2A/33) passing" + "; task4create2kernelsinprogram-passing-to-create2kernelsinprogram4xi-by-create2kernelsinprogram-of-Kernel4Xi: " + str(task4create2kernelsinprogram) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)            
        #    
  
        kernel2xi = create2kernelsinprogram4xi(task4create2kernelsinprogram)

        message2print = "{(Step 2B/33) performed" + "; create2kernelsinprogram4xi-performed-by-create2kernelsinprogram-of-Kernel4Xi: " + str(create2kernelsinprogram4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
        # 
                                
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)           
        # ----------------------------------------------------------------------------------------- 
        message2print = "{(Step 3/33) returning" + "; kernel2xi-returning-by-create2kernelsinprogram-of-Kernel4Xi: " + str(kernel2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)                                                          # 
        # 

        return kernel2xi
                                
    #                        
    #</methodize4xi>

        
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "execute2kernel-of-Kernel4Xi" usage = "
    #    print('(Step 123A/700) OF KERNEL4XI5TEST - TRYING TO EXECUTE KERNEL FOR XI ', time4xi()) 
    # 
    #    try:
    #        p2xi = Kernel4Xi()                            
    #        
    #        task4execute2kernel = {} 
    #        for key2pu in keys2pu:
    #            task4execute2kernel [key2pu]  = {}
    #                        
    #        response4execute2kernel = p2xi.execute2kernel(task4execute2kernel)                                  
    #        
    #        keys2response = response4execute2kernel.keys()
    #        
    #        for key2response in sorted(keys2response):
    #            print(key2response, ' : ', response4execute2kernel[key2response])
    #            #
    #            
    #    except:
    #        print('(Step 123Z/700) OF KERNEL4XI5TEST *** FAILED TO EXECUTE KERNEL FOR XI ', time4xi())               
    #">   
    
    # ---------------------------------------------------------------------------------------------   
    def execute2kernel(self, task4execute2kernel = None):
        '''
        executes kernel for xi
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "Kernel4Xi"
        method2print = "execute2kernel"
                     
        message2print = "{(Step 1A/33) started" + "; execute2kernel-of-Kernel4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 
            
        message2print = "{(Step 1B/33) passed" + "; task4execute2kernel-passed-to-execute-of-Kernel4Xi: " + str(task4execute2kernel) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                      
        # 
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2A/33) passing" + "; task4execute2kernel-passing-to-execute2kernel4xi-by-execute2kernel-of-Kernel4Xi: " + str(task4execute2kernel) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)            
        #    
  
        kernel2xi = execute2kernel4xi(task4execute2kernel)

        message2print = "{(Step 2B/33) performed" + "; execute2kernel4xi-performed-by-execute2kernel-of-Kernel4Xi: " + str(execute2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
        # 
                                
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)           
        # ----------------------------------------------------------------------------------------- 
        message2print = "{(Step 3/33) returning" + "; kernel2xi-returning-by-execute2kernel-of-Kernel4Xi: " + str(kernel2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)                                                          # 
        # 

        return kernel2xi
                                
    #                        
    #</methodize4xi>
    
        
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "execute2nativekernel-of-Kernel4Xi" usage = "
    #    print('(Step 123A/700) OF NATIVE KERNEL4XI5TEST - TRYING TO EXECUTE NATIVE KERNEL FOR XI ', time4xi()) 
    # 
    #    try:
    #        p2xi = Kernel4Xi()                            
    #        
    #        task4execute2nativekernel = {} 
    #        for key2pu in keys2pu:
    #            task4execute2nativekernel [key2pu]  = {}
    #                        
    #        response4execute2nativekernel = p2xi.execute2nativekernel(task4execute2nativekernel)                                  
    #        
    #        keys2response = response4execute2nativekernel.keys()
    #        
    #        for key2response in sorted(keys2response):
    #            print(key2response, ' : ', response4execute2nativekernel[key2response])
    #            #
    #            
    #    except:
    #        print('(Step 123Z/700) OF NATIVE KERNEL4XI5TEST *** FAILED TO EXECUTE NATIVE KERNEL FOR XI ', time4xi())               
    #">   
    
    # ---------------------------------------------------------------------------------------------   
    def execute2nativekernel(self, task4execute2nativekernel = None):
        '''
        executes nativekernel for xi
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "Kernel4Xi"
        method2print = "execute2nativekernel"
                     
        message2print = "{(Step 1A/33) started" + "; execute2nativekernel-of-Kernel4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 
            
        message2print = "{(Step 1B/33) passed" + "; task4execute2nativekernel-passed-to-execute-of-Kernel4Xi: " + str(task4execute2nativekernel) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                      
        # 
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2A/33) passing" + "; task4execute2nativekernel-passing-to-execute2nativekernel4xi-by-execute2nativekernel-of-Kernel4Xi: " + str(task4execute2nativekernel) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)            
        #    
  
        nativekernel2xi = execute2nativekernel4xi(task4execute2nativekernel)

        message2print = "{(Step 2B/33) performed" + "; execute2nativekernel4xi-performed-by-execute2nativekernel-of-Kernel4Xi: " + str(execute2nativekernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
        # 
                                
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)           
        # ----------------------------------------------------------------------------------------- 
        message2print = "{(Step 3/33) returning" + "; nativekernel2xi-returning-by-execute2nativekernel-of-Kernel4Xi: " + str(nativekernel2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)                                                          # 
        # 

        return nativekernel2xi
                                
    #                        
    #</methodize4xi>
    
        
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "execute2task-of-Kernel4Xi" usage = "
    #    print('(Step 123A/700) OF TASK4XI5TEST - TRYING TO EXECUTE TASK FOR XI ', time4xi()) 
    # 
    #    try:
    #        p2xi = Kernel4Xi()                            
    #        
    #        task4execute2task = {} 
    #        for key2pu in keys2pu:
    #            task4execute2task [key2pu]  = {}
    #                        
    #        response4execute2task = p2xi.execute2task(task4execute2task)                                  
    #        
    #        keys2response = response4execute2task.keys()
    #        
    #        for key2response in sorted(keys2response):
    #            print(key2response, ' : ', response4execute2task[key2response])
    #            #
    #            
    #    except:
    #        print('(Step 123Z/700) OF TASK4XI5TEST *** FAILED TO EXECUTE TASK FOR XI ', time4xi())               
    #">   
    
    # ---------------------------------------------------------------------------------------------   
    def execute2task(self, task4execute2task = None):
        '''
        executes task for xi
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "Kernel4Xi"
        method2print = "execute2task"
                     
        message2print = "{(Step 1A/33) started" + "; execute2task-of-Kernel4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 
            
        message2print = "{(Step 1B/33) passed" + "; task4execute2task-passed-to-execute-of-Kernel4Xi: " + str(task4execute2task) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                      
        # 
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2A/33) passing" + "; task4execute2task-passing-to-execute2task4xi-by-execute2task-of-Kernel4Xi: " + str(task4execute2task) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)            
        #    
  
        task2xi = execute2task4xi(task4execute2task)

        message2print = "{(Step 2B/33) performed" + "; execute2task4xi-performed-by-execute2task-of-Kernel4Xi: " + str(execute2task4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
        # 
                                
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)           
        # ----------------------------------------------------------------------------------------- 
        message2print = "{(Step 3/33) returning" + "; task2xi-returning-by-execute2task-of-Kernel4Xi: " + str(task2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)                                                          # 
        # 

        return task2xi
                                
    #                        
    #</methodize4xi>        
    
    
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "set2kernelarg-of-Kernel4Xi" usage = "
    #    print('(Step 123A/700) OF KERNEL4XI5TEST - TRYING TO SET KERNEL ARG FOR XI ', time4xi()) 
    # 
    #    try:
    #        p2xi = Kernel4Xi()                            
    #        
    #        task4set2kernelarg = {} 
    #        for key2pu in keys2pu:
    #            task4set2kernelarg [key2pu]  = {}
    #                        
    #        response4set2kernelarg = p2xi.set2kernelarg(task4set2kernelarg)                                  
    #        
    #        keys2response = response4set2kernelarg.keys()
    #        
    #        for key2response in sorted(keys2response):
    #            print(key2response, ' : ', response4set2kernelarg[key2response])
    #            #
    #            
    #    except:
    #        print('(Step 123Z/700) OF KERNEL4XI5TEST *** FAILED TO SET KERNEL ARG FOR XI ', time4xi())               
    #">   
    
    # ---------------------------------------------------------------------------------------------   
    def set2kernelarg(self, task4set2kernelarg = None):
        '''
        sets kernel arg for xi
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "Kernel4Xi"
        method2print = "set2kernelarg"
                     
        message2print = "{(Step 1A/33) started" + "; set2kernelarg-of-Kernel4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 
            
        message2print = "{(Step 1B/33) passed" + "; task4set2kernelarg-passed-to-set-of-Kernel4Xi: " + str(task4set2kernelarg) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                      
        # 
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2A/33) passing" + "; task4set2kernelarg-passing-to-set2kernelarg4xi-by-set2kernelarg-of-Kernel4Xi: " + str(task4set2kernelarg) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)            
        #    
  
        kernel2xi = set2kernelarg4xi(task4set2kernelarg)

        message2print = "{(Step 2B/33) performed" + "; set2kernelarg4xi-performed-by-set2kernelarg-of-Kernel4Xi: " + str(set2kernelarg4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
        # 
                                
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)           
        # ----------------------------------------------------------------------------------------- 
        message2print = "{(Step 3/33) returning" + "; kernel2xi-returning-by-set2kernelarg-of-Kernel4Xi: " + str(kernel2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)                                                          # 
        # 

        return kernel2xi
                                
    #                        
    #</methodize4xi>

    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "set2kernel-of-Kernel4Xi" usage = "
    #    print('(Step 123A/700) OF KERNEL4XI5TEST - TRYING TO SET KERNEL  FOR XI ', time4xi()) 
    # 
    #    try:
    #        p2xi = Kernel4Xi()                            
    #        
    #        task4set2kernel = {} 
    #        for key2pu in keys2pu:
    #            task4set2kernel [key2pu]  = {}
    #                        
    #        response4set2kernel = p2xi.set2kernel(task4set2kernel)                                  
    #        
    #        keys2response = response4set2kernel.keys()
    #        
    #        for key2response in sorted(keys2response):
    #            print(key2response, ' : ', response4set2kernel[key2response])
    #            #
    #            
    #    except:
    #        print('(Step 123Z/700) OF KERNEL4XI5TEST *** FAILED TO SET KERNEL FOR XI ', time4xi())               
    #">   
    
    # ---------------------------------------------------------------------------------------------   
    def set2kernel(self, task4set2kernel = None):
        '''
        sets kernel for xi
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "Kernel4Xi"
        method2print = "set2kernel"
                     
        message2print = "{(Step 1A/33) started" + "; set2kernel-of-Kernel4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 
            
        message2print = "{(Step 1B/33) passed" + "; task4set2kernel-passed-to-set-of-Kernel4Xi: " + str(task4set2kernel) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                      
        # 
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2A/33) passing" + "; task4set2kernel-passing-to-set2kernel4xi-by-set2kernel-of-Kernel4Xi: " + str(task4set2kernel) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)            
        #    
  
        kernel2xi = set2kernel4xi(task4set2kernel)

        message2print = "{(Step 2B/33) performed" + "; set2kernel4xi-performed-by-set2kernel-of-Kernel4Xi: " + str(set2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
        # 
                                
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)           
        # ----------------------------------------------------------------------------------------- 
        message2print = "{(Step 3/33) returning" + "; kernel2xi-returning-by-set2kernel-of-Kernel4Xi: " + str(kernel2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)                                                          # 
        # 

        return kernel2xi
                                
    #                        
    #</methodize4xi>
        

        
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "add2kernel-of-Kernel4Xi" usage = "
    #    print('(Step 123A/700) OF KERNEL4XI5TEST - TRYING TO ADD KERNEL  FOR XI ', time4xi()) 
    # 
    #    try:
    #        p2xi = Kernel4Xi()                            
    #        
    #        task4add2kernel = {} 
    #        for key2pu in keys2pu:
    #            task4add2kernel [key2pu]  = {}
    #                        
    #        response4add2kernel = p2xi.add2kernel(task4add2kernel)                                  
    #        
    #        keys2response = response4add2kernel.keys()
    #        
    #        for key2response in sorted(keys2response):
    #            print(key2response, ' : ', response4add2kernel[key2response])
    #            #
    #            
    #    except:
    #        print('(Step 123Z/700) OF KERNEL4XI5TEST *** FAILED TO ADD KERNEL  FOR XI ', time4xi())               
    #">   
    
    # ---------------------------------------------------------------------------------------------   
    def add2kernel(self, task4add2kernel = None):
        '''
        add kernel for xi
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "Kernel4Xi"
        method2print = "add2kernel"
                     
        message2print = "{(Step 1A/33) started" + "; add2kernel-of-Kernel4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 
            
        message2print = "{(Step 1B/33) passed" + "; task4add2kernel-passed-to-set-of-Kernel4Xi: " + str(task4add2kernel) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                      
        # 
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2A/33) passing" + "; task4add2kernel-passing-to-add2kernel4xi-by-add2kernel-of-Kernel4Xi: " + str(task4add2kernel) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)            
        #    
  
        kernel2xi = add2kernel4xi(task4add2kernel)

        message2print = "{(Step 2B/33) performed" + "; add2kernel4xi-performed-by-add2kernel-of-Kernel4Xi: " + str(add2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
        # 
                                
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)           
        # ----------------------------------------------------------------------------------------- 
        message2print = "{(Step 3/33) returning" + "; kernel2xi-returning-by-add2kernel-of-Kernel4Xi: " + str(kernel2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)                                                          # 
        # 

        return kernel2xi
                                
    #                        
    #</methodize4xi>


    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "delete2kernel-of-Kernel4Xi" usage = "
    #    print('(Step 123A/700) OF KERNEL4XI5TEST - TRYING TO DELETE KERNEL WITH BINARY FOR XI ', time4xi()) 
    # 
    #    try:
    #        p2xi = Kernel4Xi()                            
    #        
    #        task4delete2kernel = {} 
    #        for key2pu in keys2pu:
    #            task4delete2kernel [key2pu]  = {}
    #                        
    #        response4delete2kernel = p2xi.delete2kernel(task4delete2kernel)                                  
    #        
    #        keys2response = response4delete2kernel.keys()
    #        
    #        for key2response in sorted(keys2response):
    #            print(key2response, ' : ', response4delete2kernel[key2response])
    #            #
    #            
    #    except:
    #        print('(Step 123Z/700) OF KERNEL4XI5TEST *** FAILED TO DELETE KERNEL WITH BINARY FOR XI ', time4xi())               
    #">   
    
    # ---------------------------------------------------------------------------------------------   
    def delete2kernel(self, task4delete2kernel = None):
        '''
        delete kernel for xi
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "Kernel4Xi"
        method2print = "delete2kernel"
                     
        message2print = "{(Step 1A/33) started" + "; delete2kernel-of-Kernel4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 
            
        message2print = "{(Step 1B/33) passed" + "; task4delete2kernel-passed-to-set-of-Kernel4Xi: " + str(task4delete2kernel) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                      
        # 
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2A/33) passing" + "; task4delete2kernel-passing-to-delete2kernel4xi-by-delete2kernel-of-Kernel4Xi: " + str(task4delete2kernel) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)            
        #    
        response4delete2kernel = None
        try:
            response4delete2kernel = delete2kernel4xi(task4delete2kernel)
            
            message2print = "{(Step 2B/33) performed" + "; delete2kernel4xi-performed-by-delete2kernel-of-Kernel4Xi: " + str(delete2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
        except:
            message2print = "{(Step 2Z/33) hit" + "; task4delete2kernel-hit-by-delete2kernel4xi-of-Kernel4Xi: " + " *** " + str(task4delete2kernel)  + " *** " + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)     

        message2print = "{(Step 2B/33) performed" + "; delete2kernel4xi-performed-by-delete2kernel-of-Kernel4Xi: " + str(delete2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
        # 
                                
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)           
        # ----------------------------------------------------------------------------------------- 
        message2print = "{(Step 3/33) returning" + "; response4delete2kernel-returning-by-delete2kernel-of-Kernel4Xi: " + str(response4delete2kernel) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)                                                          
        # 

        return response4delete2kernel
                                
                    
    #</methodize4xi>



    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "get2kernelinfo-of-Kernel4Xi" usage = "
    #    print('(Step 123A/700) OF KERNEL4XI5TEST - TRYING TO GET KERNEL INFO FOR XI ', time4xi()) 
    # 
    #    try:
    #        p2xi = Kernel4Xi()                            
    #        
    #        task4get2kernelinfo = {} 
    #        for key2pu in keys2pu:
    #            task4get2kernelinfo [key2pu]  = {}
    #                        
    #        response4get2kernelinfo = p2xi.get2kernelinfo(task4get2kernelinfo)                                  
    #        
    #        keys2response = response4get2kernelinfo.keys()
    #        
    #        for key2response in sorted(keys2response):
    #            print(key2response, ' : ', response4get2kernelinfo[key2response])
    #            #
    #            
    #    except:
    #        print('(Step 123Z/700) OF KERNEL4XI5TEST *** FAILED TO GET KERNEL INFO FOR XI ', time4xi())               
    #">   
    
    # ---------------------------------------------------------------------------------------------   
    def get2kernelinfo(self, task4get2kernelinfo = None):
        '''
        gets kernel info for xi
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "Kernel4Xi"
        method2print = "get2kernelinfo"
                     
        message2print = "{(Step 1A/33) started" + "; get2kernelinfo-of-Kernel4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 
            
        message2print = "{(Step 1B/33) passed" + "; task4get2kernelinfo-passed-to-set-of-Kernel4Xi: " + str(task4get2kernelinfo) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                      
        # 
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2A/33) passing" + "; task4get2kernelinfo-passing-to-get2kernelinfo4xi-by-get2kernelinfo-of-Kernel4Xi: " + str(task4get2kernelinfo) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)            
        #    
  
        kernel2xi = get2kernelinfo4xi(task4get2kernelinfo)

        message2print = "{(Step 2B/33) performed" + "; get2kernelinfo4xi-performed-by-get2kernelinfo-of-Kernel4Xi: " + str(get2kernelinfo4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
        # 
                                
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)           
        # ----------------------------------------------------------------------------------------- 
        message2print = "{(Step 3/33) returning" + "; kernel2xi-returning-by-get2kernelinfo-of-Kernel4Xi: " + str(kernel2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)                                                          # 
        # 

        return kernel2xi
                                
    #                        
    #</methodize4xi>

    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "get2kernelworkgroupinfo-of-Kernel4Xi" usage = "
    #    print('(Step 123A/700) OF KERNEL4XI5TEST - TRYING TO GET KERNEL WORKGROUP INFO FOR XI ', time4xi()) 
    # 
    #    try:
    #        p2xi = Kernel4Xi()                            
    #        
    #        task4get2kernelworkgroupinfo = {} 
    #        for key2pu in keys2pu:
    #            task4get2kernelworkgroupinfo [key2pu]  = {}
    #                        
    #        response4get2kernelworkgroupinfo = p2xi.get2kernelworkgroupinfo(task4get2kernelworkgroupinfo)                                  
    #        
    #        keys2response = response4get2kernelworkgroupinfo.keys()
    #        
    #        for key2response in sorted(keys2response):
    #            print(key2response, ' : ', response4get2kernelworkgroupinfo[key2response])
    #            #
    #            
    #    except:
    #        print('(Step 123Z/700) OF KERNEL4XI5TEST *** FAILED TO GET KERNEL WORKGROUP INFO FOR XI ', time4xi())               
    #">   
    
    # ---------------------------------------------------------------------------------------------   
    def get2kernelworkgroupinfo(self, task4get2kernelworkgroupinfo = None):
        '''
        gets kernel workgroup info for xi
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "Kernel4Xi"
        method2print = "get2kernelworkgroupinfo"
                     
        message2print = "{(Step 1A/33) started" + "; get2kernelworkgroupinfo-of-Kernel4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 
            
        message2print = "{(Step 1B/33) passed" + "; task4get2kernelworkgroupinfo-passed-to-set-of-Kernel4Xi: " + str(task4get2kernelworkgroupinfo) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                      
        # 
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2A/33) passing" + "; task4get2kernelworkgroupinfo-passing-to-get2kernelworkgroupinfo4xi-by-get2kernelworkgroupinfo-of-Kernel4Xi: " + str(task4get2kernelworkgroupinfo) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)            
        #    
  
        kernel2xi = get2kernelworkgroupinfo4xi(task4get2kernelworkgroupinfo)

        message2print = "{(Step 2B/33) performed" + "; get2kernelworkgroupinfo4xi-performed-by-get2kernelworkgroupinfo-of-Kernel4Xi: " + str(get2kernelworkgroupinfo4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
        # 
                                
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)           
        # ----------------------------------------------------------------------------------------- 
        message2print = "{(Step 3/33) returning" + "; kernel2xi-returning-by-get2kernelworkgroupinfo-of-Kernel4Xi: " + str(kernel2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)                                                          # 
        # 

        return kernel2xi
                                
    #                        
    #</methodize4xi>

    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "get2kernelarginfo-of-Kernel4Xi" usage = "
    #    print('(Step 123A/700) OF KERNEL4XI5TEST - TRYING TO GET KERNEL ARG INFO FOR XI ', time4xi()) 
    # 
    #    try:
    #        p2xi = Kernel4Xi()                            
    #        
    #        task4get2kernelarginfo = {} 
    #        for key2pu in keys2pu:
    #            task4get2kernelarginfo [key2pu]  = {}
    #                        
    #        response4get2kernelarginfo = p2xi.get2kernelarginfo(task4get2kernelarginfo)                                  
    #        
    #        keys2response = response4get2kernelarginfo.keys()
    #        
    #        for key2response in sorted(keys2response):
    #            print(key2response, ' : ', response4get2kernelarginfo[key2response])
    #            #
    #            
    #    except:
    #        print('(Step 123Z/700) OF KERNEL4XI5TEST *** FAILED TO GET KERNEL ARG INFO FOR XI ', time4xi())               
    #">   
    
    # ---------------------------------------------------------------------------------------------   
    def get2kernelarginfo(self, task4get2kernelarginfo = None):
        '''
        gets kernel arg info for xi
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "Kernel4Xi"
        method2print = "get2kernelarginfo"
                     
        message2print = "{(Step 1A/33) started" + "; get2kernelarginfo-of-Kernel4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 
            
        message2print = "{(Step 1B/33) passed" + "; task4get2kernelarginfo-passed-to-set-of-Kernel4Xi: " + str(task4get2kernelarginfo) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                      
        # 
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2A/33) passing" + "; task4get2kernelarginfo-passing-to-get2kernelarginfo4xi-by-get2kernelarginfo-of-Kernel4Xi: " + str(task4get2kernelarginfo) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)            
        #    
  
        kernel2xi = get2kernelarginfo4xi(task4get2kernelarginfo)

        message2print = "{(Step 2B/33) performed" + "; get2kernelarginfo4xi-performed-by-get2kernelarginfo-of-Kernel4Xi: " + str(get2kernelarginfo4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
        # 
                                
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)           
        # ----------------------------------------------------------------------------------------- 
        message2print = "{(Step 3/33) returning" + "; kernel2xi-returning-by-get2kernelarginfo-of-Kernel4Xi: " + str(kernel2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)                                                          # 
        # 

        return kernel2xi
                                
    #                        
    #</methodize4xi>


    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "release2kernel-of-Kernel4Xi" usage = "
    #    print('(Step 123A/700) OF KERNEL4XI5TEST - TRYING TO RELEASE KERNEL FOR XI ', time4xi()) 
    # 
    #    try:
    #        p2xi = Kernel4Xi()                            
    #        
    #        task4release2kernel = {} 
    #        for key2pu in keys2pu:
    #            task4release2kernel [key2pu]  = {}
    #                        
    #        response4release2kernel = p2xi.release2kernel(task4release2kernel)                                  
    #        
    #        keys2response = response4release2kernel.keys()
    #        
    #        for key2response in sorted(keys2response):
    #            print(key2response, ' : ', response4release2kernel[key2response])
    #            #
    #            
    #    except:
    #        print('(Step 123Z/700) OF KERNEL4XI5TEST *** FAILED TO RELEASE KERNEL FOR XI ', time4xi())               
    #">   
    
    # ---------------------------------------------------------------------------------------------   
    def release2kernel(self, task4release2kernel = None):
        '''
        releases kernel for xi
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "Kernel4Xi"
        method2print = "release2kernel"
                     
        message2print = "{(Step 1A/33) started" + "; release2kernel-of-Kernel4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 
            
        message2print = "{(Step 1B/33) passed" + "; task4release2kernel-passed-to-set-of-Kernel4Xi: " + str(task4release2kernel) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                      
        # 
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2A/33) passing" + "; task4release2kernel-passing-to-release2kernel4xi-by-release2kernel-of-Kernel4Xi: " + str(task4release2kernel) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)            
        #    
  
        kernel2xi = release2kernel4xi(task4release2kernel)

        message2print = "{(Step 2B/33) performed" + "; release2kernel4xi-performed-by-release2kernel-of-Kernel4Xi: " + str(release2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
        # 
                                
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)           
        # ----------------------------------------------------------------------------------------- 
        message2print = "{(Step 3/33) returning" + "; kernel2xi-returning-by-release2kernel-of-Kernel4Xi: " + str(kernel2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)                                                          # 
        # 

        return kernel2xi
                                
    #                        
    #</methodize4xi>
    

    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "retain2kernel-of-Kernel4Xi" usage = "
    #    print('(Step 123A/700) OF KERNEL4XI5TEST - TRYING TO RETAIN KERNEL FOR XI ', time4xi()) 
    # 
    #    try:
    #        p2xi = Kernel4Xi()                            
    #        
    #        task4retain2kernel = {} 
    #        for key2pu in keys2pu:
    #            task4retain2kernel [key2pu]  = {}
    #                        
    #        response4retain2kernel = p2xi.retain2kernel(task4retain2kernel)                                  
    #        
    #        keys2response = response4retain2kernel.keys()
    #        
    #        for key2response in sorted(keys2response):
    #            print(key2response, ' : ', response4retain2kernel[key2response])
    #            #
    #            
    #    except:
    #        print('(Step 123Z/700) OF KERNEL4XI5TEST *** FAILED TO RETAIN KERNEL FOR XI ', time4xi())               
    #">   
    
    # ---------------------------------------------------------------------------------------------   
    def retain2kernel(self, task4retain2kernel = None):
        '''
        retains kernel for xi
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "Kernel4Xi"
        method2print = "retain2kernel"
                     
        message2print = "{(Step 1A/33) started" + "; retain2kernel-of-Kernel4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 
            
        message2print = "{(Step 1B/33) passed" + "; task4retain2kernel-passed-to-set-of-Kernel4Xi: " + str(task4retain2kernel) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                      
        # 
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2A/33) passing" + "; task4retain2kernel-passing-to-retain2kernel4xi-by-retain2kernel-of-Kernel4Xi: " + str(task4retain2kernel) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)            
        #    
  
        kernel2xi = retain2kernel4xi(task4retain2kernel)

        message2print = "{(Step 2B/33) performed" + "; retain2kernel4xi-performed-by-retain2kernel-of-Kernel4Xi: " + str(retain2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
        # 
                                
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)           
        # ----------------------------------------------------------------------------------------- 
        message2print = "{(Step 3/33) returning" + "; kernel2xi-returning-by-retain2kernel-of-Kernel4Xi: " + str(kernel2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)                                                          # 
        # 

        return kernel2xi
                                
    #                        
    #</methodize4xi>
    

                  
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "trace2kernel-of-Kernel4Xi" usage = "
    #
    #    print('(Step 125A/25) OF KERNEL4XI5TEST - TRYING TO TRACE XI: ', time4xi()) 
    #    try:                               
    #        task4trace2kernel  = {}
    #        for key2pu in keys2pu:
    #            task4trace2kernel[key2pu]  = {}
    #            
    #        response4trace2kernel = p2xi.trace2kernel(task4trace2kernel) 
    #        
    #        key2response = response4trace2kernel.keys()
    #        for key2response in sorted(keys2response):
    #            print(key2response, ' : ', response4trace2kernel[key2response] )
    #            # APU  :  {'MESSAGE': '{(Step 2Z0/33) failed; trace2kernel4apu-failed {}; time: 07:07:05 11/05/11 Pacific Daylight Time}', 'CLASS': 'trace2kernel4apu', 'METHOD': 'trace2kernel4apu'}
    #            # BPU  :  {'MESSAGE': '{(Step 2Z0/33) failed; trace2kernel4bpu-failed {}; time: 07:07:05 11/05/11 Pacific Daylight Time}', 'CLASS': 'trace2kernel4bpu', 'METHOD': 'trace2kernel4bpu'}
    #            # CPU  :  {'MESSAGE': '{(Step 2Z0/33) failed; trace2kernel4cpu-failed {}; time: 07:07:05 11/05/11 Pacific Daylight Time}', 'CLASS': 'trace2kernel4cpu', 'METHOD': 'trace2kernel4cpu'}
    #            # DPU  :  {'MESSAGE': '{(Step 2Z0/33) failed; trace2kernel4dpu-failed {}; time: 07:07:05 11/05/11 Pacific Daylight Time}', 'CLASS': 'trace2kernel4dpu', 'METHOD': 'trace2kernel4dpu'}
    #            # EPU  :  {'MESSAGE': '{(Step 2Z0/33) failed; trace2kernel4epu-failed {}; time: 07:07:05 11/05/11 Pacific Daylight Time}', 'CLASS': 'trace2kernel4epu', 'METHOD': 'trace2kernel4epu'}
    #            # FPU  :  {'MESSAGE': '{(Step 2Z0/33) failed; trace2kernel4fpu-failed {}; time: 07:07:05 11/05/11 Pacific Daylight Time}', 'CLASS': 'trace2kernel4fpu', 'METHOD': 'trace2kernel4fpu'}
    #            # GPU  :  {'MESSAGE': '{(Step 2Z0/33) failed; trace2kernel4gpu-failed {}; time: 07:07:05 11/05/11 Pacific Daylight Time}', 'CLASS': 'trace2kernel4gpu', 'METHOD': 'trace2kernel4gpu'}
    #            # HPU  :  {'MESSAGE': '{(Step 2Z0/33) failed; trace2kernel4hpu-failed {}; time: 07:07:05 11/05/11 Pacific Daylight Time}', 'CLASS': 'trace2kernel4hpu', 'METHOD': 'trace2kernel4hpu'}
    #            # IPU  :  {'MESSAGE': '{(Step 2Z0/33) failed; trace2kernel4ipu-failed {}; time: 07:07:05 11/05/11 Pacific Daylight Time}', 'CLASS': 'trace2kernel4ipu', 'METHOD': 'trace2kernel4ipu'}
    #            # JPU  :  {'MESSAGE': '{(Step 2Z0/33) failed; trace2kernel4jpu-failed {}; time: 07:07:05 11/05/11 Pacific Daylight Time}', 'CLASS': 'trace2kernel4jpu', 'METHOD': 'trace2kernel4jpu'}
    #            # KPU  :  {'MESSAGE': '{(Step 2Z0/33) failed; trace2kernel4kpu-failed {}; time: 07:07:05 11/05/11 Pacific Daylight Time}', 'CLASS': 'trace2kernel4kpu', 'METHOD': 'trace2kernel4kpu'}
    #            # LPU  :  {'MESSAGE': '{(Step 2Z0/33) failed; trace2kernel4lpu-failed {}; time: 07:07:05 11/05/11 Pacific Daylight Time}', 'CLASS': 'trace2kernel4lpu', 'METHOD': 'trace2kernel4lpu'}
    #            # MPU  :  {'MESSAGE': '{(Step 2Z0/33) failed; trace2kernel4mpu-failed {}; time: 07:07:05 11/05/11 Pacific Daylight Time}', 'CLASS': 'trace2kernel4mpu', 'METHOD': 'trace2kernel4mpu'}
    #            # NPU  :  {'MESSAGE': '{(Step 2Z0/33) failed; trace2kernel4npu-failed {}; time: 07:07:05 11/05/11 Pacific Daylight Time}', 'CLASS': 'trace2kernel4npu', 'METHOD': 'trace2kernel4npu'}
    #            # OPU  :  {'MESSAGE': '{(Step 2Z0/33) failed; trace2kernel4opu-failed {}; time: 07:07:05 11/05/11 Pacific Daylight Time}', 'CLASS': 'trace2kernel4opu', 'METHOD': 'trace2kernel4opu'}
    #            # PPU  :  {'MESSAGE': '{(Step 2Z0/33) failed; trace2kernel4ppu-failed {}; time: 07:07:05 11/05/11 Pacific Daylight Time}', 'CLASS': 'trace2kernel4ppu', 'METHOD': 'trace2kernel4ppu'}
    #            # QPU  :  {'MESSAGE': '{(Step 2Z0/33) failed; trace2kernel4qpu-failed {}; time: 07:07:05 11/05/11 Pacific Daylight Time}', 'CLASS': 'trace2kernel4qpu', 'METHOD': 'trace2kernel4qpu'}
    #            # RPU  :  {'MESSAGE': '{(Step 2Z0/33) failed; trace2kernel4rpu-failed {}; time: 07:07:05 11/05/11 Pacific Daylight Time}', 'CLASS': 'trace2kernel4rpu', 'METHOD': 'trace2kernel4rpu'}
    #            # SPU  :  {'MESSAGE': '{(Step 2Z0/33) failed; trace2kernel4spu-failed {}; time: 07:07:05 11/05/11 Pacific Daylight Time}', 'CLASS': 'trace2kernel4spu', 'METHOD': 'trace2kernel4spu'}
    #            # TPU  :  {'MESSAGE': '{(Step 2Z0/33) failed; trace2kernel4tpu-failed {}; time: 07:07:05 11/05/11 Pacific Daylight Time}', 'CLASS': 'trace2kernel4tpu', 'METHOD': 'trace2kernel4tpu'}
    #            # UPU  :  {'MESSAGE': '{(Step 2Z0/33) failed; trace2kernel4upu-failed {}; time: 07:07:05 11/05/11 Pacific Daylight Time}', 'CLASS': 'trace2kernel4upu', 'METHOD': 'trace2kernel4upu'}
    #            # VPU  :  {'MESSAGE': '{(Step 2Z0/33) failed; trace2kernel4vpu-failed {}; time: 07:07:05 11/05/11 Pacific Daylight Time}', 'CLASS': 'trace2kernel4vpu', 'METHOD': 'trace2kernel4vpu'}
    #            # WPU  :  {'MESSAGE': '{(Step 2Z0/33) failed; trace2kernel4wpu-failed {}; time: 07:07:05 11/05/11 Pacific Daylight Time}', 'CLASS': 'trace2kernel4wpu', 'METHOD': 'trace2kernel4wpu'}
    #            # XPU  :  {'MESSAGE': '{(Step 2Z0/33) failed; trace2kernel4xpu-failed {}; time: 07:07:05 11/05/11 Pacific Daylight Time}', 'CLASS': 'trace2kernel4xpu', 'METHOD': 'trace2kernel4xpu'}
    #            # YPU  :  {'MESSAGE': '{(Step 2Z0/33) failed; trace2kernel4ypu-failed {}; time: 07:07:05 11/05/11 Pacific Daylight Time}', 'CLASS': 'trace2kernel4ypu', 'METHOD': 'trace2kernel4ypu'}
    #            # ZPU  :  {'MESSAGE': '{(Step 2Z0/33) failed; trace2kernel4zpu-failed {}; time: 07:07:05 11/05/11 Pacific Daylight Time}', 'CLASS': 'trace2kernel4zpu', 'METHOD': 'trace2kernel4zpu'}
    #                                                                                                       
    #    except:
    #        print('(Step 125Z/25) OF KERNEL4XI5TEST *** FAILED TO TRACE XI: ', time4xi())       
    # 
    #">
    
    # ---------------------------------------------------------------------------------------------   
    def trace2kernel(self, task4trace2kernel = None):
        '''
        traces Kernel4Xi objects
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "Kernel4Xi"
        method2print = "trace2kernel"
                     
        message2print = "{(Step 1A/33) started" + "; trace2kernel-of-Kernel4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 
            
        message2print = "{(Step 1B/33) passed" + "; task4trace2kernel-passed-to-trace-of-Kernel4Xi: " + str(task4trace2kernel) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        #    
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2A/33) passing" + "; task4trace2kernel-passing-to-trace2kernel4xi-by-trace2kernel-of-Kernel4Xi: " + str(task4trace2kernel) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                               
        # 
  
        trace2xi = trace2kernel4xi(task4trace2kernel)

        message2print = "{(Step 2B/33) performed" + "; trace2kernel4xi-performed-by-trace2kernel-of-Kernel4Xi: " + str(trace2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
        # 
                                
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)           
        # ----------------------------------------------------------------------------------------- 
       
        message2print = "{(Step 3A/33) returning" + "; trace2xi-returning-by-trace2kernel-of-Kernel4Xi: " + str(trace2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
        # 
                 
                
        return trace2xi
                                                           
    #</methodize4xi>       


    
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "set2kernelcallback-of-Kernel4Xi" usage = "
    # 
    #    print('(Step 124A/700) OF KERNEL4XI5TEST - TRYING TO SET KERNEL CALLBACK WITH METHOD OF OBJECT XI2XI: ', p2xi) 
    # 
    #    try:
    #        task4callback2kernel = {} 
    #        for key2pu in keys2pu:
    #            task4callback2kernel [key2pu]  = {}
    #                                         
    #        response4callback = p2xi.set2kernelcallback(task4callback2kernel)                                  
    #        
    #        key2response = response4callback.keys()
    #        for key2response in sorted(keys2response):
    #            print(key2response, ' : ', response4callback [key2response] )
    #            # APU  :  {'CALLBACK': <function trace2kernel4apu at 0x00000000043E2648>, 'ACK2RETURN': ' ', 'NACK2RETURN': ' 21Z1-22Z2-22Z3-23Z1-24Z1-25Z1-26Z1-27Z1-28Z1-29Z1-30Z1-31Z1-34Z1-35Z1-36Z1-37Z1-38Z1-39Z1-'}
    #            # BPU  :  {'CALLBACK': <function trace2kernel4bpu at 0x00000000044C40C8>, 'ACK2RETURN': ' ', 'NACK2RETURN': ' 21Z1-22Z2-22Z3-23Z1-24Z1-25Z1-26Z1-27Z1-28Z1-29Z1-30Z1-31Z1-34Z1-35Z1-36Z1-37Z1-38Z1-39Z1-'}
    #            # CPU  :  {'CALLBACK': <function trace2kernel4cpu at 0x0000000004581848>, 'ACK2RETURN': ' ', 'NACK2RETURN': ' 21Z1-22Z2-22Z3-23Z1-24Z1-25Z1-26Z1-27Z1-28Z1-29Z1-30Z1-31Z1-34Z1-35Z1-36Z1-37Z1-38Z1-39Z1-'}
    #            # DPU  :  {'CALLBACK': <function trace2kernel4dpu at 0x00000000046AD048>, 'ACK2RETURN': ' ', 'NACK2RETURN': ' 21Z1-22Z2-22Z3-23Z1-24Z1-25Z1-26Z1-27Z1-28Z1-29Z1-30Z1-31Z1-34Z1-35Z1-36Z1-37Z1-38Z1-39Z1-'}
    #            # EPU  :  {'CALLBACK': <function trace2kernel4epu at 0x00000000047667C8>, 'ACK2RETURN': ' ', 'NACK2RETURN': ' 21Z1-22Z2-22Z3-23Z1-24Z1-25Z1-26Z1-27Z1-28Z1-29Z1-30Z1-31Z1-34Z1-35Z1-36Z1-37Z1-38Z1-39Z1-'}
    #            # FPU  :  {'CALLBACK': <function trace2kernel4fpu at 0x000000000483AF48>, 'ACK2RETURN': ' ', 'NACK2RETURN': ' 21Z1-22Z2-22Z3-23Z1-24Z1-25Z1-26Z1-27Z1-28Z1-29Z1-30Z1-31Z1-34Z1-35Z1-36Z1-37Z1-38Z1-39Z1-'}
    #            # GPU  :  {'CALLBACK': <function trace2kernel4gpu at 0x0000000004914748>, 'ACK2RETURN': ' ', 'NACK2RETURN': ' 21Z1-22Z2-22Z3-23Z1-24Z1-25Z1-26Z1-27Z1-28Z1-29Z1-30Z1-31Z1-34Z1-35Z1-36Z1-37Z1-38Z1-39Z1-'}
    #            # HPU  :  {'CALLBACK': <function trace2kernel4hpu at 0x00000000049B0EC8>, 'ACK2RETURN': ' ', 'NACK2RETURN': ' 21Z1-22Z2-22Z3-23Z1-24Z1-25Z1-26Z1-27Z1-28Z1-29Z1-30Z1-31Z1-34Z1-35Z1-36Z1-37Z1-38Z1-39Z1-'}
    #            # IPU  :  {'CALLBACK': <function trace2kernel4ipu at 0x0000000004A8F6C8>, 'ACK2RETURN': ' ', 'NACK2RETURN': ' 21Z1-22Z2-22Z3-23Z1-24Z1-25Z1-26Z1-27Z1-28Z1-29Z1-30Z1-31Z1-34Z1-35Z1-36Z1-37Z1-38Z1-39Z1-'}
    #            # JPU  :  {'CALLBACK': <function trace2kernel4jpu at 0x0000000004B19E48>, 'ACK2RETURN': ' ', 'NACK2RETURN': ' 21Z1-22Z2-22Z3-23Z1-24Z1-25Z1-26Z1-27Z1-28Z1-29Z1-30Z1-31Z1-34Z1-35Z1-36Z1-37Z1-38Z1-39Z1-'}
    #            # KPU  :  {'CALLBACK': <function trace2kernel4kpu at 0x0000000004C00648>, 'ACK2RETURN': ' ', 'NACK2RETURN': ' 21Z1-22Z2-22Z3-23Z1-24Z1-25Z1-26Z1-27Z1-28Z1-29Z1-30Z1-31Z1-34Z1-35Z1-36Z1-37Z1-38Z1-39Z1-'}
    #            # LPU  :  {'CALLBACK': <function trace2kernel4lpu at 0x0000000004CC4DC8>, 'ACK2RETURN': ' ', 'NACK2RETURN': ' 21Z1-22Z2-22Z3-23Z1-24Z1-25Z1-26Z1-27Z1-28Z1-29Z1-30Z1-31Z1-34Z1-35Z1-36Z1-37Z1-38Z1-39Z1-'}
    #            # MPU  :  {'CALLBACK': <function trace2kernel4mpu at 0x0000000004DA55C8>, 'ACK2RETURN': ' ', 'NACK2RETURN': ' 21Z1-22Z2-22Z3-23Z1-24Z1-25Z1-26Z1-27Z1-28Z1-29Z1-30Z1-31Z1-34Z1-35Z1-36Z1-37Z1-38Z1-39Z1-'}
    #            # NPU  :  {'CALLBACK': <function trace2kernel4npu at 0x0000000004E47D48>, 'ACK2RETURN': ' ', 'NACK2RETURN': ' 21Z1-22Z2-22Z3-23Z1-24Z1-25Z1-26Z1-27Z1-28Z1-29Z1-30Z1-31Z1-34Z1-35Z1-36Z1-37Z1-38Z1-39Z1-'}
    #            # OPU  :  {'CALLBACK': <function trace2kernel4opu at 0x0000000004F4B548>, 'ACK2RETURN': ' ', 'NACK2RETURN': ' 21Z1-22Z2-22Z3-23Z1-24Z1-25Z1-26Z1-27Z1-28Z1-29Z1-30Z1-31Z1-34Z1-35Z1-36Z1-37Z1-38Z1-39Z1-'}
    #            # PPU  :  {'CALLBACK': <function trace2kernel4ppu at 0x0000000004FDDCC8>, 'ACK2RETURN': ' ', 'NACK2RETURN': ' 21Z1-22Z2-22Z3-23Z1-24Z1-25Z1-26Z1-27Z1-28Z1-29Z1-30Z1-31Z1-34Z1-35Z1-36Z1-37Z1-38Z1-39Z1-'}
    #            # QPU  :  {'CALLBACK': <function trace2kernel4qpu at 0x00000000051034C8>, 'ACK2RETURN': ' ', 'NACK2RETURN': ' 21Z1-22Z2-22Z3-23Z1-24Z1-25Z1-26Z1-27Z1-28Z1-29Z1-30Z1-31Z1-34Z1-35Z1-36Z1-37Z1-38Z1-39Z1-'}
    #            # RPU  :  {'CALLBACK': <function trace2kernel4rpu at 0x0000000005248C48>, 'ACK2RETURN': ' ', 'NACK2RETURN': ' 21Z1-22Z2-22Z3-23Z1-24Z1-25Z1-26Z1-27Z1-28Z1-29Z1-30Z1-31Z1-34Z1-35Z1-36Z1-37Z1-38Z1-39Z1-'}
    #            # SPU  :  {'CALLBACK': <function trace2kernel4spu at 0x0000000005337448>, 'ACK2RETURN': ' ', 'NACK2RETURN': ' 21Z1-22Z2-22Z3-23Z1-24Z1-25Z1-26Z1-27Z1-28Z1-29Z1-30Z1-31Z1-34Z1-35Z1-36Z1-37Z1-38Z1-39Z1-'}
    #            # TPU  :  {'CALLBACK': <function trace2kernel4tpu at 0x00000000053F7BC8>, 'ACK2RETURN': ' ', 'NACK2RETURN': ' 21Z1-22Z2-22Z3-23Z1-24Z1-25Z1-26Z1-27Z1-28Z1-29Z1-30Z1-31Z1-34Z1-35Z1-36Z1-37Z1-38Z1-39Z1-'}
    #            # UPU  :  {'CALLBACK': <function trace2kernel4upu at 0x00000000054A23C8>, 'ACK2RETURN': ' ', 'NACK2RETURN': ' 21Z1-22Z2-22Z3-23Z1-24Z1-25Z1-26Z1-27Z1-28Z1-29Z1-30Z1-31Z1-34Z1-35Z1-36Z1-37Z1-38Z1-39Z1-'}
    #            # VPU  :  {'CALLBACK': <function trace2kernel4vpu at 0x0000000005537B48>, 'ACK2RETURN': ' ', 'NACK2RETURN': ' 21Z1-22Z2-22Z3-23Z1-24Z1-25Z1-26Z1-27Z1-28Z1-29Z1-30Z1-31Z1-34Z1-35Z1-36Z1-37Z1-38Z1-39Z1-'}
    #            # WPU  :  {'CALLBACK': <function trace2kernel4wpu at 0x00000000056AAAC8>, 'ACK2RETURN': ' ', 'NACK2RETURN': ' 21Z1-22Z2-22Z3-23Z1-24Z1-25Z1-26Z1-27Z1-28Z1-29Z1-30Z1-31Z1-34Z1-35Z1-36Z1-37Z1-38Z1-39Z1-'}
    #            # XPU  :  {'CALLBACK': <function trace2kernel4xpu at 0x0000000005628348>, 'ACK2RETURN': ' ', 'NACK2RETURN': ' 21Z1-22Z2-22Z3-23Z1-24Z1-25Z1-26Z1-27Z1-28Z1-29Z1-30Z1-31Z1-34Z1-35Z1-36Z1-37Z1-38Z1-39Z1-'}
    #            # YPU  :  {'CALLBACK': <function trace2kernel4ypu at 0x00000000057572C8>, 'ACK2RETURN': ' ', 'NACK2RETURN': ' 21Z1-22Z2-22Z3-23Z1-24Z1-25Z1-26Z1-27Z1-28Z1-29Z1-30Z1-31Z1-34Z1-35Z1-36Z1-37Z1-38Z1-39Z1-'}
    #            # ZPU  :  {'CALLBACK': <function trace2kernel4zpu at 0x0000000005854A48>, 'ACK2RETURN': ' ', 'NACK2RETURN': ' 21Z1-22Z2-22Z3-23Z1-24Z1-25Z1-26Z1-27Z1-28Z1-29Z1-30Z1-31Z1-34Z1-35Z1-36Z1-37Z1-38Z1-39Z1-'}
    #                          
    #    except:
    #        print('(Step 124Z/700) OF KERNEL4XI5TEST *** FAILED TO SET KERNEL CALLBACK WITH METHOD ***', time4xi())    
    # 
    #">
    
    # ---------------------------------------------------------------------------------------------   
    def set2kernelcallback(self, task4set2kernelcallback = None): 
        '''
        set2kernelcallback of Kernel4Xi objects
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "Kernel4Xi"
        method2print = "set2kernelcallback"
                     
        message2print = "{(Step 1A/33) started" + "; set2kernelcallback-of-Kernel4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 
            
        message2print = "{(Step 1B/33) passed" + "; task4set2kernelcallback-passed-to-set2kernelcallback-of-Kernel4Xi: " + str(task4set2kernelcallback) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # None    
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2A/33) passing" + "; task4set2kernelcallback-passing-to-set2kernelcallback -by-set2kernelcallback-of-Kernel4Xi: " + str(task4set2kernelcallback) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                               
        # 
        
        callback2xi4kernel = {} 
        try:
            callback2xi4kernel = set2kernelcallback4xi (task4set2kernelcallback)

            message2print = "{(Step 2B/33) callback2xi4kernel" + "; callback2xi4kernel-set-by-set2kernelcallback-of-Kernel4Xi to: " + str(callback2xi4kernel) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)             
            # 
        except:
            message2print = "{(Step 4A/33) failed" + "; callback2xi4kernel-failed-by-set2kernelcallback-of-Kernel4Xi: " + str(callback2xi4kernel) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
                                            
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)           
        # ----------------------------------------------------------------------------------------- 
       
        message2print = "{(Step 3A/33) returning" + "; callback2xi4kernel-returning-by-set2kernelcallback-of-Kernel4Xi: " + str(callback2xi4kernel) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
        # 
                                             
        return callback2xi4kernel
                                                           
    #</methodize4xi>     
    
                                                              
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "sense-of-Kernel4Xi" usage = "
    #
    #    print('(Step 170A/700) OF KERNEL4XI5TEST - SENSING ', time4xi())  
    #    # 
    #    try:
    # 
    #         response4sense = p2xi.sense()
    #         
    #         print(response4sense)
    #         # {'classvariable2xi-of-Kernel4Xi': 4, 'object': <kernel4xi.Kernel4Xi object at 0x0000000006018278>}         
    # 
    #     except:
    #         print('(Step 170Z/700) OF KERNEL4XI5TEST *** FAILED TO SENSE ', time4xi())      
    #  
    # ">
    
    # ---------------------------------------------------------------------------------------------
    def sense(self):
        '''
        method sense: senses Kernel4Xi class objects
        '''
        
        # -----------------------------------------------------------------------------------------
        #
        # ----------------------------------------------------------------------------------------- 
        class2print = 'Kernel4Xi'
        method2print = 'sense'
        
                     
        message2print = "{(Step 1A/33) started" + "; sense-of-Kernel4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------  
        
        message2print = "{(Step 2A/33) sensing" + "; Kernel4Xi-sensing-by-sense-of-Kernel4Xi: " + str(Kernel4Xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)         
        #         
        
        # -----------------------------------------------------------------------------------------
        # get sensed knowledge for this object
        # -----------------------------------------------------------------------------------------        
        
        kb2xi = sense_object4xi(self)
        
        message2print = "{(Step 3A/33) got" + "; kb2xi-got-by-sense-of-Kernel4Xi: " + str(kb2xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 
        
        # -----------------------------------------------------------------------------------------
        # add knowledge specific to this object
        # format example: kb2xi['time2xi'] = time4xi() #adding time 
        # -----------------------------------------------------------------------------------------         
        try:
            kb2xi['classvariable2xi-of-Kernel4Xi'] = Kernel4Xi.classvariable2xi
        except:
            message2print = "{(Step 4A/33) yielded" + "; kb2xi-yielded-by-sense-of-Kernel4Xi: " + str(kb2xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            
      
        message2print = "{(Step 5A/33) sensed" + "; Kernel4Xi-sensed-by-sense-of-Kernel4Xi: " + str(Kernel4Xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)    
        # 
        
        # -----------------------------------------------------------------------------------------
        # 
        # -----------------------------------------------------------------------------------------         
        
        message2print = "{(Step 6A/33) returning" + "; kb2xi-returning-by-sense-of-Kernel4Xi: " + str(kb2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)                                                          
        #             
          
        return kb2xi
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------        
    #</methodize4xi>
    
        
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "reason-of-Kernel4Xi" usage = "
    # 
    #    print('(Step 171A/700) OF KERNEL4XI5TEST - REASONING ', time4xi())  
    #    # 
    #    try:
    #                
    #        response4reason = p2xi.reason()
    #        
    #        print(response4reason)
    #        # {'object-reason-object4xi': <kernel4xi.Kernel4Xi object at 0x0000000006018278>, 'time-reason-of-Kernel4Xi': '09:46:11 11/05/11 Pacific Daylight Time'}         
    # 
    #     except:
    #         print('(Step 171Z/700) OF KERNEL4XI5TEST *** FAILED TO REASON ', time4xi())  
    # 
    #">
    
    # ---------------------------------------------------------------------------------------------
    def reason(self):
        '''
        method reason: reasons Kernel4Xi class objects
        '''
        
        # -----------------------------------------------------------------------------------------
        #
        # ----------------------------------------------------------------------------------------- 
        class2print = 'Kernel4Xi'
        method2print = 'reason'

                     
        message2print = "{(Step 1A/33) started" + "; reason-of-Kernel4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------
        
        message2print = "{(Step 2A/33) reasoning" + "; Kernel4Xi-reasoning-by-reason-of-Kernel4Xi: " + str(Kernel4Xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # 
        
        # -----------------------------------------------------------------------------------------
        # get reasoned knowledge for this object
        # -----------------------------------------------------------------------------------------         
        
        kb4xi = reason_object4xi(self)
        
        
        message2print = "{(Step 3A/33) got" + "; kb4xi-got-by-reason-of-Kernel4Xi: " + str(kb4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        #   
        
        # -----------------------------------------------------------------------------------------
        # add knowledge specific to this object
        # format example: kb4xi['time2xi'] = time4xi() #adding time 
        # -----------------------------------------------------------------------------------------          
        try:
            kb4xi['time-reason-of-Kernel4Xi'] = time4xi() #adding time
        except:
            message2print = "{(Step 4Z/33) yielded" + "; kb4xi-yielded-by-reason-of-Kernel4Xi: " + str(kb4xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
        
          
        
        message2print = "{(Step 5A/33) reasoned" + "; Kernel4Xi-reasoned-by-reason-of-Kernel4Xi: " + str(Kernel4Xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
        # 
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------        
        
        message2print = "{(Step 6A/33) returning" + "; kb4xi-returning-by-reason-of-Kernel4Xi: " + str(kb4xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)                                                          
        #            
          
        return kb4xi
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------            
    #</methodize4xi>
    
    
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "ace-of-Kernel4Xi" usage = "
    # 
    #    print('(Step 172A/700) OF KERNEL4XI5TEST - ACING ', time4xi())  
    #    # 
    #    try:
    # 
    #         response4ace = p2xi.ace()
    # 
    #         print(response4ace)
    #         # {'cores-of-Kernel4Xi': 4, 'object8xi': <kernel4xi.Kernel4Xi object at 0x0000000006018278>}         
    # 
    #     except:
    #         print('(Step 172Z/700) OF KERNEL4XI5TEST *** FAILED TO ACE ', time4xi())                                     
    #    
    #">
    
    # ---------------------------------------------------------------------------------------------
    def ace(self):
        '''
        method ace: aces Kernel4Xi class objects 
        '''
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------       
        
        
        class2print = 'Kernel4Xi'
        method2print = 'ace'
        
                     
        message2print = "{(Step 1A/33) started" + "; ace-of-Kernel4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        #  
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------
        
        message2print = "{(Step 2A/33) acing" + "; Kernel4Xi-acing-by-ace-of-Kernel4Xi: " + str(Kernel4Xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)         
        #         
        
        # -----------------------------------------------------------------------------------------
        # get aced knowledge for this object
        # -----------------------------------------------------------------------------------------        
        
        kb8xi = ace_object4xi(self)  
        
        message2print = "{(Step 3A/33) got" + "; kb8xi-got-by-ace-of-Kernel4Xi: " + str(kb8xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 


        # -----------------------------------------------------------------------------------------
        # add knowledge specific to this object
        # format example: kb8xi['time2xi'] = time4xi() #adding time 
        # -----------------------------------------------------------------------------------------              
        try:
             kb8xi['cores-of-Kernel4Xi'] = Kernel4Xi.classvariable2xi
        except:
             message2print = "{(Step 4A/33) yielded" + "; kb8xi-yielded-by-ace-of-Kernel4Xi: " + str(kb8xi)  + "; time: " + time4xi() + "}"
             print4xi(class2print, method2print, message2print) 
  
        message2print = "{(Step 5A/33) aced" + "; Kernel4Xi-aced-by-ace-of-Kernel4Xi: " + str(Kernel4Xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)         
        # 
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------        
        message2print = "{(Step 6A/33) returning" + "; kb8xi-returning-by-ace-of-Kernel4Xi: " + str(kb8xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
        return kb8xi
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------            
    #</methodize4xi>
#</class4xi>
#</program4xi>


# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   kernel4xi5test.txt
#   sense-kernel4xi5test.xml
#   reason-kernel4xi5test.xml
#   ace-kernel4xi5test.xml
#"
#>

#<acknowledge4xi acknowledgement = "33" tester = "Small & Smart"/>


# -------------------------------------------------------------------------------------------------
# to-be-done                              
# -------------------------------------------------------------------------------------------------    
#<do4xi do = "
# None
#"
#/>

#<note4xi note = "
# parse4xi.py - to parse this module
# "/>

# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of kernel4xi.py                              
# ------------------------------------------------------------------------------------------------- 
#"
#/>
